
#include  <stdio.h>

#define   ERROR           -1
#define   MAXCHA         600           // Maximum number of channels, components
#define   MAXPAR          10           // Maximum number of parameter sets
#define   MAXSMP       15000
#define   MAXDLY        3600           // Maximum number of seconds delay trigger buffer
#define   RTBUFSIZ      5000           // Buffersize in READ_PACKETS

int       MINUT_NOW     = 18;          // Current time is set at this minute in delay buffer
int       DELAY_BUFFER  = 20;          // Size of delay buffer in minutes
int       SECONDS2SHUFLE=  4;          // Number of seconds to shufle the delay buffer
int       DET_DELAY     =  7;          // time delay where to start detection
int       APW           = 120;         // Array propagation window in seconds

float     FL_PRESET     = 2.0;         // DEFAULT LOW-PASS FREQUENCY
float     FH_PRESET     = 8.0;         // DEFAULT HIGH-PASS FREQUENCY
int       DCWINDOW      = 1000;        // Length of window in samples do average for DC
int       VENT          = 100;         // Number of blocks to wait for STA LTA to stabelize

typedef   struct  {

/*--------------------------------------------------------------------------*/
/*           DATA-STRUCTURE FOR PARAMETER-MODULE                            */
/*--------------------------------------------------------------------------*/
float  csta[MAXPAR][MAXCHA];               // STA for klon n and channel m
float  clta[MAXPAR][MAXCHA];               // LTA for klon n and channel m
float  cnoi[MAXPAR][MAXCHA];               // noise level for klon n and channel m
float  cdcavg[MAXPAR][MAXCHA];             // DC average for klon n and station number m
int    dur[MAXPAR][MAXCHA];                // duration trigger klon n and station m
float  coda[MAXPAR][MAXCHA];               // lta at trigger-point
double tt[MAXPAR][MAXCHA];                 // MSECS for klon n and channel m
char   ttdly[MAXPAR][MAXCHA][MAXDLY];      // trigger delay buffer
int    age[MAXPAR][MAXCHA][5];             // array propagation window klon n + channel m
double latency[MAXPAR][MAXCHA];            // latency for klon n and channel m
char   rtid[MAXPAR][MAXCHA][80];           // timestring miniseed buffer klon n + channel m
int    val20[MAXPAR];                      // no_to_plot for klon n
char   stasjon[MAXPAR][MAXCHA][10];
char   trig_stations[MAXPAR][MAXCHA][80];
int    receiving[MAXPAR][MAXCHA];
} rtmod;


