#pragma ident "$Id: list.h,v 1.2 2004/06/25 18:34:56 dechavez Exp $"
#ifndef list_include_defined
#define list_include_defined

/* platform specific stuff */

#include "platform.h"

#ifdef __cplusplus
extern "C" {
#endif

/* datatypes */

typedef struct list_node {
    struct list_node *prev;
    struct list_node *next;
    UINT32 length;
    void *payload;
    void *parent;
} LIST_NODE;

typedef struct {
    LIST_NODE head;
    LIST_NODE tail;
    UINT32 count;
    VOID **array;
    BOOL FreeMe;
} LIST;

/* Function prototypes */

/* list.c */
BOOL listInit(LIST *lp);
LIST *listCreate(VOID);
LIST_NODE *listFirstNode(LIST *lp);
LIST_NODE *listLastNode(LIST *lp);
LIST_NODE *listNextNode(LIST_NODE *crnt);
LIST_NODE *listPrevNode(LIST_NODE *crnt);
LIST_NODE *listInsertAfter(LIST_NODE *crnt, VOID *payload, UINT32 length);
LIST_NODE *listInsertBefore(LIST_NODE *crnt, VOID *payload, UINT32 length);
BOOL listAppend(LIST *lp, VOID *payload, UINT32 length);
VOID listDestroy(LIST *lp);
BOOL listSetArrayView(LIST *lp);
VOID listDump(FILE *fp, LIST *list);

/* version.c */
char *listVersionString(VOID);
VERSION *listVersion(VOID);

#ifdef __cplusplus
}
#endif

#endif

/* Revision History
 *
 * $Log: list.h,v $
 * Revision 1.2  2004/06/25 18:34:56  dechavez
 * C++ compatibility
 *
 * Revision 1.1  2003/10/16 18:35:09  dechavez
 * initial release
 *
 */
