
/* file CPAR.H
 *      ======
 *
 * version 3, 6-Feb-2001
 *
 * include file of module CPAR.C
 * K. Stammler, 9-May-92
 */


/* global constants */
#define PAC_MAXPAR 20
	/* maximum number of parameters */
#define PAC_MAXQUAL 20
	/* maximum number of qualifers */


/*--------------------------------------------------------------------*/


void pa_init( int argc, char *argv[] );

/* intializes pa-variables.  Determines number of parameters and
 * number of qualifers
 *
 * parameters of routine
 * int        argc;       input; number of items (quals and pars)
 * char       *argv[];    input; argument string
 */


/*--------------------------------------------------------------------*/


int pa_pnumber( void );

/* returns number of parameters
 *
 * no parameters
 */


/*--------------------------------------------------------------------*/


int pa_qnumber( void );

/* returns number of qualifiers
 *
 * no parameters
 */


/*--------------------------------------------------------------------*/


char *pa_pvalue( int number );

/* returns value of parameter number "number"
 *
 * parameters of routine
 * int        number;    number of parameter
 */


/*--------------------------------------------------------------------*/


BOOLEAN pa_qspecified( char name[] );

/* checks whether a particular qualifier is specified in the command
 * line
 *
 * parameter of the routine
 * char      name[];      input; name of the qualifier
 *                        returns TRUE if the qualifier was specified
 */


/*--------------------------------------------------------------------*/


char *pa_qvalue( char name[] );

/* returns value of a particular qualifier
 *
 * parameter of the routine
 * char      name[];      input; name of the qualifier
 *                        returns TRUE if the qualifier was specified
 */


/*--------------------------------------------------------------------*/


int pa_qunchecked( char first[] );

/* returns the number of unchecked qualifers.  If the number is
 * greater than zero, "first" contains the first unchecked qualifier
 *
 * parameters of routine
 * char       first[];    output; first unchecked qualifier
 *                        returns number of unchecked qualifiers
 */


/*--------------------------------------------------------------------*/


char *pa_progname( void );

/* returns name of program without path
 *
 * no parameters
 */


/*--------------------------------------------------------------------*/
