
/* file calibloc.h
 *      ==========
 *
 * version 4, 25-May-94
 *
 * header file of module calibloc.c
 * K. Stammler, 23-Sep-93
 */



/* error cods */
#define CALE_OFFSET           4900
#define CALE_STROVFL          (CALE_OFFSET+1)    /* string overflow */
#define CALE_OPENREAD         (CALE_OFFSET+2)    /* error opening input file */
#define CALE_NOCALIBFILE      (CALE_OFFSET+3)    /* no calibration file found */
#define CALE_READLOOKUP       (CALE_OFFSET+4)    /* error reading lookup file */
#define CALE_READCALIB        (CALE_OFFSET+5)    /* error reading calib file */
#define CALE_EMPTYCAL         (CALE_OFFSET+6)    /* empty calibration file */


/* prototypes of module */

/*----------------------------------------------------------------------------*/


void cal_initialize( Widget parent, Widget calwdw, STATUS *status );

/* initializes calibration window
 *
 * parameters of routine
 * Widget     parent;      input; widget ID of root window
 * Widget     calwdw;      input; Widget ID of calibration window
 * STATUS     *status;     output; return status
 */


/*----------------------------------------------------------------------------*/



void cal_display_calib( Widget w, CUT_PARAMS *par, STATUS *status );

/* displays calibration vectors for within a
 * window centered on given slowness and azimuth.  The analysis parameters
 * are copied to a local data structure.
 *
 * parameters of routine
 * Widget     w;           input; widget ID of calibration window
 * CUT_PARAMS *par;        input; analysis parameters
 * STATUS     *status;     output; return status
 */


/*----------------------------------------------------------------------------*/


void cal_handle_xevent( Widget w, XEvent *ev );

/* handles events of calibration window
 *
 * parameters of routine
 * Widget     w;         input; widget ID of calibration window
 * XEvent     *ev;       input; event happened
 */


/*----------------------------------------------------------------------------*/



void cal_accept_values( Widget w, CUT_PARAMS *par );

/* puts corrected values of slowness and azimuth as well as location
 * parameters to passed structure and
 * terminates calibration window.
 *
 * parameters of routine
 * Widget     w;          input; widget ID of calibration window
 * CUT_PARAMS *par;       output; analysis parameters
 */


/*----------------------------------------------------------------------------*/
