
/* file polarfil.h
 *      ==========
 *
 * version 2, 2-Nov-2005
 *
 * Header file for module polarfil.c
 * K. Stammler, 29-Oct-2005
 */



/* constants */
#define POL_ID_COHLTH 1
#define POL_ID_POW_LINFIL 2



/*----------------------------------------------------------------------------*/


void pol_initialize( Widget parent, Widget pmwdw, TSyStatus *status );

/* initializes polarisation filter window
 *
 * parameters of routine
 * Widget     parent;      input; widget ID of root window
 * Widget     pmwdw;       input; Widget ID of polarisation filter window
 * TSyStatus  *status;     output; return status
 */


/*----------------------------------------------------------------------------*/


void pol_close_window( void );

/* Closes polarisation filter window
 *
 * parameters of routine
 * none
 */


/*----------------------------------------------------------------------------*/


void pol_draw_poltraces( float defzoom, TSyStatus *status );

/* Draws polarisation filtered traces into separate window
 *
 * parameters of routine
 * float      defzoom;        input; default zoom value for display
 * TSyStatus  *status;        output; return status
 */


/*----------------------------------------------------------------------------*/


void pol_incpar( int parid, int inc );

/* increments parameter
 *
 * parameter of routine
 * int       parid;      input; parameter ID
 * int       inc;        input; increment value
 */


/*----------------------------------------------------------------------------*/
