
/* file RFUSRDEF.H
 *      ==========
 *
 * version 3, 26-Jan-94
 *
 * prototypes of module RECFILTR.C
 * K. Stammler, 22-MAY-91
 */


#ifndef __RFUSRDEF
#define __RFUSRDEF

#ifndef __SHCONST
#include "shconst.h"
#endif

typedef struct {
	BOOLEAN     use_lpc;          /* use lin pred coding */
	int         pred_length;      /* prediction length in samples */
	int         pred_order;       /* prediction order */
	int         src_length;       /* length of source array */
	BOOLEAN     demean;           /* remove mean value on each stage */
} RFT_STARTUP;

#define RFC_MAXFILTER 8
	/* maximum number of filters */

/*------------------------------------------------------------------------*/


void rf_filter_input( int list_lth, char *flt_list[], int pos_list[],
	int *status );

/* reads one or more filters into memory
 *
 * paramters of routine
 * int       list_lth;       input; number of filters to read
 * char      *flt_list[];    input; list of filter names
 * int       pos_list[];     input; positions of filters in files
 * int       *status;        output; return status
 */


/*------------------------------------------------------------------------*/


void rf_filter( SAMPLE src[], long trclth, REAL dt, RFT_STARTUP *lpc,
	SAMPLE dst[], STATUS *status );

/* filters the seismogram "src" from index "start" to index "end"
 * with all the filters in rfv_fct.  The result is returned in "dst"
 *
 * parameters of routine
 * SAMPLE     src[];     input; input signal to be filtered
 * long       trclth;    input length of trace in samples
 * REAL       dt;        input; sample distance in sec
 * RFT_STARTUP *lpc;     input; use special startup routine
 * SAMPLE     dst[];     output; output signal
 * STATUS     *status;   output; return status
 */


/*------------------------------------------------------------------------*/

#endif /* __RFUSRDEF */
