
/* file ev2telex.c
 *      ==========
 *
 * version 5, 14-Oct-96
 *
 * reformats event to telex format
 * K. Stammler, 28-Jul-93
 */



#include <stdio.h>
#include <string.h>
#include "basecnst.h"
#include "sysbase.h"
#include "eventdsc.h"
#include "evtelex.h"
#include "cpar.h"



int main( int argc, char *argv[] )
{
	/* local variables */
	char      infile[BC_FILELTH+1];    /* input file */
	char      outfile[BC_FILELTH+1];   /* output file */
	char      header[BC_LINELTH+1];    /* header line */
	char      station[BC_LINELTH+1];   /* station name */
	EvStatusT status;                  /* return status */
	BOOLEAN   ignoreflag=FALSE;        /* ignore telex flag */

	/* executable code */

	pa_init( argc, argv );
	if  (pa_pnumber() != 4)  {
		fprintf( stderr, "Usage: %s <input> <output> <header> <station>\n",
			pa_progname() );
		fprintf( stderr, "    Options:    -ignoreflag    ignores telex flag\n" );
		return 1;
	} /*endif*/

	/* get parameters */
	strcpy( infile, pa_pvalue(1) );
	strcpy( outfile, pa_pvalue(2) );
	strcpy( header, pa_pvalue(3) );
	strcpy( station, pa_pvalue(4) );
	ignoreflag = pa_qspecified( "-ignoreflag" );

	if  (ignoreflag)  EfSetIgnoreTelexFlag( TRUE );
	EfSetTelexHeader( header );
	EfSetTelexStation( station );
	status = EveNOERROR;
	EvReformatEventfile( infile, outfile, EvGetEvent,
		EfPutTelex, &status );

#	ifndef BC_VAX
	return 0;
#	endif

} /* end of main */
