
/* file evhypo.h
 *      ========
 *
 * version 3, 15-Oct-93
 *
 * header file of module evhypo.c
 * K. Stammler, 8-Sep-93
 */


/*-------------------------------------------------------------------*/


void EfPutHypo( FILE *hypo, EvEventT *event, EvStatusT *status );

/* Prints event "event" in HYPOELLIPSE format to file "hypo".  This
 * routine may be used as a "put_routine" in "EvReformatEvenfile".
 *
 * parameters of routine
 * FILE       *hypo;          input; output file
 * EvEventT   *event;         input; event information
 * EvStatusT  *status;        output; return status
 */


/*-------------------------------------------------------------------*/


void EfSetHypoDepth( BOOLEAN fixed, float depth );

/* Sets fixed or free depth for instruction record.  "depth" is valid
 * only if "fixed" is TRUE.
 *
 * parameters of routine
 * BOOLEAN    fixed;        input; fixed depth if TRUE
 * float      depth;        input value of fixed depth in km
 */


/*-------------------------------------------------------------------*/


void EfSetHypoUseS( BOOLEAN use );

/* Enables/disables usage of S waves for location
 *
 * parameters of routine
 * BOOLEAN    use;        input; if TRUE, S waves are use
 */


/*-------------------------------------------------------------------*/
