#!/bin/sh

# TO BE HARD-WIRED
seiscomp_root=$HOME/seiscomp

what='autopick'
regx='('"$what"'_main)'
prog="$what"_main.py

msg () {
	echo "`LC_ALL=C date +'%Y/%m/%d %H:%M:%S'` $0: $1"
}

running () {
	# we are now in the application directory

	test -s .pid || return 1	    # no .pid file found

	if      ps ww `cat .pid` |
                grep python |
                grep -E "$regx" >/dev/null 2>&1
        then
		true
        else
		# this message is issued here because it's an
		# unexpected situation to have a .pid file and no
		# program running
		msg "$what not running"
		msg "removing stale .pid file"
		rm -f .pid
		false
        fi
}


d=$seiscomp_root/$what
cd $d || exit 1

c_ini=config/config.ini
t_ini=config/trigger.ini

if	running
then
	msg "$what is already running"
	exit 0
fi

msg "starting $what"

export PATH=$d/bin:$PATH
export PYTHONPATH=$seiscomp_root/lib/python
export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$seiscomp_root/lib

nohup 2>detec.log \
    python bin/$prog -c $c_ini -t $t_ini > triggers.txt &

pid=$!
echo $pid > .pid

exit 0
