from Numeric import array

class TabFile(dict):

    types = {}
#   types = { 'x':int, 'y':float } # example

    def __init__(self, f=None):
#       for col in self.types:
#           self[col] = None            # initialize all columns
        if f: self.parse(f)

    def __getattr__(self, attrname):
        if attrname in self.keys():
            return self[attrname]
        raise AttributeError, attrname

    def parse(self, f):
	import re
	rx = re.compile(" *(#.*|\n)") # regex to match comment and blank lines
        if type(f) is list:
            lines = f
        else:
            if type(f) is str:
                f = file(f)
            if type(f) is file:
                lines = f.readlines()
            else: raise TypeError, "cannot read from '%s'" % str(type(f))
        
	lines = [ x.split() for x in lines if not rx.match(x) ]
	header = map(lambda x: x.lower(), lines[0])

	for col in header:
            self[col] = []

	for line in lines[1:]:
	    if len(line) < len(header):
		raise '%s: too few columns' % line
	    for val, col in zip(line, header):
		self[col].append(val)

        for col in self:
            if self[col] and col in self.types.keys():
                self[col] = array(map(self.types[col], self[col]))
#       else: error?
