from Numeric import array, log10

def bmagn(amp, per, dist):

    # Distance correction for mb (after D. Seidl) 
    sigma = array([0.,
                   5.9, 5.9, 5.9, 6.0, 6.0, 6.1, 6.2, 6.3, 6.3, 6.5, 6.4,
                   6.5, 6.6, 6.6, 6.6, 6.7, 6.7, 6.7, 6.7, 6.7, 6.6, 6.5,
                   6.5, 6.4, 6.4, 6.5, 6.5, 6.5, 6.5, 6.7, 6.8, 6.9, 6.9,
                   6.8, 6.7, 6.7, 6.7, 6.7, 6.8, 6.8, 6.8, 6.8, 6.8, 6.8,
                   6.8, 6.6, 7.0, 6.9, 7.0, 7.0, 7.0, 7.0, 7.0, 7.0, 6.9,
                   6.9, 6.9, 6.9, 6.8, 6.8, 6.9, 6.9, 6.9, 6.8, 6.7, 6.8,
                   6.9, 7.0, 7.0, 7.0, 6.9, 6.9, 7.1, 7.0, 7.0, 7.1, 7.1,
                   7.2, 7.1, 7.2, 7.3, 7.4, 7.5, 7.5, 7.4, 7.3, 7.4, 7.5,
                   7.6, 7.7, 7.8, 7.9, 7.9, 8.0, 8.1, 8.2, 8.2, 8.4, 8.6,
                   8.7, 8.8, 8.9, 9.0, 9.0, 9.0])
    if amp <= 0. or per <= 0.:
        raise ValueError
    istat = 0
    idist = int(dist+0.5)
    if idist < 16:
        istat=1
        idist=16
    elif idist > 105:
        istat=2
        idist=105
    # a=a/1000. (nm/s -> mym/s) /2*pi (mym/s -> mym at 1 Hz)
    # bmagn=alog10(amp/6283.)+sigma(idist-15)
    # a=a/1000. (nm -> mym)
    if istat == 0:
        return log10(amp/(1000.*per)) + sigma[idist-15]
#   return 0.

def lmagn(amp, dist):
#
#   Determines ML from get_amp amplitudes
#
#   Distance correction for ML (after C.F.RICHTER (1958): Elementary
#   Seismologie. p 342, up to 600 km epicenter distance; and after G.SCHNEIDER
#   (1975): Erdbeben. p 338, for 700-1000 km focal distance).
#

    sigml = array([0.,
                   1.4,1.4,1.5,1.6,1.7,1.9,2.1,2.3,2.4,2.5,2.6,2.7,2.8,2.8,2.8,2.8,2.9,2.9,3.0,3.0,3.0,3.1,3.1,3.2,3.2,3.3,3.3,3.4,3.4,3.5,3.5,3.6,3.65,3.7,3.7,3.8,3.8,3.9,3.9,4.0,4.0,4.1,4.1,4.2,4.2,4.3,4.3,4.3,4.4,4.4,4.5,4.5,4.5,4.6,4.6,4.6,4.6,4.7,4.7,4.7,4.7,4.8,4.8,4.8,4.8,4.8,4.9,4.9,4.9,4.9,4.9,5.2,5.4,5.5,5.7])

    istat = 0

    if amp <= 0.:
        raise ValueError

    kdist = dist*111.18

#   ml not defined for dist .gt. 1000 km
    if kdist > 1000:
        raise ValueError
#   from 600-1000 km: steps with 100 km
    if kdist > 600:
        _del = 100.
        iadd = 65
#   from 100-600 km: steps with 10 km
    else:
        if kdist > 100:
            _del = 10.
            iadd = 11
#   from 0-100 km: steps with 5 km
        else:
            _del = 5.
            iadd = 1

    idist = int(kdist/_del) + iadd
    tanalpha = (sigml[idist+1] - sigml[idist])/_del
    ixx = int(kdist/_del)
    xx = kdist-float(ixx)*_del
    sm10 = xx*tanalpha + sigml[idist]
    return log10(amp) + sm10
