#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <stdarg.h>

#define MAXCHA 300
char *topdir_rt = 0;                   // top directory RTQUAKE

/*----------------------------------------------------------------*/
/* Read input streams                                             */
/*----------------------------------------------------------------*/
read_profil( const char * streamfile,char streams[MAXCHA][100],char store[MAXCHA][100],int trgmin[],float lpf[],float hpf[],float staw[],float ltaw[],float trg[],float dtrg[],char slserv[MAXCHA][100])
{
  FILE *streamfp;
  char linje[200];
  char filnam1[200];
  int i,l,n,no;

/* Open the profil file */
  if ((streamfp = fopen (streamfile, "rb")) == NULL)
  {
    printf("rtprof: %s does not exist.\n",streamfile);
    exit(0);
  }
   no = 0;
  while ( (fgets (linje, sizeof(linje), streamfp)) !=  NULL)
  {
//    printf("rtprof: %3d %s",no,linje);
    sscanf(linje,"%s %s %d %f %f %f %f %f %f %s",streams[no],store[no],&trgmin[no],&lpf[no],&hpf[no],&staw[no],&ltaw[no],&trg[no],&dtrg[no],slserv[no]);
    no++;
  }

  printf("rtprof: Profile contains %d parametersets.\n",no); 
  if ( fclose (streamfp) )
  {
      printf ("rtprof: Closing stream list file\n");
    return -1;
  }
return(no);

}
/*----------------------------------------------------------------*/
/* Read parameter file                                            */
/*----------------------------------------------------------------*/
read_par_file( const char * streamfile)
{
  FILE *streamfp;
  char linje[200];
  char filnam1[200];
  int i,l,n,no;

/* Open the parameter file */
  if ((streamfp = fopen (streamfile, "rb")) == NULL)
  {
    printf("rtprof: %s does not exist.\n",streamfile);
    exit(0);
  }
   no = 0;
  while ( (fgets (linje, sizeof(linje), streamfp)) !=  NULL)
  {
    printf("%3d %s",no,linje);
//    sscanf(linje,"%s %s %s %s",streams[no],stations[no],store[no],slserv[no]);
    no++;
  }

  printf("\nProfile contains %d lines.\n",no); 
  if ( fclose (streamfp) )
  {
      printf ("rtdet: read_inputstreams: Closing stream list file\n");
    return -1;
  }
return(no);

}
int main(int argc, char **argv)
{
  char streamsfull[255];
  char streams[MAXCHA][100];
  int  trgmin[100];
  float lpf[100];
  float hpf[100];
  float staw[100];
  float ltaw[100];
  float trg[100];
  float dtrg[100];
  char slserv[MAXCHA][100];
  char store[MAXCHA][100];
  char profile[20];  
  int nc;
  int p;
  
  if(argc == 2)
  {
//------------------------------------------------------------------------
// set path to RTQUAKE_TOP as default
//------------------------------------------------------------------------
    topdir_rt = (char*)getenv("RTQUAKE_TOP");
    if (topdir_rt)
    {
      printf("RTDET: RTQUAKE_TOP: %s\n", topdir_rt);
    }else{
      printf("RTDET: RTQUAKE_TOP not defined\n");
      printf("Include setup_rt.bash or setup_rt.csh in your .bashrc or .csh\n");
      exit(0);      
    }
    sprintf(profile,"%s",argv[1]);
    sprintf(streamsfull,"%s/par/%s/profile",topdir_rt,argv[1]);  
    nc =read_profil(streamsfull,streams,store,trgmin,lpf,hpf,staw,ltaw,trg,dtrg,slserv); 
    for(p=0;p<nc;p++)
      printf("%s %s %2d %5.2f %5.2f %5.2f %5.2f %5.2f %5.2f %s\n",streams[p],store[p],trgmin[p],lpf[p],hpf[p],staw[p],ltaw[p],trg[p],dtrg[p],slserv[p]);
    for(p=0;p<nc;p++)
    {
      printf("Seedlink server address: %s Min. number of triggers: %2d\n",slserv[p],trgmin[p]);
      sprintf(streamsfull,"%s/par/%s/%s",topdir_rt,profile,streams[p]);
      read_par_file(streamsfull);
       }
    for(p=0;p<nc;p++)
    {
      printf("Recording file:\n");
      sprintf(streamsfull,"%s/par/%s/%s",topdir_rt,profile,store[p]);
      read_par_file(streamsfull);    
    }
  }else{
    printf("***********************************\n");
    printf("Give file-name of profile to check.\n");
    printf("***********************************\n");    
  }
 
}
