/***************************************************************************
 *   Copyright (C) 2009 by seismo   *
 *   seismo@tuspring.geo.uib.no   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdlib.h>
#include "gdfontl.h"
#include "gdfontg.h"
#include "gdfonts.h"
#include "gd.h"
#include <stdio.h>
#include <string.h>
#include <math.h>
//#include <io.h>
#include <fcntl.h>
#define PACKAGE "rtdrum"
#define VERSION LIBSLINK_VERSION
#define nch 600
//http://www.boutell.com/gd/manual2.0.33.html
//http://www.libgd.org/Reference
//gcc simplegd.c -lgd -o simplegd
void exit();

static int parameter_proc (int argcount, char **argvec);
static char *getoptval (int argcount, char **argvec, int argopt);
static void usage (void);

char wdir[256];
char wfiltdir[256];

char *topdir_rt   = 0;                 // top directory RTQUAKE
char *logol       = 0;                 // name of left logo gif file
char *logor       = 0;                 // name of right logo jpg file
char *wwwdir      = 0;                 // directory unfiltered heli plots
char *wwwfiltdir  = 0;                 // directory filtered heli plots
char *datafile    = 0;                 // datafile for helicorder plot
char *staname     = 0;

float gain        = 0.003;             // default gain factor
int upd           = 120;               // default update factor
int comp          = 0;                 // switch to decide if station has been selected
int tot_wd        = 1500;              // total width of image in pixels
int tot_hg;                            // total height of image in pixels
int frame_wd      = 800;               // signal frame width in pixels
int frame_hg      = 620;              // signal frame height in pixels
int minutes       = 60;
int     to_wi = 1000;
int     fr_hg = 600;
int     mt    = 15;
int     col   = 0;
int frame_origo_x;                     // upper left corner signal frame
int frame_origo_y;                     // upper left corner signal frame
int left_margin;                       // left margin signal frame
int right_margin;                      // right margin signal frame
int top_margin;                        // top margin signal frame
char toplot[nch][80];
int filter = 0;
int printarg=0;
int     no_to_plot;
int main(int argc, char **argv)
{
  FILE *out;                           // output plot file
  FILE *in1;                           // input datafile
  FILE *in;                            // input file GIF logo
  
  long   yrn;
  long   mon;
  long   day;
  long   hrn;
  long   min;

  int   iyrn;
  int   imon;
  int   iday;
  int   ihrn;
  int   imin;

  int    mins;
  float  sek;
  int DDAY,MMTH;
  double MSECS;
  int DY;
  int YR;
  char dum[50];
  char line[200];
  char stat[15];
  char filnavn[256];
  char station_name[256];
  int  id;
  char dd[3];
  int  blk;
  int  rt1;

  char ctim[256];
  int  smp;
  int lines;
  int rest;
  int i,l,k;

  int ix;
  int dc_cnt;
  int ix_old,ix_new,iy_old,iy_new;
  float idx;
  float incr;
  int ne;
  int ret;
  int ssrate;
  int line_seq;
  int line_nr_hel;
  float scale;

  float line_nr;
  int avstand;
  float fem_minut;
  float fem;
  float ti_sekund;
  float ti;
  int antall;
  int old_line;
  float timer;
  float minutter;
  float sec_of_day;
  float sec_on_line;
  char time1[10];
  char time2[10];
  char fullpath[100];
  char pngfile[100];
  char pngfilecpy[100];
  char pngfilenew[100];
  char syscmd[200];

  char ext[80];
  int buf[1000];
  int samples[1000];
  float samp[1000];
  int dctemp[5000];
  float sum;
  int multiply;
  int dc;
  
  int switch1;
  float max;

  gdImagePtr im;                                 // Declare the image
  gdImagePtr im_in;                              // Declare the logo image
  gdImagePtr im_in2;                             // Declare the logo image

  int cnt5 = 0;
  int bg,sg1,sg2,sg3,sg4,tl,tt,tk,t5;
  int white, black, green, red, blue,gray;       // Declare color indexes
  logol      = "logo_left_def.gif";                  // logo UIB
  logor      = "logo_right_def.jpg";                 // logo IPOC (for test run)

  left_margin   = 60;
  top_margin    = 75;
  right_margin  = 130;
   //------------------------------------------------------------------------
// set path to RTQUAKE_TOP as default
//------------------------------------------------------------------------
  topdir_rt = (char*)getenv("RTQUAKE_TOP");
  if (topdir_rt)
  {
    printf("RTDRUM: RTQUAKE_TOP: %s\n", topdir_rt);
  }else{
    printf("RTDRUM: RTQUAKE_TOP not defined\n");
    printf("Include setup_rt.bash or setup_rt.csh in your .bashrc or .csh\n");
    exit(0);      
  } 
  sprintf(wdir,"%s/rt/png",topdir_rt);
  wwwdir=wdir;
  sprintf(wfiltdir,"%s/rt/png_filt",topdir_rt);
  wwwfiltdir=wfiltdir; 
//-------------------------------------------------------------------------
// Process command line parameters
//-------------------------------------------------------------------------
  if (parameter_proc (argc, argv) < 0)
  {
    fprintf(stderr, "Parameter processing failed\n\n");
    fprintf(stderr, "Try '-h' for detailed help\n");
    return -1;
  }
  if(comp == 0)
  {
    printf("You MUST specify a component. f.ex. -comp ASK__00EHZ\n");
    exit(0);
  }

  pipe_tmp();
//  printf("no_to_plot: %d\n",no_to_plot);
  if(no_to_plot == 0)
  {
    if(filter == 0)
    {
      printf("No files in: %s ready for plotting.\n",wwwdir);
      exit(0);
    }else{
      printf("No files in: %s ready for plotting.\n",wwwfiltdir);
      exit(0);
    }
  }

  tot_wd = to_wi;
  frame_hg = fr_hg;
  minutes = mt;

if(tot_wd <= 500 || fr_hg <= 500)
{
  top_margin = 20;
  right_margin = 10;
}



  frame_origo_x = left_margin;
  frame_origo_y = top_margin;

  frame_wd = tot_wd - left_margin - right_margin;
  tot_hg = top_margin + frame_hg +30;



  im = gdImageCreate(tot_wd, tot_hg);            // Allocate the image: tot_wd pixels width by tot_hg pixels high
  
  switch(col)
  {
    case 0:
    bg  = gdImageColorAllocate(im, 255, 255, 255); // WHITE first color definition defines the background color
    tl  = gdImageColorAllocate(im, 200, 200, 200); // GRAY  color for timelines
    tk  = gdImageColorAllocate(im,   0,   0,   0); // BLACK color for text
    tt  = gdImageColorAllocate(im,   0,   0, 255); // BLUE color for title
    t5  = gdImageColorAllocate(im,   0,   0,   0); // BLACK color for 5 minute marks
    sg1 = gdImageColorAllocate(im, 255,   0,   0); // RED   color seismogram
    sg2 = gdImageColorAllocate(im,   0, 255,   0); // GREEN color seismogram
    sg3 = gdImageColorAllocate(im,   0,   0, 255); // BLUE color seismogram
    sg4 = gdImageColorAllocate(im,   0,   0,   0); // BLACK color seismogram
    break;

    case 1:
    bg  = gdImageColorAllocate(im, 255, 255, 255); // WHITE first color definition defines the background color
    tl  = gdImageColorAllocate(im, 200, 200, 200); // GRAY  color for timelines
    tk  = gdImageColorAllocate(im,   0,   0,   0); // BLACK color for text
    tt  = gdImageColorAllocate(im,   0,   0, 255); // BLUE color for title
    t5  = gdImageColorAllocate(im,   0,   0,   0); // BLACK color for 5 minute marks
    sg1 = gdImageColorAllocate(im,   0,   0,   0); // BLACK   color seismogram
    sg2 = gdImageColorAllocate(im,   0,   0,   0); // BLACK color seismogram
    sg3 = gdImageColorAllocate(im,   0,   0,   0); // BLACK color seismogram
    sg4 = gdImageColorAllocate(im,   0,   0,   0); // BLACK color seismogram
    break;

    case 2:
    bg  = gdImageColorAllocate(im,   0,   0,   0); // BLACK first color definition defines the background color
    tl  = gdImageColorAllocate(im, 100, 120, 100); // GRAY  color for timelines
    tk  = gdImageColorAllocate(im, 255, 255, 255); // WHITE color for text
    tt  = gdImageColorAllocate(im, 255, 165,   0); // ORANGE color for title
    t5  = gdImageColorAllocate(im, 255, 255, 255); // WHITE color for 5 minute marks
    sg1 = gdImageColorAllocate(im,   0, 255,   0); // GREEN color seismogram
    sg2 = gdImageColorAllocate(im,   0, 255,   0); // GREEN color seismogram
    sg3 = gdImageColorAllocate(im,   0, 255,   0); // GREEN color seismogram
    sg4 = gdImageColorAllocate(im,   0, 255,   0); // GREEN color seismogram
    break;

    case 3:
    bg  = gdImageColorAllocate(im,   0,   0,   0); // BLACK first color definition defines the background color
    tl  = gdImageColorAllocate(im,  50,  50,  50); // GRAY  color for timelines
    tk  = gdImageColorAllocate(im, 218, 165,  32); // WHITE color for text
    tt  = gdImageColorAllocate(im, 218, 165,  32); // ORANGE color for title
    t5  = gdImageColorAllocate(im, 255, 255, 255); // WHITE color for 5 minute marks
    sg1 = gdImageColorAllocate(im, 255, 215,   0); // GREEN color seismogram
    sg2 = gdImageColorAllocate(im, 255, 215,   0); // GREEN color seismogram
    sg3 = gdImageColorAllocate(im, 255, 215,   0); // GREEN color seismogram
    sg4 = gdImageColorAllocate(im, 255, 215,   0); // GREEN color seismogram
    break;

    case 4:
    bg  = gdImageColorAllocate(im, 176, 196, 222); // BLACK first color definition defines the background color
    tl  = gdImageColorAllocate(im, 175, 238, 238); // GRAY  color for timelines
    tk  = gdImageColorAllocate(im,  30, 144, 255); // WHITE color for text
    tt  = gdImageColorAllocate(im,  30, 144, 255); // ORANGE color for title
    t5  = gdImageColorAllocate(im,  70, 130, 180); // WHITE color for 5 minute marks
    sg1 = gdImageColorAllocate(im,   0,   0, 205); // GREEN color seismogram
    sg2 = gdImageColorAllocate(im,   0,   0, 205); // GREEN color seismogram
    sg3 = gdImageColorAllocate(im,   0,   0, 205); // GREEN color seismogram
    sg4 = gdImageColorAllocate(im,   0,   0, 205); // GREEN color seismogram
    break;

    case 5:
    bg  = gdImageColorAllocate(im,   0,   0,   0); // BLACK first color definition defines the background color
    tl  = gdImageColorAllocate(im, 100, 120, 100); // GRAY  color for timelines
    tk  = gdImageColorAllocate(im, 255, 255, 255); // WHITE color for text
    tt  = gdImageColorAllocate(im, 255, 165,   0); // ORANGE color for title
    t5  = gdImageColorAllocate(im, 255, 255, 255); // WHITE color for 5 minute marks
    sg1 = gdImageColorAllocate(im,   0, 255,   0); // GREEN color seismogram
    sg2 = gdImageColorAllocate(im, 255,   0,   0); // RED   color seismogram
    sg3 = gdImageColorAllocate(im,  14, 191, 233); // BLUE color seismogram
    sg4 = gdImageColorAllocate(im, 255, 255,   0); // YELLOW color seismogram
    break;
  }



  old_line = -1;

// draw square for helicorder plot

  gdImageLine(im, frame_origo_x, frame_origo_y, frame_origo_x + frame_wd, frame_origo_y, tl);
  gdImageLine(im, frame_origo_x + frame_wd, frame_origo_y, frame_origo_x + frame_wd, frame_origo_y + frame_hg, tl);
  gdImageLine(im, frame_origo_x + frame_wd, frame_origo_y + frame_hg, frame_origo_x, frame_origo_y + frame_hg, tl);
  gdImageLine(im, frame_origo_x, frame_origo_y + frame_hg, frame_origo_x, frame_origo_y, tl);

if(tot_wd > 500 || fr_hg > 500)
{
  sprintf(fullpath,"%s/par/%s",topdir_rt,logol);
//printf("FULLPATH: %s\n",fullpath);
  in = fopen(fullpath, "rb");
  if(in)
  {
    im_in = gdImageCreateFromGif(in);
    fclose(in);
    gdImageCopy(im, im_in, 0, 0, 0, 0, 70, 70);
//    gdImageCopy(im, im_in, 0, 0, 0, 0, 1088, 136);
    gdImageDestroy(im_in);
  }

  sprintf(fullpath,"%s/par/%s",topdir_rt,logor);
  in = fopen(fullpath, "rb");
  if(in)
  {
    im_in2 = gdImageCreateFromJpeg(in);
    fclose(in);
//    gdImageCopyResized(im, im_in2, 710, 0, 0, 0, 150, 65,550,235);
    gdImageCopyResized(im, im_in2, left_margin+frame_wd - 100, 0, 0, 0, 150, 65,im_in2->sx,im_in2->sy);
    gdImageDestroy(im_in2);
  }
}
//--------------------------------------------------------------------------------//
// draw timelines for helicorder plot. Every 5 minute with stronger color: t5     //
//--------------------------------------------------------------------------------//
  fem_minut = (float)frame_wd / (float)minutes;
  ti_sekund = (float)frame_wd / (6.0 * (float)minutes);
  fem = 0.0;
  for(l=0;l <= minutes;l++)
  {
    if(cnt5 ==0 || cnt5 == 5)
    {
      cnt5 = 0;
      gdImageLine(im, frame_origo_x + (int)fem, frame_origo_y, frame_origo_x + (int)fem, frame_origo_y + frame_hg, t5);
    }else{
      gdImageLine(im, frame_origo_x + (int)fem, frame_origo_y, frame_origo_x + (int)fem, frame_origo_y + frame_hg, tl);
    }
    fem = fem + fem_minut;
    cnt5++;
  }
//-----------------------------------------//
// draw hours, left & right margin         //
//-----------------------------------------//

  for(l=0;l<24;l++)
  {
    sprintf(time1,"%2d:00",l);
    if(l<10)
      time1[0]='0';
    switch(minutes)
    {
      case 15:
      sprintf(time2,"%2d:15",l);
      if(l<10)
        time2[0]='0';
      multiply = 4;
      break;
      case 30:
      sprintf(time2,"%2d:30",l);
      if(l<10)
        time2[0]='0';
      multiply = 2;
      break;
      case 60:
      sprintf(time2,"%2d:00",l+1);
      if(l<9)
        time2[0]='0';
      multiply = 1;

      break;
    }
    avstand = frame_hg/(25 * multiply);
    if(tot_wd > 500 || fr_hg > 500)
    {
      gdImageString(im,gdFontGetLarge(),10,l*avstand*multiply+top_margin+avstand/2,time1,tk);
    }else{
      gdImageString(im,gdFontGetLarge(),5,l*avstand*multiply+top_margin+avstand/2,time1,tk);
    }
if(tot_wd > 500 || fr_hg >500)
    gdImageString(im,gdFontGetLarge(),frame_origo_x + frame_wd+5,l*avstand*multiply+top_margin+avstand/2,time2,tk);
//printf("avstand: %10d %10d\n",avstand,l*avstand*multiply+top_margin+avstand/2);
  }
//----------------------------------//
// draw minute scale at bottom      //
//----------------------------------//

  ti = 0.0;
  for(l=0;l< (6 * minutes);l++)
  {
    gdImageLine(im, frame_origo_x + (int)ti, top_margin + frame_hg, frame_origo_x + (int)ti, top_margin + frame_hg + 6, tl);
    ti = ti + ti_sekund;
  }
  cnt5 = 0;
  fem = 0.0;
  for(l=0;l<(minutes+1);l++)
  {
    sprintf(time1,"%2d",l);
    if(l<10)
      time1[0]='0';
    if(tot_wd > 500 || fr_hg > 500)
    {
      gdImageString(im,gdFontGetLarge(),frame_origo_x - 5 + (int)fem,top_margin+frame_hg + 10,time1,tk);
      gdImageLine(im, frame_origo_x + (int)fem, top_margin + frame_hg, frame_origo_x + (int)fem, top_margin + frame_hg + 10, tk);
    }else{
      if(cnt5 == 0 || cnt5 == 5)
      {
        cnt5=0;
        gdImageString(im,gdFontGetLarge(),frame_origo_x - 8 + (int)fem,top_margin+frame_hg + 10,time1,tk);
        gdImageLine(im, frame_origo_x + (int)fem, top_margin + frame_hg, frame_origo_x + (int)fem, top_margin + frame_hg + 10, tk);
      }
    }
    fem = fem + fem_minut;
    cnt5++;
  }

  sprintf(fullpath,"%s",toplot[no_to_plot-1]);
//  printf("FULLPATH: %s\n",fullpath);
  for(i=0;i<80;i++)
  {
    if(fullpath[i]=='\0')
      break;
  }

  for(k=0;k<80;k++)
    ext[k]='\0';
  k=0;
  for(l=(i-13);l<i;l++)
  {
    ext[k]=fullpath[l];
    k++;
  }

  sprintf(filnavn,"%s%s",datafile,ext);
//  printf("%s\n",filnavn);
  filnavn[10] = ' ';
  filnavn[22] = filnavn[14];
  filnavn[21] = filnavn[13];
  filnavn[20] = filnavn[12];
  filnavn[19] = filnavn[11];
  filnavn[11] = filnavn[17];  
  filnavn[12] = filnavn[18];
  filnavn[13] = '/';
  filnavn[14] = filnavn[15];
  filnavn[15] = filnavn[16];
  filnavn[16] = '/';
  filnavn[17] = filnavn[19];
  filnavn[18] = filnavn[20];
  filnavn[19] = filnavn[21];
  filnavn[20] = filnavn[22];
  filnavn[21] = ' ';
  filnavn[22] = ' ';

//-------------------------------------------------//
// print filename and station name on top of plot  //
//-------------------------------------------------//
  if(tot_wd > 500 || fr_hg > 500)
  {  
    gdImageString(im,gdFontGetGiant(),150,35,filnavn,tt);
    sprintf(station_name,"%s",staname);
//    printf("station_name: %s\n",station_name);
    for(l=0;l<60;l++)
    {
      if(station_name[l]== '_')
	station_name[l]=' ';
    }
//    printf("station_name: %s\n",station_name);    
    gdImageString(im,gdFontGetGiant(),400,35,station_name,tt);
  }else{
    gdImageString(im,gdFontGetGiant(),5,5,filnavn,tt);
    sprintf(station_name,"%s",staname);
    for(l=0;l<50;l++)
    {
      if(station_name[l]== '_')
	station_name[l]=' ';
    }    
    gdImageString(im,gdFontGetGiant(),210,5,station_name,tt);
  }

  if(filter == 0)
  {
    sprintf(pngfile,"%s/%s%s.png",wwwdir,datafile,ext);
  }else{
    
    sprintf(pngfile,"%s/%s%s.png",wwwfiltdir,datafile,ext);
  }
//  printf("pngfile: %s\n",pngfile);

  if ((in1 = fopen (fullpath, "r")) == NULL)
  {
    printf("Can't open data file: %s\n", fullpath);
    exit(0);
  }

  switch1 = 0;



  ix=0;
  dc_cnt = 0;
  antall = 0;
//------------------------------------------//
// read data file                           //
//------------------------------------------//
  for(i=0;i<5000;i++)
    dctemp[i]=0;
  while(fread(&ne,4,1,in1) != 0)                                   // read number of samples
  {
//printf("NE: %5d\n",ne);
    ix = 0;
    ret=fread(&ssrate,4,1,in1);                                    // read samplerate

    incr= (float)frame_wd/((float)ssrate * 60.0 * (float)minutes);
    rt1=fread(ctim,22,1,in1);                                          // read time for this buffer
//    printf("ne: %4d sr: %4d incr: %5.4f ret: %d %s\n",ne,ssrate,incr,ret,ctim);

    sscanf(ctim,"%4d%1c%3d%1c%2d%1c%2d%1c%f7.4",&YR,dum,&DY,dum,&ihrn,dum,&imin,dum,&sek);
    hrn=ihrn;
    min=imin;

    DTE (DY,&DDAY,&MMTH,YR);
    yrn=YR;
    mon=MMTH;
    day=DDAY;
//      printf("TIME: %4d %2d %2d %2d %2d %4.1f\n",yrn,mon,day,hrn,min,sek);
    TIMSEC(yrn,mon,day,hrn,min,sek,&MSECS);
    mins=min;
//printf("mins: %d\n",mins);
    timer = (float)hrn;
    minutter = (float)mins;
//printf("timer %8.2f minutter %8.2f\n",timer,minutter);
//    sec_of_day = (float)hrn * 3600.0 + (float)min * 60.0 + sek;
    sec_of_day = timer * 3600.0 + minutter * 60.0 + sek;
//    printf("sec_of_day: %12.4f\n",sec_of_day);
    rt1=fread(&buf,4*ne,1,in1);            // read 'ne*4' bytes
    ix = ne;
    for(i=0;i<(5000-ne);i++)
      dctemp[i]=dctemp[i+ne];
    for(i=0;i<ne;i++)
      dctemp[5000-ne+i]=buf[i];
    antall = antall + ne;
    sum=0.0;                           // compute dc
    if(antall < 5000)
    {
      for(i=0;i<antall;i++)
	sum = sum+(float)dctemp[i];
//        sum = sum+(float)dctemp[1000-antall+i];
      sum=sum/antall;
      dc=(int)sum;
    }else{
      for(i=0;i<5000;i++)
        sum = sum+(float)dctemp[i];
      sum=sum/5000;
      dc=(int)sum;
    }
//    printf("Antall: %5d DC: %d\n",antall,dc);
    for(i=0;i<ix;i++)                  // scale data
      samp[i] = (float)(buf[i] -dc) * gain;

//printf("sec_of_day: %8.2f\n",sec_of_day);
    line_nr = sec_of_day / (60.0 * (float)minutes);     // which line to start plotting this buffer
    line_nr_hel = (int)line_nr;
//printf("line_nr_hel: %d line_nr: %f\n",line_nr_hel,line_nr);
//--------------------------------------------//
// print DC on the right of plot              //
//--------------------------------------------//
    if(line_nr_hel != old_line)
    {
      old_line = line_nr_hel;
      sprintf(time1,"%6d",(int)dc);
      gdImageString(im,gdFontGetSmall(),left_margin + frame_wd+60,avstand * (int)(line_nr)+ top_margin+avstand/2,time1,tk);
    }
    line_seq = line_nr_hel % 4;   // to decide sequence 1234,1234 etc for setting diferent colors
    sec_on_line = sec_of_day - (int)line_nr * 60.0 * (float)minutes; // which second on this line this buffer
    idx=(float)left_margin + incr * sec_on_line * (float)ssrate;
    ix_old=idx;
    iy_old=(int)samp[0]+avstand * (int)(line_nr)+top_margin+avstand/2 +7;
//    printf("IX: %d\n",ix);
    for(i=0;i<ix;i++)                  // plot this buffer
    {
      ix_new=(int)idx;
      iy_new=(int)samp[i]+avstand * (int)(line_nr)+top_margin+avstand/2 +7;
      switch(line_seq)
      {
        case 0:
        gdImageLine(im, ix_old, iy_old, ix_new, iy_new, sg1);  // draw from old to new point
        break;
        case 1:
        gdImageLine(im, ix_old, iy_old, ix_new, iy_new, sg2);    // draw from old to new point
        break;
        case 2:
        gdImageLine(im, ix_old, iy_old, ix_new, iy_new, sg3);  // draw from old to new point
        break;
        case 3:
        gdImageLine(im, ix_old, iy_old, ix_new, iy_new, sg4);   // draw from old to new point
        break;
      }
      ix_old=ix_new;
      iy_old=iy_new;
      idx=idx+incr;
      if((int)idx >= (frame_wd+left_margin)) // test if data from one buffer wraps to new 15-minute line
      {
        idx=left_margin;
        ix_old = left_margin;
        iy_old=(int)samp[0]+ avstand * (int)(line_nr)+top_margin+avstand/2 +7 ;
      }
    }
  }

printf("End of plot: %s\n",station_name);


  out = fopen (pngfile, "wb");
  gdImagePng (im, out);
  fclose (out);
  gdImageDestroy(im);                   /* Destroy the image in memory. */


  if(filter == 0)
  {
    sprintf(pngfilecpy,"%s/%s.prv",wwwdir,datafile);
    sprintf(pngfilenew,"%s/%s.new",wwwdir,datafile);
  }else{
    sprintf(pngfilecpy,"%s/%s.prv",wwwfiltdir,datafile);
    sprintf(pngfilenew,"%s/%s.new",wwwfiltdir,datafile);
  }
//  printf("pngfilecpy: %s\n",pngfilecpy);
  sprintf(syscmd,"cp %s %s",pngfile,pngfilenew);
  rt1=system(syscmd);  
//  printf("%s\n",syscmd);
  
  sprintf(syscmd,"cp %s %s",pngfile,pngfilecpy);
  rt1=system(syscmd);
//  printf("%s\n",syscmd);


//  sleep(upd);
//}

} 

//*=========================================================================      
//*                                                                               
//* Routine to convert from day-of-year to date                                   
//*                                                         Leif Kvamme 12-1-85   
DTE (DOY,DAY,MON,YR)                                          
int DOY;
int *DAY;
int *MON;
int YR;
{
int MTH[14],J,M,N;
for(J=1;J<8;J=J+2)
    MTH[J] = 31;
for(J=8;J<13;J=J+2)
    MTH[J] = 31;
MTH[2] = 28;
MTH[4] = 30;
MTH[6] = 30;
MTH[9] = 30;
MTH[11]= 30;
if ((YR%4) == 0) MTH[2] = 29;
M = 0;                                                                    
for(J=1;J<13;J++)
{
    M = M + MTH[J];
    N = DOY - M;                                                              
    if (N <= 0)
    {                                                       
        *MON = J;
        *DAY = N + MTH[J];                                                     
        goto four;                                                               
    }
}
four:                                                                   
J=0;
}
TIMSEC (YR,MTH,DAY,HR,MIN,SECS,MSECS)                         
int YR;
int MTH;
int DAY;
int HR;
int MIN;
float SECS;
double *MSECS;                         /* total seconds to be returned      */
{
int DYR;                               /* flag for leap year                */
int IYR;                               /* number of leap-years since 1900   */
int YDY;                               /* number of days in current year    */

if(YR <= 50) YR=YR+100;                /* check for 2000 or more in 2 digits*/

if(YR >= 1900) YR=YR - 1900;
DYR = 0;
if((YR % 4) == 0) DYR = 1;
IYR = YR/4 - DYR;
//                -- Seconds to beginning of     
*MSECS = (float)(IYR*366) + (float)((YR-IYR)*365);
//                -- current year                
*MSECS = *MSECS*86400.0;
//                -- January                     
if (MTH == 1) YDY = DAY;
//                -- February                    
if (MTH == 2) YDY = DAY + 31;
//                -- ....                        
if (MTH == 3) YDY = DAY + DYR + 59;       
if (MTH == 4) YDY = DAY + DYR + 90;                                     
if (MTH == 5) YDY = DAY + DYR + 120;                                    
if (MTH == 6) YDY = DAY + DYR + 151;                                    
if (MTH == 7) YDY = DAY + DYR + 181;                                    
if (MTH == 8) YDY = DAY + DYR + 212;                                    
if (MTH == 9) YDY = DAY + DYR + 243;                                    
if (MTH ==10) YDY = DAY + DYR + 273;                                    
if (MTH ==11) YDY = DAY + DYR + 304;                                    
if (MTH ==12) YDY = DAY + DYR + 334;                                    
*MSECS = *MSECS + (float)(YDY*86400 + HR*3600 + MIN*60) + SECS;
}
/***************************************************************************
 * parameter_proc:
 *
 * Process the command line parameters.
 *
 * Returns 0 on success, and -1 on failure
 ***************************************************************************/
static int
parameter_proc (int argcount, char **argvec)
{
  int optind;
  int error = 0;
  char tm[80];

  if (argcount <= 1)
    error++;

  /* Process all command line arguments */
  for (optind = 1; optind < argcount; optind++)
    {
      if (strcmp (argvec[optind], "-h") == 0)
	{
	  usage();
	  exit (0);
	}
      else if (strcmp (argvec[optind], "-top") == 0)
	{
	  topdir_rt = argvec[++optind];
	}
      else if (strcmp (argvec[optind], "-logol") == 0)
	{
	  logol = argvec[++optind];
	}
      else if (strcmp (argvec[optind], "-logor") == 0)
	{
	  logor = argvec[++optind];
	}
      else if (strcmp (argvec[optind], "-comp") == 0)
	{
          comp=1;
	  datafile = argvec[++optind];
//          printf("top directory: %s\n",topdir);
	}
      else if (strcmp (argvec[optind], "-name") == 0)
	{
	  staname = argvec[++optind];
	}
      else if (strcmp (argvec[optind], "-flt") == 0)
      {
          filter = 1;
      }

      else if (strcmp (argvec[optind], "-gain") == 0)
      {
        gain = atof(argvec[++optind]);
//        printf("gain: %f\n", gain);
//        exit(0);
      }
      else if (strcmp (argvec[optind], "-col") == 0)
      {
        col = atoi(argvec[++optind]);
      }
      else if (strcmp (argvec[optind], "-to_wi") == 0)
      {
        to_wi = atoi(argvec[++optind]);
      }
      else if (strcmp (argvec[optind], "-fr_hg") == 0)
      {
        fr_hg = atoi(argvec[++optind]);
      }
      else if (strcmp (argvec[optind], "-mt") == 0)
      {
        mt = atoi(argvec[++optind]);
      }
      else if (strcmp (argvec[optind], "-upd") == 0)
      {
        upd = atoi(argvec[++optind]);
//        printf("gain: %f\n", gain);
//        exit(0);
      }

      else if (strncmp (argvec[optind], "-", 1 ) == 0)
	{
	  fprintf(stderr, "Unknown option: %s\n", argvec[optind]);
	  exit (1);
	}
//      else if (!slconn->sladdr)
//	{
//	  slconn->sladdr = argvec[optind];
//printf("server: %s\n",argvec[optind]);
//  sprintf(ipaddress,argvec[optind]);
//	}
      else
	{
	  fprintf(stderr, "Unknown option: %s\n", argvec[optind]);
	  exit (1);
	}
    }

  /* Make sure a server was specified */
//  if ( ! slconn->sladdr )
//    {
//      fprintf(stderr, "No SeedLink server specified\n\n");
//      fprintf(stderr, "Usage: %s [options] [host][:port]\n", PACKAGE);
//      fprintf(stderr, "Try '-h' for detailed help\n");
//      exit (1);
//    }

  /* If errors then report the usage message and quit */
  if (error)
    {
      usage ();
      exit (1);
    }
  return 0;
}				/* End of parameter_proc() */

/***************************************************************************
 * getoptval:
 * Return the value to a command line option; checking that the value is 
 * itself not an option (starting with '-') and is not past the end of
 * the argument list.
 *
 * argcount: total arguments in argvec
 * argvec: argument list
 * argopt: index of option to process, value is expected to be at argopt+1
 *
 * Returns value on success and exits with error message on failure
 ***************************************************************************/
static char *
getoptval (int argcount, char **argvec, int argopt)
{
  if ( argvec == NULL || argvec[argopt] == NULL ) {
    fprintf (stderr, "getoptval(): NULL option requested\n");
    exit (1);
  }
  
  /* Special case of '-o -' usage */
  if ( (argopt+1) < argcount && strcmp (argvec[argopt], "-o") == 0 )
    if ( strcmp (argvec[argopt+1], "-") == 0 )
      return argvec[argopt+1];
  
  if ( (argopt+1) < argcount && *argvec[argopt+1] != '-' )
    return argvec[argopt+1];

  fprintf (stderr, "Option %s requires a value\n", argvec[argopt]);
  exit (1);
}  /* End of getoptval() */
/***************************************************************************
 * usage:
 * Print the usage message and exit.
 ***************************************************************************/
static void
usage (void)
{

  fprintf (stderr, "\nUsage: %s [options]\n\n", PACKAGE);
  fprintf (stderr,
	   "General program options:\n"
	   " -h             show this usage message\n"
           " -top           top directory (default: /home/seismo)\n"
           " -logo1         name of left-side logo (gif file)\n"
           " -logo2         name of right-side logo (jpg file)\n" 
           " -gain          gain factor signals. For example: 0.003\n"
           " -flt           will generate filtered helicorder plots\n"
           " -comp          filename component to plot, 10 char.(ex: ASK__00EHZ)\n"
           " -upd n         update plot every n seconds (default: 120=\n");
  
}				/* End of usage() */

pipe_tmp()
{
  FILE *fp;
  int status;
  char linje[200000];
  int i,l,no;
  char pip[80];
  if(filter ==0)
  {
    sprintf(pip,"ls %s/rt/tmp/%s*",topdir_rt,datafile);
//printf("pip: %s\n",pip);
  }else{
    sprintf(pip,"ls %s/rt/tmp_filt/%s*",topdir_rt,datafile);
  }
//printf("%s\n",pip);
  fp = popen(pip, "r");

  no = 200;
  for(i=0;i<no;i++)
  {
    if((fgets(linje, 200000, fp)) != NULL)
    {
      printf("%3d %s",i,linje);
      for(l=0;l<80;l++)
        toplot[i][l]='\0';
      sprintf(toplot[i],"%s",linje);
      for(l=0;l<80;l++)
        if(toplot[i][l]== 0xa) toplot[i][l]='\0';
    }else{
      break;
    }
  }
  status = pclose(fp); 
  printf("End of file. File contains: %2d items\n",i);
  no_to_plot = i;
}

