/***************************************************************************
 * rtdet
 * SeedLink client using libslink (Chad Trabant).
 *
 ***************************************************************************/
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <math.h>		                 // For math routines (such as sqrt & trig).
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include "gd.h"
#include <sh_mem_rt.h>
#include <libslink.h>
#include <signal.h>
#include <pthread.h>
#include <sys/shm.h>
#include <sys/timeb.h>
#include <sys/stat.h>
#include <dirent.h>

#define strcasecmp _stricmp
#define QUEUE 5                     // MAX NUMBER OF EVENTS IN QUEUE

/* prototype for thread routine */
void READ_PACKETS ( void *ptr );
static void design();
static void appl(int fnd);
static void STA_LTA();
static void ZERO_START(float scr[]);
static void MaxAmp(int no_of_smp,float scr[],float *MxAmp);
static void Scale_to_1(int no_of_smp,float scr[],float MxAmp);
static void STALTAPHFL(int ne, float kanal[],int ws,int wl,float rat[]);
static void TRIGGER_TIME_P(int ws,int pindex,int kanal,float sr,int sekunder);
static void TRIGGER_DUR(int sekunder,int kanal,int nn);
static void *CAT_DELAY(int maxdur);

static void CAT_MUL(void *ptr);

static int parameter_proc (int argcount, char **argvec);
static int packet_handler (char *msrecord, int packet_type,
			    int seqnum, int packet_size,SLCD * slconn);

/* struct to hold data to be passed to a thread
   this shows how multiple data items can be passed to a thread */
typedef struct str_thdata
{
    int thread_no;
    char ipaddr[100];
    char streams[100];
    char stations[100];
    int no_comp;

} thdata;

typedef struct str_trgmul
{
    int   thread_no;
    int   no_comp;
    int   antkan;
    int   fra;
    int   til;
    int   minimum_no_triggers;
} trgmul;


typedef struct str_catmul
{
    int   thread_no;
    int   maxdur;
    int   no_comp;
    int   antkan;
    int   fra;
    int   til;
} catmul;







rtmod *spt;                            // pointer shared memory
int totalchannels=0;
int    klon         = 0;
static short int verbose  = 0;
static short int ppackets = 0;
static char *dumpfile     = 0;	                 /* output file for data dump */
static char *location     = "1";                 // switch to read data for plotting
static FILE *outfile      = 0;                   /* the descriptor for the dumpfile */


int     LOCK=0;
/***************************************************************/
/* Mutex & Condition synchronizing start of threads from main  */
/***************************************************************/
int main_cnd=0;                    // condition variable for main
pthread_mutex_t cnd_mtx_main = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t  cnd_cnd_main  = PTHREAD_COND_INITIALIZER;
/***************************************************************/
/* Mutex & Condition synchronizing MEM_RNG and WRT_RNG         */
/***************************************************************/
int mem_wrt_rng_cnd[MAXCHA];
pthread_mutex_t cnd_mtx_MEM_WRT_RNG[MAXCHA];
pthread_cond_t  cnd_cnd_MEM_WRT_RNG[MAXCHA];
//------------------------------------------------------------------
// Mutex & Condition synchronizing of READ_PACKETS and BUFFER_SHUFLE
//------------------------------------------------------------------
pthread_mutex_t shufle_mutex;
pthread_cond_t signal_shufle; 
//------------------------------------------------------------------
// Mutex & Condition synchronizing of READ_PACKETS and BUFFER_SHUFLE
//------------------------------------------------------------------
pthread_mutex_t shift_mutex;
pthread_cond_t signal_shift; 


float LOW_PASS = 2.0;
float HIGH_PASS= 8.0;
float STAW     = 2.0;
float LTAW     = 100.0;
float TRGLEV   = 4.5;
float DTRGLEV  = 2.0;

int   swsl=0;
float   eqavst;
int     ssrate;

int  printarg = 1;

char *topdir_rt = 0;                   // top directory RTQUAKE
char  *topdir;                         // top directory SEISAN
char  cfgfile[80]   = "";              // configuration file 
char  streamfile[80]= "";              // stream list file to read from seedlink-server
char  detfile[80]   = "";              // components list file for detection 
char  streampath[80]= "";              // complete path for streamfile
char  recpath[80]   = "";              // complete path for recording file
char  detpath[80]   = "";              // complete path for detection file
char  recordfile[80]= "";              // station list for recording
char  trgdir[80]    = "";              // directory for triggers
int   autolocate   = 0;

int    kanaler_hver_stream[200];
int    kanaler_hver_record[200];
int    seismo[MAXCHA][2000];
int    ctrs[MAXCHA];
char   toplot[MAXCHA][200];
char   tmpfiles[MAXCHA][200];
char   staname[MAXCHA][200];
char   stnm[200];
float  ufilt;
float  filt;
float  unfiltered[MAXCHA];
float  filtered[MAXCHA];
char   fullna[MAXCHA][200];
float  flow;
float  fhigh;
float  tflow[MAXCHA];
float  tfhigh[MAXCHA];

char   allstreams[MAXCHA][200];
char   allslinks[MAXCHA][200];
int    stream_count = 0;
int    rec_count = 0;



static void DTE();
static void TIMSEC();

static int  unpack_samples();

int antall = 0;
char   tid[MAXCHA][200];

long   ryrn[MAXCHA];
long   rmon[MAXCHA];
long   rday[MAXCHA];
long   rhrn[MAXCHA];
long   rmin[MAXCHA];
int    time_quality[MAXCHA];
int    risec[MAXCHA];
float  rsek[MAXCHA];
int    rsecs[MAXCHA];
int    ryrn_int;
int    rmon_int;
int    rday_int;
int    rhrn_int;
int    rmin_int;
int    sr[MAXCHA];
char   rtid[MAXCHA][200];

int    sw2[MAXCHA];
int    sum[MAXCHA];
int    teller[MAXCHA];
int    avg[MAXCHA];
int only_one = 0;
int stno = 0;

int    ns[MAXCHA];

#ifndef abs
#define ABS(x) ((x)<0?-(x):(x))
#endif
#define TRUE 1
float   fl;
float   fh;
float   eqavst;
int     orden;
float  fl_par[MAXCHA];
float  fh_par[MAXCHA];
static  int nsects;

static  float sn[5*3+1],sd[5*3+1];
float   snc[MAXCHA][16];                            // filter coefficients
float   sdc[MAXCHA][16];                            // filter coefficients
int     cset[MAXCHA];
static  float save_y2[MAXCHA][16];                  // overlap between 2 filter buffers
static  float save_y1[MAXCHA][16];
static  float save_x2[MAXCHA][16];
static  float save_x1[MAXCHA][16];
static  float save_y2_pick[MAXCHA][16];                  // overlap between 2 filter buffers
static  float save_y1_pick[MAXCHA][16];
static  float save_x2_pick[MAXCHA][16];
static  float save_x1_pick[MAXCHA][16];
typedef struct {float r, i;} complex;

/* Table of constant values */
static  float c_b12 = 2.;
static  complex c_b43 = {1.,0.};




/* Local function prototypes */
static  double warp();
static  int chebparm(), lptbp(), lptbr(), lpthp(), bilin2(), lp();
static  int c1roots(), c2roots();
static  int cutoffs(), beroots();
static  complex cmul(), cpowi(), csqrt1(), conjg(), cdiv();

float  fseismo[MAXCHA][2000];
float  ftimea[MAXCHA];
double latency[MAXCHA];
float  ftemp[MAXCHA][5000];
float  sta_par[MAXCHA];
float  lta_par[MAXCHA];
char   params[MAXCHA][200];
float  dtrg_par[MAXCHA];

char   trig_stations[MAXCHA][200];
char   trig_components[MAXCHA][200];
float  trg_par[MAXCHA];
int    hold[MAXCHA];
float  rat[MAXCHA];
int    trig_flag[MAXCHA];
int    trig_dur[MAXCHA];
int    det_flg;
char   TRIGGER_TIMES[MAXCHA][200];
int    arrwnd= 100;
double TIME_NOW=0.0;
double trgdly[MAXCHA][MAXDLY];      // trigger delay buffer
int   SKIPPED[MAXCHA];
  int pk=0; 
int    mintrg=0;
int    DURTRG[MAXCHA];
double MINSTETID;
char MINTRGTID[200];
int    preevent=60;
int    postevent=60;

char  dbname[200]    = "";              // SEISAN database name
int  dbase_switch = 0;
char  trgpath[200]   = "";              // complete path for triggers
int    no_to_record;
char   record[MAXCHA][200];
char  sfilepath[200] = "";              // SEISAN S-file path
char SFILETOPICK[256];
char detection_file[200];
char   EVENTS_S[200];
double trg_tim[MAXCHA];             // MSECS for channel m


  float  values[MAXCHA][RTBUFSIZ];    // values per block per channel  
  float dc[MAXCHA];
  float  seis[RTBUFSIZ];
  int first[MAXCHA]; 
  int    ON_OFF[MAXCHA];
  int duration[MAXCHA];  
  float  ratios[RTBUFSIZ];
char streams[MAXCHA][100];
char stations[MAXCHA][100];
char slserv[MAXCHA][100];
char store[MAXCHA][100];
int  trgmin[100];
float lpf[100];
float hpf[100];
float staw[100];
float lta[100];
float trg[100];
float dtrg[100];

int fra[100];
int til[100];

int CAT_DEL_BUSY = 0;
  
/*----------------------------------------------------------------*/
/* Read recording file                                            */
/*----------------------------------------------------------------*/
read_recordfile ( const char * streamfile,int stream_count,int p)
{
  FILE *streamfp;
  char linje[100];
  int count = 0;
  int t;
  int s;
  int k;
  int r;
  int tel;
  int bryter;
  int ret;
  char rnam[20];
  char stnam[20];

/* Open the recording list file */

  if ((streamfp = fopen (streamfile, "rb")) == NULL)
  {
    printf("rtdet: read_recordfile Can't open recording_stream file: %s\n",streamfile);
    printf("rtdet: read_recordfile Check if file exists, or is wrong.\n");
    exit(0);
  }
  while ( (fgets (linje, sizeof(linje), streamfp)) !=  NULL)
  {
    sprintf(record[rec_count],"%s %s",linje,slserv[p]);
    for(r=0;r<20;r++)
    {
      if(record[rec_count][r] == 0xa)
        record[rec_count][r] = ' ';
    }
    count++;
    rec_count++;
  }
  kanaler_hver_record[p] = count;
  if ( fclose (streamfp) )
  {
    return -1;
  }
  no_to_record = rec_count;
} 

/*----------------------------------------------------------------*/
/* Read streams file                                              */
/*----------------------------------------------------------------*/
read_inputstreams( const char * streamfile,int p)
{
  FILE *streamfp;
  char linje[100];
  int count = 0;
  int s;

/* Open the streams file */
  if ((streamfp = fopen (streamfile, "rb")) == NULL)
  {
    printf("rtdet: read_inputstreams Can't open input stream file: %s\n",streamfile);
    printf("rtdet: read_inputstreams Check if file exists, or is wrong.\n");
    exit(0);
  }
  while ( (fgets (linje, sizeof(linje), streamfp)) !=  NULL)
  {
    for(s=0;s<20;s++)
    {
      if(linje[s] == 0xa)
        linje[s] = '\0';
    }
    sprintf(allstreams[stream_count],"%s %s",linje,slserv[p]);
    sprintf(allslinks[stream_count],"%s",slserv[p]);
    
    fl_par[stream_count]   = lpf[p];
    fh_par[stream_count]   = hpf[p];
    sta_par[stream_count]  = staw[p];
    lta_par[stream_count]  = lta[p];
    trg_par[stream_count]  = trg[p];
    dtrg_par[stream_count] = dtrg[p];    
    
//    printf("allstreams: %3d %s\n",stream_count,allstreams[stream_count]);
    stream_count++;
    count++;
  }
  kanaler_hver_stream[p]=count;
  if ( fclose (streamfp) )
  {
    return -1;
  }
}  

S_REC(year,month,day,hour,minute,seconds,dummy,fullpath,filename,nchannels,trgdur)
char year[];
char month[];
char day[];
char hour[];
char minute[];
char seconds[];
char dummy[];
char fullpath[];
char filename[];
int nchannels;
int trgdur[];
//int thr[];
//int tmn[];
//int tsc[];
//int tms[];
//int start_trg[];
{
FILE    *sf;
char buf[256];
char comp[200];
char dm1[200];
char dm2[200];
int hr1;
int mn1;
int sc1;
int ms1;

int i;
int ch; 
int cnt;
int YR,MTH,DAY,HR,MIN;
float SEC;
int AR;

//printf("SECONDS: %s\n",seconds);
sscanf(year,"%d",&YR);
//printf("%s %d\n",year,YR);
sscanf(month,"%d",&MTH);
//printf("%s %d\n",month,MTH);
sscanf(day,"%d",&DAY);
//printf("%s %d\n",day,DAY);
sscanf(hour,"%d",&HR);
//printf("%s %d\n",hour,HR);
sscanf(minute,"%d",&MIN);
//printf("%s %d\n",minute,MIN);
sscanf(seconds,"%f",&SEC);
//printf("%s %f\n",seconds,SEC);




sf=fopen(fullpath,"w");
if(sf == NULL)
{
  printf("rtdet: S_REC Can't open S-file: %s\n",fullpath);
  for(i=0;i<52;i++)
    printf("%2d %2x %c\n",i,fullpath[i],fullpath[i]);

  exit(0);
}else{
  for(i=0;i<100;i++)
  buf[i]=' ';
  printf("rtdet: S_REC  %4d %2d%2d %2d%2d %4.1f\n",YR,MTH,DAY,HR,MIN,SEC);
  sprintf(buf," %4d %2d%2d %2d%2d %4.1f",YR,MTH,DAY,HR,MIN,SEC);
  for(i=0;i<100;i++)
    if(buf[i]=='\0')buf[i]=' ';
  buf[21]='L';
  buf[22]='M';
  buf[45]='T';   // extract Agency from short network name
  buf[46]='S';
  buf[47]='T';
  buf[79]='1';
  buf[80]='\0';
  fprintf(sf,"%s\n",buf);

  for(i=0;i<100;i++)
    buf[i]=' ';
//printf("In S_REC: FILENAME: %s\n",filename);
  sprintf(buf," %s",filename);
  for(i=0;i<100;i++)
    if(buf[i]=='\0')buf[i]=' ';
  buf[79]='6';
  buf[80]='\0';
  fprintf(sf,"%s\n",buf);

  sprintf(dm1,"%4d",YR);
  sscanf(dm1,"%2c%d",dm2,&AR);

  for(i=0;i<100;i++)
    buf[i]=' ';
  sprintf(buf," ACTION:NEW %2d-%2d-%2d %2d:%2d OP:SEIS STATUS:               ID:%4d%2d%2d%2d%2d%2d",AR,MTH,DAY,HR,MIN,YR,MTH,DAY,HR,MIN,(int)SEC);

  if(buf[12]==' ')buf[12]='0';
  if(buf[15]==' ')buf[15]='0';
  if(buf[18]==' ')buf[18]='0';
  if(buf[21]==' ')buf[21]='0';
  if(buf[24]==' ')buf[24]='0';
  
  

  for(i=0;i<100;i++)
    if(buf[i]=='\0')buf[i]=' ';
  for(i=59;i<73;i++)
    if(buf[i]==' ')buf[i]='0';
  buf[79]='I';
  buf[80]='\0';
  fprintf(sf,"%s\n",buf);                 
  sprintf(buf," STAT SP IPHASW D HRMM SECON CODA AMPLIT PERI AZIMU VELO SNR AR TRES W  DIS CAZ7");
  fprintf(sf,"%s\n",buf);

// STAT SP IPHASW D HRMM SECON CODA AMPLIT PERI AZIMU VELO AIN AR TRES W
// BER  BZ IP       2223  6.00    4
  for(ch=0;ch<nchannels;ch++)
  {
    if(printarg > 0)
      printf("rtdet: S_REC %2d dur: %3d msec: %12.1f time: %s\n",ch,trgdur[ch],trg_tim[ch],TRIGGER_TIMES[ch]);
  }
  for(ch=0;ch<nchannels;ch++)
  {
    if(printarg > 0)
      printf("rtdet: S_REC %2d dur: %3d time: %s\n",ch,trgdur[ch],TRIGGER_TIMES[ch]);
  }
  for(ch=0;ch<nchannels;ch++)
  {
    if(trgdur[ch] != 0 && trg_tim[ch] != 0.0)
    {
      comp[0]=trig_components[ch][2];
      comp[1]=trig_components[ch][4];
      comp[2]='\0';

      cnt=0;
      for(i=0;i<6;i++)
      {
        if(trig_stations[ch][i] != '\0')
        {
          cnt++;
        }else{
          break;
        }
      }
      sscanf(TRIGGER_TIMES[ch],"%9c%2d",dm1,&hr1);
      sscanf(TRIGGER_TIMES[ch],"%12c%2d",dm1,&mn1);
      sscanf(TRIGGER_TIMES[ch],"%15c%2d",dm1,&sc1);
      sscanf(TRIGGER_TIMES[ch],"%18c%2d",dm1,&ms1);
      switch(cnt)
      {
        case 2:
        fprintf(sf," %s   %s IP    A  %2d%2d %2d.%2d %4d\n",trig_stations[ch],comp,hr1,mn1,sc1,ms1,trgdur[ch]);
        break;
        case 3:
        fprintf(sf," %s  %s IP    A  %2d%2d %2d.%2d %4d\n",trig_stations[ch],comp,hr1,mn1,sc1,ms1,trgdur[ch]);
        break;
        case 4:
        fprintf(sf," %s %s IP    A  %2d%2d %2d.%2d %4d\n",trig_stations[ch],comp,hr1,mn1,sc1,ms1,trgdur[ch]);
        break;
        case 5:
        fprintf(sf," %s%s IP    A  %2d%2d %2d.%2d %4d\n",trig_stations[ch],comp,hr1,mn1,sc1,ms1,trgdur[ch]);
        break;

        break;
      }
    }
  }

  fclose(sf);
  for(ch=0;ch < nchannels;ch++)
  {
    for(i=0;i<80;i++)
      TRIGGER_TIMES[ch][i]='\0';
  }

}
}


Create_Sfile(char tid[],char filename[],int nchannels,int trgdur[])
{
  int retur;
  int i;
  int ret;
  char fullpath[200];
  char syscmd[200];
  char comm1[200];
  char comm2[200];
  char comm4[200];
  char snam[200];
  char dummy[200];

  char year[5];
  char month[5];
  char day[5];
  char hour[5];
  char minute[5];
  char sec[5];
  
  int yr;
  int mn;
  int dy;
  int ho;
  int mi;
  int sc;

  char seconds[10];
  char tempo[80];

  for(i=0;i<200;i++)
  {
    snam[i]='\0';
    fullpath[i]='\0';
  }
//----------------------------------------
// make sfile name
//----------------------------------------
  if(printarg >= 1)
    printf("rtdet: Create_Sfile Time to make Sfile: %s\n",tid);
  for(i=0;i<23;i++)
    if(tid[i]==' ')tid[i]='0';

  sscanf(tid,"%6s%4s",dummy,year);
//printf("Year: %s\n",year);
  sscanf(tid,"%3s%2s",dummy,month);
//printf("Month:%s\n",month);
  sscanf(tid,"%2s",day);
//printf("Day:  %s\n",day);
  sscanf(tid,"%11s%2s",dummy,hour);
//printf("Hour; %s\n",hour);
  sscanf(tid,"%14s%2s",dummy,minute);
//printf("Minu: %s\n",minute);
  sscanf(tid,"%17s%2s",dummy,sec);
//printf("Sec:  %s\n",sec);
  sscanf(tid,"%17s%6s",dummy,seconds);

  sscanf(year,"%d",&yr);
  sscanf(month,"%d",&mn);
  sscanf(day,"%d",&dy);
  sscanf(hour,"%d",&ho);
  sscanf(minute,"%d",&mi);
  sscanf(sec,"%d",&sc);


  sprintf(snam,"%2s-%2s%2s-%2sL.S%4s%2s",
day,hour,minute,sec,year,month);
  for(i=0;i<19;i++)
    if(snam[i]==' ')snam[i]='0';
  printf("rtdet: Create_Sfile S-filename: %s\n",snam);

  sprintf(EVENTS_S,"%s/%s",sfilepath,dbname);
  sprintf(dummy,"%s/%s/%s",EVENTS_S,year,month);
  printf("rtdet: Create_Sfile DUMMY: %s\n",dummy);
  CreateDirectory(dummy);
//--------------------------------------------
// make full path for S-file
//--------------------------------------------
  sprintf(fullpath,"%s/%s",dummy,snam);
  retur=exists(fullpath);
  printf("RETUR: %d\n",retur);
  printf("rtdet: Create_Sfile FULLPATH: %s\n",fullpath);
  if(retur == 1)
  {
    printf("File exist, add 1 second and create new name.\n");
    sc = sc +1;
    if(sc > 59)
    {
      sc = 0;
      mi = mi +1;
      if(mi > 59)
      {
	mi = 0;
	ho = ho+1;
      }
    }
    sprintf(hour,"%2d",ho);
    sprintf(minute,"%2d",mi);
    sprintf(sec,"%2d",sc);
//    printf("%s  %s  %s\n",ho,mi,sc);
  sprintf(snam,"%2s-%2s%2s-%2sL.S%4s%2s",
day,hour,minute,sec,year,month);
  for(i=0;i<19;i++)
    if(snam[i]==' ')snam[i]='0';
  printf("rtdet: Create_Sfile S-filename: %s\n",snam);
  sprintf(fullpath,"%s/%s",dummy,snam);
  printf("rtdet: Create_Sfile FULLPATH: %s\n",fullpath);  
  }
  sprintf(SFILETOPICK,"%s",fullpath);

  
//  S_REC(year,month,day,hour,minute, seconds, dummy,fullpath,filename,nchannels,trgdur,thr,tmn,tsc,tms,start_trg);
  S_REC(year,month,day,hour,minute, seconds, dummy,fullpath,filename,nchannels,trgdur);

  sprintf(comm4,"cp %s hyp_save.out",fullpath);
  ret=system(comm4);                                     // copy sfile (no location) to "hyp_save.out" OK
  printf("rtdet: Create_Sfile comm4..................: %s\n",comm4);

}
int exists(const char *fname)
{
    FILE *file;
    if (file = fopen(fname, "r"))
    {
        fclose(file);
        return 1;
    }
    return 0;
}
//----------------------------------------------------------------------
// create directory given in 'buffer' if not present
//----------------------------------------------------------------------
CreateDirectory(char* buffer) 
{ 
  int ret;
  int i;
  int siz;
  char path2[80];
  char message[100];
  DIR  *dirp; 
  struct dirent *direntp; 

  siz=strlen(buffer);
  buffer[siz]='/';
  buffer[siz+1]='\0';
  for(i=0;i<siz+1;i++)
  {
    if(buffer[i]=='/' && i > 0)
    {
      strncpy(path2,buffer,i);
      path2[i]='\0';
      dirp = opendir(path2);              // check if dir exists 
      if(dirp == NULL) 
      { 
//--------------------log message-------------------------------
        sprintf(message,"%d %s does not exist. Create it !",klon,path2);
//        ErrMsg();
        ret=mkdir(path2,S_IRWXU | S_IRGRP | S_IXGRP | S_IROTH | S_IXOTH);
//        if(processor == 0)
//          changemod(path2);
//      }else{
//--------------------log message-------------------------------
//        sprintf(message,"CreateDirectory: '%s' exist.",buffer);
//        ErrMsg();
      } 
      closedir(dirp);
    }
  }
} 



/*----------------------------------------------------------------*/
/* Read detection file                                            */
/*----------------------------------------------------------------*/
read_detectionfile ( const char * streamfile)
{
  FILE *streamfp;
  char linje[200];
  char navn[200];
  char filnam1[200];
  int i,l,n,no;
  int br=0;
  char dum[20];
  char dum1[10];
  char dum2[10];
  char sta[10];
  char com[10];
//  int index = totalchannels;
  
/* Open the detection file */
  if ((streamfp = fopen (streamfile, "rb")) == NULL)
  {
    printf("read_detectionfile Can't open detection file: %s\n",streamfile);
    printf("read_detectionfile Check if file exist, or is wrong.\n");
    
    exit(0);
  }
  no = 0;
  while ( (fgets (linje, sizeof(linje), streamfp)) !=  NULL)
  {
    for(l=0;l<80;l++)
    {
      if(linje[l] == 0xa)
	linje[l] = '\0';
    }
      printf("%3d %s\n",no,linje);

    sprintf(params[totalchannels],"%s",linje);
    for(n=0;n<25;n++)
      navn[n]='\0';
    for(n=0;n<10;n++)
      navn[n]=linje[n];

    sprintf(toplot[totalchannels], "%s",navn);      
    sprintf(spt->trig_stations[klon][totalchannels],"%s",navn);  

//      printf("rtdet: tu_read_stationlist %3d %s  ",no,toplot[no]);

    sscanf(linje,"%10c %f %f %f %f %f %f",
dum,&fl_par[totalchannels],&fh_par[totalchannels],&sta_par[totalchannels],&lta_par[totalchannels],&trg_par[totalchannels],&dtrg_par[totalchannels]);
    for(l=0;l<10;l++)
    {
      dum1[l]='\0';
      dum2[l]='\0';
    }
    for(l=0;l<5;l++)
    {
      dum1[l]=linje[l];
      dum2[l]=linje[l+5];
    }
    sscanf(dum1,"%s",sta);
    sscanf(dum2,"%s",com);
    sscanf(dum1,"%s",trig_stations[totalchannels]);
    sscanf(dum2,"%s",trig_components[totalchannels]);

//    printf("rtdet: tu_read_stationlist STA: %s COM: %s  ",sta,com);
//    printf("fl: %6.2f %6.2f %5.1f %5.1f %5.1f %5.1f\n",
//fl_par[index],fh_par[index],sta_par[index],lta_par[index],trg_par[index],dtrg_par[index]);
    totalchannels++;
//    no++;
//    index++;
  }
  spt->val20[klon]=totalchannels;
//  if(printarg == 2)
  printf("read_detectionfile Number of components for detect: %3d items\n",totalchannels); 
  if ( fclose (streamfp) )
  {
      printf ("rtdet: tu_read_stationlist Closing stream list file\n");
    return -1;
  }
return(no);

}
/*----------------------------------------------------------------*/
/* Create detection tables                                        */
/*----------------------------------------------------------------*/
create_detectiontable()
{
  int k,n;
  char navn[50];
  char dum1[10];
  char dum2[10];
  
  for(k=0;k < stream_count; k++)
  {
    for(n=0;n<25;n++)
      navn[n]='\0';
    for(n=0;n<10;n++)
      navn[n]=allstreams[k][n+3];
    sprintf(toplot[k], "%s",navn);      
    sprintf(spt->trig_stations[klon][k],"%s",navn); 
//    fl_par[k]   = LOW_PASS;
//    fh_par[k]   = HIGH_PASS;
//    sta_par[k]  = STAW;
//    lta_par[k]  = LTAW;
//    trg_par[k]  = TRGLEV;
//    dtrg_par[k] = DTRGLEV;
    for(n=0;n<10;n++)
    {
      dum1[n]='\0';
      dum2[n]='\0';
    }
    for(n=0;n<5;n++)
    {
      dum1[n]=allstreams[k][n];
      dum2[n]=allstreams[k][n+5];
    }
//    sscanf(dum1,"%s",sta);
//    sscanf(dum2,"%s",com);
    sscanf(dum1,"%s",trig_stations[k]);
    sscanf(dum2,"%s",trig_components[k]);    
  }
}
/*----------------------------------------------------------------*/
/* Read config-file                                               */
/*----------------------------------------------------------------*/
read_configfile( const char * streamfile)
{
  FILE *streamfp;
  char linje[200];
  char navn[200];
  char filnam1[200];
  int i,l,n,no;
  int br=0;
  char dum[20];
  char dum1[10];
  char dum2[10];
  char sta[10];
  char com[10];
//  int index = totalchannels;
/* Open the detection file */
  if ((streamfp = fopen (streamfile, "rb")) == NULL)
  {
    printf("rtdet: read_configfile: Can't open config-file: %s\n",streamfile);
    printf("rtdet: read_configfile: Check if file exist, or is wrong.\n");
    
    exit(0);
  }
   no = 0;
  while ( (fgets (linje, sizeof(linje), streamfp)) !=  NULL)
  {
//      printf("rtdet: read_configfile: %3d %s\n",no,linje);
      sscanf(linje,"%s %s %d %f %f %f %f %f %f %s",streams[no],store[no],&trgmin[no],&lpf[no],&hpf[no],&staw[no],&lta[no],&trg[no],&dtrg[no],slserv[no]);      
      no++;
  }
//  printf("rtdet: read_configfile: Number of items: %3d items\n",no); 
  if ( fclose (streamfp) )
  {
      printf ("rtdet: read_configfile: Closing config file\n");
    return -1;
  }
return(no);

}
/*--------------------------------------------------------------------------*/
/* Compute STA and LTA and store max STA                                    */
/*--------------------------------------------------------------------------*/
void STA_LTA(float* sta1,float* lta1,float* lev1,float* stamax,int chan,int ns,int nsta,int nlta,int levn,int* ixmax)
{
  register    int ix;
  float       idx;                    /* Average difference in data value     */
                                      /* between 2 samples.                   */
  int no_sta = nsta;
  int no_lta = nlta;
  int no_lev = levn;
  float value;
/*----initialise max sta----*/

  *stamax=0.0;
  *ixmax=0;

  for(ix=0; ix<ns; ix++)
  {
    idx=(float)(fabs((double)(fseismo[chan][ix])));
//        idx=idx * idx;
/*--calculate sta and lta, and assign max if necessary--*/
    *sta1 += (idx - *sta1)/no_sta;
    *lta1 += (*sta1 - *lta1)/no_lta;

    *lev1 += (*sta1 - *lev1)/no_lta;

    if(*sta1 > *stamax)
    {
      *stamax = *sta1;
      *ixmax=ix;
    }
    if(*lta1 == 0.0)
      *lta1 = *sta1;
    if(*lev1 == 0.0)
      *lev1 = *sta1;
  }
} /* end of sta_lta procedure */
void CURRENT_TIME()
{
  char dummy[256];
  long   yrn;
  long   mon;
  long   day;
  long   hrn;
  long   min;
  long   doy;
  int   iyrn;
  int   imon;
  int   iday;
  int   ihrn;
  int   imin;
  int   isec;
  int   i,j;
  int   BUFSECS;
  float  sek;
  char dum[50];

  time_t now = time(NULL);
  struct tm *now_s = localtime(&now);
  sprintf(dummy,"%d-%02d-%02d_%02d:%02d:%02d", 1900+now_s->tm_year, ++now_s ->tm_mon,now_s->tm_mday, now_s->tm_hour, now_s->tm_min,now_s->tm_sec);
  sscanf(dummy,"%4d%1c%2d%1c%2d%1c%2d%1c%2d%1c%2d",&iyrn,dum,&imon,dum,&iday,dum,&ihrn,dum,&imin,dum,&isec);
  yrn=iyrn;
  yrn=yrn-2000;
  mon=imon;
  day=iday;
  hrn=ihrn;
  min=imin;
  mon=imon;
  sek=isec;

  TIMSEC(yrn,mon,day,hrn,min,sek,&TIME_NOW); 
}
void TRIGGER_TIME_P(int ws,int pindex,int kanal,float sr,int sekunder)
{
  int DDAY,MMTH;
  int DY;
  int YR;
  long   yrn;
  long   mon;
  long   day;
  long   hrn;
  long   min;
  long   doy;

  int   iyrn;
  int   imon;
  int   iday;
  int   ihrn;
  int   imin;

  float  sek;
  double MSECS;
  int   br=0;

  int   SECONDS_NOW;
  int   DELAY_INDX;

  int seconds_cpu;
  char tiden_cpu[80];
  char millis_cpu[4];
  long day_cpu;
  long mon_cpu;
  long yrn_cpu;
  long hrn_cpu;
  long min_cpu;
  float sek_cpu;
  char dm[10];
  double MSECS_CPU;
  double BUFFER_TIME_TRG;

  char   timestamp[80];
  char dum[50];
  int i,j,nn,nc;

  sscanf(rtid[kanal],"%4d%1c%3d%1c%2d%1c%2d%1c%f6.3",&YR,dum,&DY,dum,&ihrn,dum,&imin,dum,&sek);
  hrn=ihrn;
  min=imin;

  DTE (DY,&DDAY,&MMTH,YR);     //-- convert from doy to date  
  yrn=YR;
  yrn=yrn-2000;
  mon=MMTH;
  day=DDAY;

  iday=day;
  imon=mon;
  iyrn=yrn;
  ihrn=hrn;
  imin=min;

  TIMSEC(yrn,mon,day,hrn,min,sek,&MSECS);
  BUFFER_TIME_TRG = MSECS;
  MSECS=MSECS+(sr * pindex)-(sr * ws);
  SECTIM(MSECS,&yrn,&doy,&mon,&day,&hrn,&min,&sek);

  iday=day;
  imon=mon;
  iyrn=yrn;
  ihrn=hrn;
  imin=min;
  iyrn=iyrn-2000;

  sprintf(timestamp,"%2d/%2d/%2d %2d:%2d:%6.3f",iday,imon,iyrn,ihrn,imin,sek);
  if(timestamp[0] == ' ') timestamp[0] = '0';
  if(timestamp[3] == ' ') timestamp[3] = '0';
  if(timestamp[6] == ' ') timestamp[6] = '0';
  if(timestamp[9] == ' ') timestamp[9] = '0';
  if(timestamp[12] == ' ') timestamp[12] = '0';
  if(timestamp[15] == ' ') timestamp[15] = '0';
  if(timestamp[18] == ' ') timestamp[18] = '0';
  if(timestamp[19] == ' ') timestamp[19] = '0';
  if(timestamp[20] == ' ') timestamp[20] = '0';
  if(printarg == 2)
    printf("rtdet: TRIGGER_TIME %2d %s %s\n",klon,toplot[kanal],timestamp);
  sprintf(TRIGGER_TIMES[kanal],"%s",timestamp);

  spt->tt[klon][kanal]=MSECS;                      // save trigger time

  spt->age[klon][kanal][0] = arrwnd;
  spt->dur[klon][kanal] = 0;
  
  SECONDS_NOW = MINUT_NOW * 60;

  DELAY_INDX = SECONDS_NOW - (int)(TIME_NOW - BUFFER_TIME_TRG);
  printf("DELAY_INDX: %d\n",DELAY_INDX);
  
  if(DELAY_INDX >= 0 && DELAY_INDX <= (SECONDS_NOW + 60))
  {
    spt->ttdly[klon][kanal][SECONDS_NOW - (int)(TIME_NOW - BUFFER_TIME_TRG)] = 122;  
    trgdly[kanal][SECONDS_NOW - (int)(TIME_NOW - BUFFER_TIME_TRG)] = BUFFER_TIME_TRG;
//    printf("kanal: %2d\n",kanal);
    SKIPPED[kanal]=kanal;  
  }else{
    printf("DELAY_INDX outside buffer, trigger skipped. Channel: %d %s\n",kanal,toplot[kanal]);
    SKIPPED[kanal]=-1;
  }
}
void TRIGGER_DUR(int sekunder,int kanal,int nn)
{
  int DDAY,MMTH;
  int DY;
  int YR;
  long   yrn;
  long   mon;
  long   day;
  long   hrn;
  long   min;
  long   doy;

  int   iyrn;
  int   imon;
  int   iday;
  int   ihrn;
  int   imin;

  float  sek;
  double MSECS;
  double BUFFER_TIME_TRG;
  int   br=0;

  int   SECONDS_NOW;
  int   index;

  int seconds_cpu;
  char tiden_cpu[80];
  char millis_cpu[4];
  long day_cpu;
  long mon_cpu;
  long yrn_cpu;
  long hrn_cpu;
  long min_cpu;
  float sek_cpu;
  char dm[10];
  double MSECS_CPU;

  char   timestamp[80];
  char dum[50];
  int i,j,nc;

  sscanf(rtid[kanal],"%4d%1c%3d%1c%2d%1c%2d%1c%f6.3",&YR,dum,&DY,dum,&ihrn,dum,&imin,dum,&sek);
  hrn=ihrn;
  min=imin;

  DTE (DY,&DDAY,&MMTH,YR);     //-- convert from doy to date  
  yrn=YR;
  yrn=yrn-2000;
  mon=MMTH;
  day=DDAY;

  TIMSEC(yrn,mon,day,hrn,min,sek,&MSECS);
  BUFFER_TIME_TRG = MSECS;

  SECONDS_NOW = MINUT_NOW * 60;
if(SKIPPED[kanal] >= 0)
{
  spt->ttdly[klon][kanal][SECONDS_NOW - (int)(TIME_NOW - BUFFER_TIME_TRG)] = 111;  
  trgdly[kanal][SECONDS_NOW - (int)(TIME_NOW - BUFFER_TIME_TRG)] = 111;  
//  printf("duration index: %6d\n",SECONDS_NOW - (int)(TIME_NOW - BUFFER_TIME_TRG));
  for(i=1;i<600;i++)
  {
    index = SECONDS_NOW - (int)(TIME_NOW - BUFFER_TIME_TRG) - i;
    if(spt->ttdly[klon][kanal][index] < 122 && trgdly[kanal][index] < 10000)
    {
      spt->ttdly[klon][kanal][index] = 111;
      trgdly[kanal][index] = 111;
    }else{
      break;
  }
  }
}else{
 printf("channel %2d skipped\n",kanal); 
}
}
//-----------------------------------------------------
// find maximum amplitude channel ->MxAMP
//-----------------------------------------------------
void MaxAmp(int no_of_smp,float scr[],float *MxAmp)                 // Find max amplitude channel
{
  float max;
  int k;

  max=(float)0.0;
  for(k=0;k<no_of_smp;k++)
  {
    if(fabsf(scr[k])>max)
      max=fabsf(scr[k]);
  }
  *MxAmp=max;
//  printf("MxAmp: %8.3f\n",MxAmp);

  }
//-----------------------------------------------------
// scale seis->1.0
//-----------------------------------------------------
void Scale_to_1(int no_of_smp,float scr[],float MxAmp)             // Scale channel to max 1
{
  int k;

  for(k=0;k<no_of_smp;k++)
  {
    scr[k]=scr[k]/MxAmp;
  }

}



Read_Parameters()
{
  FILE *par;
  char  dummy[256];
  char  linjer[256];
  char  keyword[256];
  float val;
  int   k;
  int   br = 0;

  par = fopen("pic.def","r");
  if(par == NULL)
  {
    printf("rtdet: pic.def does not exist in current directory.\n");

    sprintf(dummy,"%s/com/pic.def",topdir_rt);
   
    printf("rtdet: Look in %s\n",dummy);    
    par = fopen(dummy,"r");
    if(par == NULL)
    {
      printf("rtdet: pic.def does not exist in %s/com. Use program defaults.\n",topdir_rt);
      br=1;      
    }
  }
  if(br == 0)
  {
    printf("rtdet: read pic.def\n");
    sprintf(keyword,"DELAY_BUFFER");
    while ( fgets ( linjer, sizeof linjer, par ) != NULL ) /* read a line from file */
    {
      if (strstr(linjer, keyword) )
      {
	printf("%s", linjer);
	sscanf(linjer,"%40c%f",dummy,&val);
//	printf("val: %5.1f\n",val);
	DELAY_BUFFER = (int)val;
        break;
      }
    }
    rewind(par);    
    sprintf(keyword,"SECONDS2SHUFLE");
    while ( fgets ( linjer, sizeof linjer, par ) != NULL ) /* read a line from file */
    {
  
      if (strstr(linjer, keyword) )
      {
	printf("%s", linjer);
	sscanf(linjer,"%40c%f",dummy,&val);
//        printf("val: %5.1f\n",val);
	SECONDS2SHUFLE = (int)val;
        break;
      }
    }   
    rewind(par);    
    sprintf(keyword,"MINUT_NOW");
    while ( fgets ( linjer, sizeof linjer, par ) != NULL ) /* read a line from file */
    {
  
      if (strstr(linjer, keyword) )
      {
	printf("%s", linjer);
	sscanf(linjer,"%40c%f",dummy,&val);
//        printf("val: %5.1f\n",val);
	MINUT_NOW = (int)val;
        break;
      }
    }
    
    rewind(par);    
    sprintf(keyword,"PRINTING");
    while ( fgets ( linjer, sizeof linjer, par ) != NULL ) // read a line from file 
    {
  
      if (strstr(linjer, keyword) )
      {
	printf("%s", linjer);
	sscanf(linjer,"%40c%f",dummy,&val);
//        printf("val: %5.1f\n",val);
//	prt = (int)val;	
        break;
      }
    }   
    rewind(par);
/*
    sprintf(keyword,"LOW_PASS");
    while ( fgets ( linjer, sizeof linjer, par ) != NULL ) // read a line from file 
    {
  
      if (strstr(linjer, keyword) )
      {
	printf("%s", linjer);
	sscanf(linjer,"%40c%f",dummy,&val);
//        printf("val: %5.1f\n",val);
	LOW_PASS = (int)val;	
        break;
      }
    }   
    rewind(par);
    
    sprintf(keyword,"HIGH_PASS");
    while ( fgets ( linjer, sizeof linjer, par ) != NULL ) // read a line from file 
    {
  
      if (strstr(linjer, keyword) )
      {
	printf("%s", linjer);
	sscanf(linjer,"%40c%f",dummy,&val);
//        printf("val: %5.1f\n",val);
	HIGH_PASS = (int)val;	
        break;
      }
    }   
    rewind(par);
    
    sprintf(keyword,"STAW");
    while ( fgets ( linjer, sizeof linjer, par ) != NULL ) // read a line from file 
    {
  
      if (strstr(linjer, keyword) )
      {
	printf("%s", linjer);
	sscanf(linjer,"%40c%f",dummy,&val);
//        printf("val: %5.1f\n",val);
	STAW = (int)val;	
        break;
      }
    }   
    rewind(par);
    
    sprintf(keyword,"LTAW");
    while ( fgets ( linjer, sizeof linjer, par ) != NULL ) // read a line from file 
    {
  
      if (strstr(linjer, keyword) )
      {
	printf("%s", linjer);
	sscanf(linjer,"%40c%f",dummy,&val);
//        printf("val: %5.1f\n",val);
	LTAW = (int)val;	
        break;
      }
    }   
    rewind(par);
    
     sprintf(keyword,"TRGLEV");
    while ( fgets ( linjer, sizeof linjer, par ) != NULL ) // read a line from file 
    {
  
      if (strstr(linjer, keyword) )
      {
	printf("%s", linjer);
	sscanf(linjer,"%40c%f",dummy,&val);
//        printf("val: %5.1f\n",val);
	TRGLEV = (int)val;	
        break;
      }
    }   
    rewind(par);

     sprintf(keyword,"DTRGLEV");
    while ( fgets ( linjer, sizeof linjer, par ) != NULL ) // read a line from file 
    {
  
      if (strstr(linjer, keyword) )
      {
	printf("%s", linjer);
	sscanf(linjer,"%40c%f",dummy,&val);
//        printf("val: %5.1f\n",val);
	DTRGLEV = (int)val;	
        break;
      }
    }   
    rewind(par);    
*/    
    sprintf(keyword,"DET_DELAY");
    while ( fgets ( linjer, sizeof linjer, par ) != NULL ) // read a line from file 
    {
  
      if (strstr(linjer, keyword) )
      {
	printf("%s", linjer);
	sscanf(linjer,"%40c%f",dummy,&val);
//        printf("val: %5.1f\n",val);
	DET_DELAY = val;
        break;
      }
    }
    rewind(par);    
    sprintf(keyword,"APW");
    while ( fgets ( linjer, sizeof linjer, par ) != NULL ) // read a line from file 
    {
  
      if (strstr(linjer, keyword) )
      {
	printf("%s", linjer);
	sscanf(linjer,"%40c%f",dummy,&val);
//        printf("val: %5.1f\n",val);
	APW = val;
        break;
      }
    }
/*    
    rewind(par);    
    sprintf(keyword,"MAIL1");
    while ( fgets ( linjer, sizeof linjer, par ) != NULL ) // read a line from file 
    {
  
      if (strstr(linjer, keyword) )
      {
	printf("%s", linjer);
	sscanf(linjer,"%19c%s",dummy,mailaddress1);
	sscanf(linjer,"%40c%f",dummy,&val);	
//        printf("val: %5.1f  %s\n",val,mailaddress1);
	mail1 = (int)val;	
        break;
      }
    }
    
    rewind(par);    
    sprintf(keyword,"MAIL2");
    while ( fgets ( linjer, sizeof linjer, par ) != NULL ) // read a line from file 
    {
  
      if (strstr(linjer, keyword) )
      {
	printf("%s", linjer);
	sscanf(linjer,"%19c%s",dummy,mailaddress2);
	sscanf(linjer,"%40c%f",dummy,&val);	
//        printf("val: %5.1f  %s\n",val,mailaddress1);
	mail2 = (int)val;	
        break;
      }
    }      
    rewind(par);    
    sprintf(keyword,"MAIL3");
    while ( fgets ( linjer, sizeof linjer, par ) != NULL ) // read a line from file 
    {
  
      if (strstr(linjer, keyword) )
      {
	printf("%s", linjer);
	sscanf(linjer,"%19c%s",dummy,mailaddress3);
	sscanf(linjer,"%40c%f",dummy,&val);	
//        printf("val: %5.1f  %s\n",val,mailaddress1);
	mail3 = (int)val;	
        break;
      }
    }      
    
    rewind(par);    
    sprintf(keyword,"MAIL4");
    while ( fgets ( linjer, sizeof linjer, par ) != NULL ) // read a line from file 
    {
  
      if (strstr(linjer, keyword) )
      {
	printf("%s", linjer);
	sscanf(linjer,"%19c%s",dummy,mailaddress4);
	sscanf(linjer,"%40c%f",dummy,&val);	
//        printf("val: %5.1f  %s\n",val,mailaddress1);
	mail4 = (int)val;	
        break;
      }
    }        
    
    rewind(par);    
    sprintf(keyword,"MAIL5");
    while ( fgets ( linjer, sizeof linjer, par ) != NULL ) // read a line from file 
    {
  
      if (strstr(linjer, keyword) )
      {
	printf("%s", linjer);
	sscanf(linjer,"%19c%s",dummy,mailaddress5);
	sscanf(linjer,"%40c%f",dummy,&val);	
//        printf("val: %5.1f  %s\n",val,mailaddress1);
	mail5 = (int)val;	
        break;
      }
    }      
    
*/    
    
    
    
    
    
    
    
    
    
    
    
    
  fclose(par);    
    
  }
}  
LATENCY(int kanal)
{
  int DDAY,MMTH;
  int DY;
  int YR;
  long   yrn;
  long   mon;
  long   day;
  long   hrn;
  long   min;

  int   iyrn;
  int   imon;
  int   iday;
  int   ihrn;
  int   imin;

  float  sek;
  double MSECS;

  int seconds_cpu;
  char tiden_cpu[80];
  char millis_cpu[4];
  long day_cpu;
  long mon_cpu;
  long yrn_cpu;
  long hrn_cpu;
  long min_cpu;

  int iday_cpu;
  int imon_cpu;
  int iyrn_cpu;
  int ihrn_cpu;
  int imin_cpu;

  float sek_cpu;
  char dm[10];
  double MSECS_CPU;


  char dum[50];
  int i,j;
  char   timestamp[80];
  struct timeb  tp;               // structure CPU time


  ftime(&tp);               // CPU time
  seconds_cpu=tp.time;
  sprintf(tiden_cpu,"%s",ctime(&tp.time));
  sprintf(millis_cpu,"%3d",tp.millitm);
  Cnv_CPUtime(tiden_cpu,millis_cpu);

  sscanf(tiden_cpu,"%2d%1s%2d%1s%4d %2d%1s%2d%1s%f6.3",
&iday_cpu,dm,&imon_cpu,dm,&iyrn_cpu,&ihrn_cpu,dm,&imin_cpu,dm,&sek_cpu);
  day_cpu=iday_cpu;
  mon_cpu=imon_cpu;
  yrn_cpu=iyrn_cpu;
  hrn_cpu=ihrn_cpu;
  min_cpu=imin_cpu;

  TIMSEC(yrn_cpu,mon_cpu,day_cpu,hrn_cpu,min_cpu,sek_cpu,&MSECS_CPU);

  sscanf(rtid[kanal],"%4d%1c%3d%1c%2d%1c%2d%1c%f6.3",&YR,dum,&DY,dum,&ihrn,dum,&imin,dum,&sek);
  hrn=ihrn;
  min=imin;

//  printf("%4d %3d %2d %2d %4.1f\n",YR,DY,hrn,min,sek);

  DTE (DY,&DDAY,&MMTH,YR);     //-- convert from doy to date  
  yrn=YR;
  yrn=yrn-2000;
  mon=MMTH;
  day=DDAY;

  iday=day;
  imon=mon;
  iyrn=yrn;
  ihrn=hrn;
  imin=min;

  sprintf(timestamp,"%2d/%2d/%2d %2d:%2d:%6.3f",iday,imon,iyrn,ihrn,imin,sek);
  if(timestamp[0] == ' ') timestamp[0] = '0';
  if(timestamp[3] == ' ') timestamp[3] = '0';
  if(timestamp[6] == ' ') timestamp[6] = '0';
  if(timestamp[9] == ' ') timestamp[9] = '0';
  if(timestamp[12] == ' ') timestamp[12] = '0';
  if(timestamp[15] == ' ') timestamp[15] = '0';
  if(timestamp[18] == ' ') timestamp[18] = '0';
  if(timestamp[19] == ' ') timestamp[19] = '0';
  if(timestamp[20] == ' ') timestamp[20] = '0';
//printf("%s %s\n",toplot[kanal],timestamp);
//      printf("TIME: %4d %2d %2d %2d %2d %4.1f\n",yrn,mon,day,hrn,min,sek);
  TIMSEC(yrn,mon,day,hrn,min,sek,&MSECS);
  latency[kanal] = MSECS_CPU - MSECS;
  spt->latency[klon][kanal] = latency[kanal];
}
Cnv_CPUtime(char tiden[],char millis[])
{
  int ret;
  char word[4];
      word[0]=tiden[4];
      word[1]=tiden[5];
      word[2]=tiden[6];
      word[3]='\0';


      tiden[0]=tiden[8];
      tiden[1]=tiden[9];
      tiden[2]='/';
      ret=strcmp(word,"Jan");
      if(ret==0)
      {
        tiden[3]='0';
        tiden[4]='1';
      }
      ret=strcmp(word,"Feb");
      if(ret==0)
      {
        tiden[3]='0';
        tiden[4]='2';
      }
      ret=strcmp(word,"Mar");
      if(ret==0)
      {
        tiden[3]='0';
        tiden[4]='3';
      }
      ret=strcmp(word,"Apr");
      if(ret==0)
      {
        tiden[3]='0';
        tiden[4]='4';
      }
      ret=strcmp(word,"May");
      if(ret==0)
      {
        tiden[3]='0';
        tiden[4]='5';
      }
      ret=strcmp(word,"Jun");
      if(ret==0)
      {
        tiden[3]='0';
        tiden[4]='6';
      }
      ret=strcmp(word,"Jul");
      if(ret==0)
      {
        tiden[3]='0';
        tiden[4]='7';
      }
      ret=strcmp(word,"Aug");
      if(ret==0)
      {
        tiden[3]='0';
        tiden[4]='8';
      }
      ret=strcmp(word,"Sep");
      if(ret==0)
      {
        tiden[3]='0';
        tiden[4]='9';
      }
      ret=strcmp(word,"Oct");
      if(ret==0)
      {
        tiden[3]='1';
        tiden[4]='0';
      }
      ret=strcmp(word,"Nov");
      if(ret==0)
      {
        tiden[3]='1';
        tiden[4]='1';
      }
      ret=strcmp(word,"Dec");
      if(ret==0)
      {
        tiden[3]='1';
        tiden[4]='2';
      }
      tiden[5]='/';
      tiden[6]=tiden[20];
      tiden[7]=tiden[21];
      tiden[8]=tiden[22];
      tiden[9]=tiden[23];
      tiden[19]='.';


      tiden[20]=millis[0];
      tiden[21]=millis[1];
      tiden[22]=millis[2];
      tiden[23]='\n';



}

/*  Subroutine to apply an iir filter to a data sequence.                   */
/*    The filter is assumed to be stored as second order sections.          */
/*    Filtering is in-place.                                                */
/*    Zero-phase (forward and reverse) is an option.                        */
//appl(sw,chan,nsamp,peker)
void appl_pick(int fnd,float seis[])
//int      sw;
//int      chan;
//int      nsamp;
//float    *peker;
{
//float    *tpek;
    /* System generated locals */
int      i1;
int      i2;

    /* Local variables */
int      jptr;
int      i;
int      j;
float    b0;
float    b1;
float    b2;
float    a1;
float    a2;
float    x1;
float    x2;
float    y1;
float    y2;
float    output;
//tpek=peker;

/* Parameter adjustments                                                    */
/*    --data;*/

/* Function Body                                                            */
jptr = 1;
i1 = cset[fnd];

for (j = 1; j <= i1; ++j)
{
    x1 = save_x1_pick[fnd][j];
    x2 = save_x2_pick[fnd][j];
    y1 = save_y1_pick[fnd][j];
    y2 = save_y2_pick[fnd][j];
    b0 = snc[fnd][jptr];
    b1 = snc[fnd][jptr + 1];
    b2 = snc[fnd][jptr + 2];
    a1 = sdc[fnd][jptr + 1];
    a2 = sdc[fnd][jptr + 2];
if(fnd==1000)
  printf("%8.3f %8.3f %8.3f %8.3f %8.3f %8.3f %8.3f %8.3f %8.3f\n",x1,x2,y1,y2,b0,b1,b2,a1,a2);

    i2 = 5000;

    for (i = 0; i < i2; ++i)
    {
      output = b0 * seis[i] + b1 * x1 + b2 * x2;
      output -= a1 * y1 + a2 * y2;
      y2 = y1;
      y1 = output;
      x2 = x1;
      x1 = seis[i];
      seis[i] = output;

    }

    jptr += 3;

    save_y2_pick[fnd][j]=y2;
    save_y1_pick[fnd][j]=y1;
    save_x2_pick[fnd][j]=x2;
    save_x1_pick[fnd][j]=x1;

}

}
/*---------------------------------------------------------*/
/*     Network Delay Trigger  TRG_MUL Thread               */
/*---------------------------------------------------------*/
void TRG_MUL(void *ptr)
{

      int lthread_no;
      int lantkan;
      int lfra;
      int ltil;
      int lminimum_no_triggers;  
  
  
  trgmul *data;            
  data = (trgmul *) ptr;  /* type cast to a pointer to thdata */

  lthread_no = data->thread_no;
  lantkan = data->antkan;
  lfra = data->fra;
  ltil = data->til;
  lminimum_no_triggers = data-> minimum_no_triggers;
  
  
  
  pthread_t cat_mul_thread;             // definition for CAT_MUL thread  
  catmul catinfo1, catinfo2, catinfo3;



  
  long   yrn;
  long   doy;
  long   mon;
  long   day;
  long   hrn;
  long   min;

  int   iyrn;
  int   idoy;
  int   imon;
  int   iday;
  int   ihrn;
  int   imin;

  float  sek;
  
  int from;
  int to;
  int t1;
  int t2;

  int ch1;
  int kan1;
  int thread;
  int kk;
  int df1;
  int p;
  int pk;
  int t;
  int jj;
  int rt1;
  int br1;
  int teller;
  int min_trg;
  int min_trg_cnt=0;
  int retur;
//  int triggers;
  int maxdur;
  double diff;
  double d1;
  double dd1[200];
  int avpa;
  char lyd[200];
  double mintid;
  double start_time;
  int    triggers[MAXCHA];
  double trigtime[MAXCHA];
  int    trigindx[MAXCHA];
  int    durk[MAXCHA];
  pthread_t cat_del_thread;            // definition for CAT_DELAY thread
  sprintf(lyd,"aplay %s/map/glasses.wav",topdir_rt);
/******** SIGNAL to main thread to go on **************/
  main_cnd=0;                    // change condition variable and let main goon
  if( main_cnd == 0 )
  {
    pthread_cond_signal( &cnd_cnd_main );
  }
  t1   = (MINUT_NOW - DET_DELAY) * 60;
  t2   = t1 + APW/2;  
  from = (MINUT_NOW - DET_DELAY) * 60;
  to   = from + APW;
  printf("FROM: %d  TO: %d\n",from,to);
  
  printf("totalchannels: %d\n",totalchannels);
  for(;;)
  {
    sleep(1);
//    printf("TRG_MUL %d streams: %2dfra: %2d til: %2d\n",lthread_no,lantkan,lfra,ltil);

//----------------------------------------------------------------------------------------
// check for trigger on-sets in Array-Propagation-Window that is delayed DET_DELAY minutes
//----------------------------------------------------------------------------------------    
    min_trg_cnt = 0;
    br1=0;
    for(t = t1; t < t2; t++)
    {
      for(kan1 = lfra; kan1 < ltil; kan1++)
      {
	if(spt->ttdly[klon][kan1][t] == 122 && trgdly[kan1][t] > 10000.0)
        {
          br1=1;
//printf("Thread %2d Trigger on channel %2d in APW %s\n",lthread_no,kan1,allstreams[kan1]);
          break;
        }
      }
    }
    
    if(br1 ==1)
    {   
      for(jj = from; jj < to; jj++)
      {
        for(kan1 = lfra;kan1 < ltil; kan1++)
        {
	  if(spt->ttdly[klon][kan1][jj] == 122 && trgdly[kan1][jj] > 10000.0)
	  {
	    for(pk = lfra; pk < ltil; pk++)
	    {
	      if(triggers[kan1] == 0)        // not triggered before
	      {
		triggers[kan1] = 1;
	        min_trg_cnt++;
//                printf("Thread %2d new trigger on chan: %2d min_trg_cnt: %d\n",lthread_no,kan1,min_trg_cnt);
	        trigtime[kan1] = trgdly[kan1][jj];
	        trigindx[kan1] = jj;
//		printf("trigindx: kan1: %2d jj: %4d\n",kan1,jj);
	        for(p=jj+1;p<(DELAY_BUFFER*60);p++)
	        {
	          if(spt->ttdly[klon][kan1][p] == 111 && trgdly[kan1][p] == 111)	    
	          {
	            durk[kan1] = durk[kan1] + 1;
//		    printf("increment durk: %2d %3d\n",kan1,durk[kan1]);
	          }else{
	            break;
	          }  // spt
	        }    // p
	      }      // if triggers
	    }        // pk 
//	  printf("min_trg: %2d ch: %2d dur: %3d index: %5d\n",min_trg_cnt,kan1,dur[kan1],jj);
	  }          // spt
        }            // kan1
      }              // jj
    }                // if br
//    for(p=0;p<no_to_plot;p++)
//      printf("%2d",triggers[p]);
//    printf("\n");
//printf("MIN_TRG_CNT: %2d MIN_TRG: %d\n",min_trg_cnt,mintrg);



    if(min_trg_cnt >= lminimum_no_triggers)
    {
      
          
      printf("WE HAVE A DELAYED TRIGGER on thread %2d !\n",lthread_no);

      rt1=system(lyd);
      for(p = lfra;p < ltil;p++)
      {
        DURTRG[p]=durk[p];
//	printf("dur: %6d\n",durk[p]);
      }
      for(p = lfra;p < ltil;p++)
      {
	if(trigindx[p] != 0)
	  printf("kan: %3d %s time: %12.2f index: %5d dur: %3d\n",p,spt->trig_stations[klon][p],trigtime[p],trigindx[p],durk[p]);
      }
      mintid = 9333333333.0;
      for(p = lfra; p < ltil; p++)
      {
        if(trigtime[p] > 10000.0)
	{
	  if(trigtime[p] < mintid)
	    mintid=trigtime[p];
	}
      }
      
      maxdur = 0;
      for(p = lfra; p < ltil; p++)
      {
        if(trigtime[p] > 10000.0)
	{
	  if(durk[p] > maxdur)
	    maxdur=durk[p];
	}
      }
      printf("rtdet: TRG_DELAY mintid:   %12.2f  maxdur: %d\n",mintid,maxdur);
      SECTIM(mintid,&yrn,&doy,&mon,&day,&hrn,&min,&sek);
      iyrn=yrn;
      imon=mon;
      iday=day;
      ihrn=hrn;
      imin=min;
      MINSTETID=mintid;
      printf("rtdet: TRG_DELAY MINTRGTID: %4d/%2d/%2d %2d:%2d:%4.1f\n",iyrn,imon,iday,ihrn,imin,sek);
      sprintf(MINTRGTID,"%02d/%02d/%4d %02d:%02d:%4.1f",iday,imon,iyrn,ihrn,imin,sek);
      printf("rtdet: TRG_DELAY MINTRGTID: %s\n",MINTRGTID);
      

      main_cnd=1;                              // set conditon to WAIT
/*------------------------------------------------------------------------------*/
/* Start thread CAT_DET to retreive data from SEEDLINK buffer and store the data*/
/*------------------------------------------------------------------------------*/

     if(mintrg == 0)
     {
       thread = lthread_no-1;
       catinfo1.maxdur = maxdur;
       catinfo1.thread_no           = thread+1;
       catinfo1.antkan              = kanaler_hver_record[thread];	  
       catinfo1.fra                 = fra[thread];
       catinfo1.til                 = til[thread];
     }else{
       thread = lthread_no-1;
       catinfo1.maxdur = maxdur;
       catinfo1.thread_no           = thread+1;
       catinfo1.antkan              = rec_count;	  
       catinfo1.fra                 = 0;
       catinfo1.til                 = rec_count;       
     }
      printf("rtdet: CAT_MUL thread: %2d started. channels: %2d from: %2d to: %2d\n",catinfo1.thread_no,catinfo1.antkan,catinfo1.fra,catinfo1.til);     
      pthread_create(&cat_mul_thread, NULL, (void *) &CAT_MUL,(void *) &catinfo1);



/*
      if(pthread_create(&cat_del_thread,NULL,(void *)CAT_DELAY,(void *)maxdur))
      {
        if(printarg >= 1)
          printf("rtdet: TRG Start CAT_DET thread failed: EXIT\n");
        abort();     
      }
      if(printarg >= 1)
        printf("rtdet: TRG.......:CAT_DET started\n");
      while( main_cnd != 0 )
      {
        if(LOCK==1)
          pthread_mutex_lock(&cnd_mtx_main);
        pthread_cond_wait( &cnd_cnd_main, &cnd_mtx_main );
      }      
*/
      for(p =lfra;p < ltil;p++)
      {
	if(trigindx[p] != 0)
	{
	  for(t=trigindx[p];t<(trigindx[p]+durk[p]+1);t++)
	  {
            spt->ttdly[klon][p][t] = 0;
            trgdly[p][t] = 0.0;	    
	  }
	}
      }
      for(p = lfra;p < ltil;p++)
      {
	trigtime[p] = 0.0;
	trigindx[p] = 0;
	durk[p] = 0;
	triggers[p] = 0;
      }
      min_trg_cnt = 0;
//}else{
//  printf("CATALOG BUSY\n");
//  sleep(1); 
//}
      
    }else{
      for(p=0;p<totalchannels;p++)
      {
	trigtime[p] = 0.0;
	trigindx[p] = 0;
	durk[p] = 0;
        triggers[p] = 0;
      }     
    }


    
    
  }  // for ;;
  
 
 
  


//  return NULL;
}


/*---------------------------------------------------------*/
/*     Network Delay Trigger  TRG_DELAY Thread             */
/*---------------------------------------------------------*/
void *TRG_DELAY(int *parno)
{

  long   yrn;
  long   doy;
  long   mon;
  long   day;
  long   hrn;
  long   min;

  int   iyrn;
  int   idoy;
  int   imon;
  int   iday;
  int   ihrn;
  int   imin;

  float  sek;
  
  int from;
  int to;
  int t1;
  int t2;

  int ch1;
  int kan1;
  int kk;
  int df1;
  int p;
  int pk;
  int t;
  int jj;
  int rt1;
  int br1;
  int teller;
  int min_trg;
  int min_trg_cnt=0;
  int retur;
//  int triggers;
  int maxdur;
  double diff;
  double d1;
  double dd1[200];
  int avpa;
  char lyd[200];
  double mintid;
  double start_time;
  int    triggers[MAXCHA];
  double trigtime[MAXCHA];
  int    trigindx[MAXCHA];
  int    durk[MAXCHA];
  pthread_t cat_del_thread;            // definition for CAT_DELAY thread
  sprintf(lyd,"aplay %s/map/glasses.wav",topdir_rt);
/******** SIGNAL to main thread to go on **************/
  main_cnd=0;                    // change condition variable and let main goon
  if( main_cnd == 0 )
  {
    pthread_cond_signal( &cnd_cnd_main );
  }
  t1   = (MINUT_NOW - DET_DELAY) * 60;
  t2   = t1 + APW/2;  
  from = (MINUT_NOW - DET_DELAY) * 60;
  to   = from + APW;
  printf("FROM: %d  TO: %d\n",from,to);
  
  printf("totalchannels: %d\n",totalchannels);
  for(;;)
  {
    sleep(1);

//----------------------------------------------------------------------------------------
// check for trigger on-sets in Array-Propagation-Window that is delayed DET_DELAY minutes
//----------------------------------------------------------------------------------------    
    min_trg_cnt = 0;
    br1=0;
    for(t = t1; t < t2; t++)
    {
      for(kan1 = 0; kan1 < totalchannels; kan1++)
      {
	if(spt->ttdly[klon][kan1][t] == 122 && trgdly[kan1][t] > 10000.0)
        {
          br1=1;
//printf("Trigger on channel %2d in APW\n",kan1);
          break;
        }
      }
    }
    if(br1 ==1)
    {   
      for(jj = from; jj < to; jj++)
      {
        for(kan1 = 0;kan1 < totalchannels; kan1++)
        {
	  if(spt->ttdly[klon][kan1][jj] == 122 && trgdly[kan1][jj] > 10000.0)
	  {
	    for(pk = 0; pk < totalchannels; pk++)
	    {
	      if(triggers[kan1] == 0)        // not triggered before
	      {
		triggers[kan1] = 1;
	        min_trg_cnt++;
//                printf("new trigger on chan: %2d min_trg_cnt: %d\n",kan1,min_trg_cnt);
	        trigtime[kan1] = trgdly[kan1][jj];
	        trigindx[kan1] = jj;
//		printf("trigindx: kan1: %2d jj: %4d\n",kan1,jj);
	        for(p=jj+1;p<(DELAY_BUFFER*60);p++)
	        {
	          if(spt->ttdly[klon][kan1][p] == 111 && trgdly[kan1][p] == 111)	    
	          {
	            durk[kan1] = durk[kan1] + 1;
//		    printf("increment durk: %2d %3d\n",kan1,durk[kan1]);
	          }else{
	            break;
	          }  // spt
	        }    // p
	      }      // if triggers
	    }        // pk 
//	  printf("min_trg: %2d ch: %2d dur: %3d index: %5d\n",min_trg_cnt,kan1,dur[kan1],jj);
	  }          // spt
        }            // kan1
      }              // jj
    }                // if br
//    for(p=0;p<no_to_plot;p++)
//      printf("%2d",triggers[p]);
//    printf("\n");
//printf("MIN_TRG_CNT: %2d MIN_TRG: %d\n",min_trg_cnt,mintrg);
    if(min_trg_cnt >= mintrg)
    {
      
//if(CAT_DEL_BUSY == 0)
//{      
      
      printf("WE HAVE A DELAYED TRIGGER !\n");
      rt1=system(lyd);
      for(p=0;p<totalchannels;p++)
      {
        DURTRG[p]=durk[p];
//	printf("dur: %6d\n",durk[p]);
      }
      for(p=0;p<totalchannels;p++)
      {
	if(trigindx[p] != 0)
	  printf("kan: %3d %s time: %12.2f index: %5d dur: %3d\n",p,spt->trig_stations[klon][p],trigtime[p],trigindx[p],durk[p]);
      }
      mintid = 9333333333.0;
      for(p=0; p< totalchannels; p++)
      {
        if(trigtime[p] > 10000.0)
	{
	  if(trigtime[p] < mintid)
	    mintid=trigtime[p];
	}
      }
      maxdur = 0;
      for(p=0; p< totalchannels; p++)
      {
        if(trigtime[p] > 10000.0)
	{
	  if(durk[p] > maxdur)
	    maxdur=durk[p];
	}
      }
      printf("rtdet: TRG_DELAY mintid:   %12.2f  maxdur: %d\n",mintid,maxdur);
      SECTIM(mintid,&yrn,&doy,&mon,&day,&hrn,&min,&sek);
      iyrn=yrn;
      imon=mon;
      iday=day;
      ihrn=hrn;
      imin=min;
      MINSTETID=mintid;
      printf("rtdet: TRG_DELAY MINTRGTID: %4d/%2d/%2d %2d:%2d:%4.1f\n",iyrn,imon,iday,ihrn,imin,sek);
      sprintf(MINTRGTID,"%02d/%02d/%4d %02d:%02d:%4.1f",iday,imon,iyrn,ihrn,imin,sek);
      printf("rtdet: TRG_DELAY MINTRGTID: %s\n",MINTRGTID);
      

      main_cnd=1;                              // set conditon to WAIT
/*------------------------------------------------------------------------------*/
/* Start thread CAT_DET to retreive data from SEEDLINK buffer and store the data*/
/*------------------------------------------------------------------------------*/
      if(pthread_create(&cat_del_thread,NULL,(void *)CAT_DELAY,(void *)maxdur))
      {
        if(printarg >= 1)
          printf("rtdet: TRG Start CAT_DET thread failed: EXIT\n");
        abort();     
      }
      if(printarg >= 1)
        printf("rtdet: TRG.......:CAT_DET started\n");
      while( main_cnd != 0 )
      {
        if(LOCK==1)
          pthread_mutex_lock(&cnd_mtx_main);
        pthread_cond_wait( &cnd_cnd_main, &cnd_mtx_main );
      }      
      for(p=0;p<totalchannels;p++)
      {
	if(trigindx[p] != 0)
	{
	  for(t=trigindx[p];t<(trigindx[p]+durk[p]+1);t++)
	  {
            spt->ttdly[klon][p][t] = 0;
            trgdly[p][t] = 0.0;	    
	  }
	}
      }
      for(p=0;p<totalchannels;p++)
      {
	trigtime[p] = 0.0;
	trigindx[p] = 0;
	durk[p] = 0;
	triggers[p] = 0;
      }
      min_trg_cnt = 0;
//}else{
//  printf("CATALOG BUSY\n");
//  sleep(1); 
//}
    }else{
      for(p=0;p<totalchannels;p++)
      {
	trigtime[p] = 0.0;
	trigindx[p] = 0;
	durk[p] = 0;
        triggers[p] = 0;
      }     
    }


    
    
  }  // for ;;
  
 
 
  


  return NULL;
}


/*---------------------------------------------------------*/
/*     CAT_DELAY Thread                                    */
/*---------------------------------------------------------*/
void CAT_MUL(void *ptr)
{
  
  catmul *data;
  data = (catmul *) ptr;

      int lthread_no;
      int lmaxdur;
      int lantkan;	  
      int lfra;
      int ltil;

      lthread_no = data->thread_no;
      lmaxdur = data->maxdur;
      lantkan = data->antkan;
      lfra = data->fra;
      ltil = data->til;
  
  
  FILE   *req;
  char   reqnam[200];
  char   comm[200];
  char   stasjon[20];
  char   ipserv[50];
  int    cr;
  double stop_time;
  double start_time;
  char   FILNAVN[1024];
  char   CRTDIR[256];
  char   PATHANDFIL[256];
  char   syscmd[512];
  int    varighet[MAXCHA];
  long   fyrn;
  long   fdoy;
  long   fmon;
  long   fday;
  long   fhrn;
  long   fmin;

  int   ifyrn;
  int   ifdoy;
  int   ifmon;
  int   ifday;
  int   ifhrn;
  int   ifmin;
  
  int   ityrn;
  int   itdoy;
  int   itmon;
  int   itday;
  int   ithrn;
  int   itmin;
  
  long   tyrn;
  long   tdoy;
  long   tmon;
  long   tday;
  long   thrn;
  long   tmin;
    

  float  tsek;
  
  int   kk;
  int   rt1;
  int   pp;
  float  fsek;
  
  printf("********************************************************************************\n");
  printf("rtdet:                       CAT_DELAY started\n");
  printf("********************************************************************************\n"); 

CAT_DEL_BUSY=1;

  main_cnd=0;                    // change condition variable and let main goon
  if( main_cnd == 0 )
  {
    pthread_cond_signal( &cnd_cnd_main );
  }
  printf("rtdet: CAT_DELAY maxdur: %d\n",lmaxdur);
  start_time = MINSTETID - preevent;
  stop_time = MINSTETID + lmaxdur + postevent;
  SECTIM(start_time,&fyrn,&fdoy,&fmon,&fday,&fhrn,&fmin,&fsek);

  ifyrn=fyrn;
  ifmon=fmon;
  ifday=fday;
  ifhrn=fhrn;
  ifmin=fmin;

//  sprintf(from, "%4d-%2d-%2d-%2d%2d-%2d.NNSN__%3d_%2d",ifyrn,ifmon,ifday,ifhrn,ifmin,(int)fsek,no_to_plot,klon);
  sprintf(FILNAVN, "%4d-%2d-%2d-%2d%2d-%2d.NNSN__%3d_%2d",ifyrn,ifmon,ifday,ifhrn,ifmin,(int)fsek,totalchannels,klon);

  for(kk=0;kk<32;kk++)
    if(FILNAVN[kk] == ' ') FILNAVN[kk]='0';

  FILNAVN[31]='\0';
  FILNAVN[19] = dbname[0];
  FILNAVN[20] = dbname[1];
  FILNAVN[21] = dbname[2];
  FILNAVN[22] = dbname[3];
  FILNAVN[23] = dbname[4];
  printf("rtdet: CAT_DELAY FILNAVN: %s\n",FILNAVN);
  
//--------------------------------------------------------------
// check if waveform is to be stored in WOR (no database structure,
// or in WAV seisan database structure.
//-----------------------------------------------------------------
  if(dbase_switch == 1)
  {
    sprintf(PATHANDFIL,"%s/%s/%2d/%2d/%s",trgpath,dbname,ifyrn,ifmon,FILNAVN);

    for(kk=0;kk<256;kk++)
      if(PATHANDFIL[kk] == ' ') PATHANDFIL[kk] = '0';
    printf("rtdet: CAT_DELAY PATHANDFIL: %s\n",PATHANDFIL);  
    sprintf(CRTDIR,"%s/%s/%2d/%2d",trgpath,dbname,ifyrn,ifmon);

    for(kk=0;kk<256;kk++)
      if(CRTDIR[kk] == ' ') CRTDIR[kk] = '0';
    printf("rtdet: CAT_DELAY CRTDIR: %s\n",CRTDIR);   
    CreateDirectory(CRTDIR);
  }else{
    sprintf(PATHANDFIL,"%s/%s",trgpath,FILNAVN);
    printf("rtdet: CAT_DELAY PATHANDFIL: %s\n",PATHANDFIL); 
  }

  SECTIM(stop_time,&tyrn,&tdoy,&tmon,&tday,&thrn,&tmin,&tsek);

  ityrn=tyrn;
  itmon=tmon;
  itday=tday;
  ithrn=thrn;
  itmin=tmin;

  printf("rtdet: CAT_DET to  : %4d/%2d/%2d %2d:%2d:%4.1f\n",ityrn,itmon,itday,ithrn,itmin,tsek);
  sprintf(reqnam,"%s/req/%s",topdir_rt,FILNAVN);
  if ((req = fopen (reqnam, "w")) == NULL)
  {
    printf("rtdet: CAT_DET Can't open: %s\n",reqnam);
  }
  printf("********************************************************************************\n");
  printf("rtdet: CAT_DELAY Extracting data from SeedLink server........\n");
  printf("********************************************************************************\n");
//  for(kk=0;kk<no_to_record;kk++)
  for(kk = lfra; kk < ltil; kk++)    
  {
    ifyrn=fyrn;
    ifmon=fmon;
    ifday=fday;
    ifhrn=fhrn;
    ifmin=fmin;

    ityrn=tyrn;
    itmon=tmon;
    itday=tday;
    ithrn=thrn;
    itmin=tmin;


    sscanf(record[kk],"%s %s",stasjon,ipserv);
    
   // sprintf(syscmd,"%s/bin/getwindow -S %c%s%c -tw %d,%d,%d,%d,%d,%d:%d,%d,%d,%d,%d,%d -nt 10 -o %s  %s",topdir_rt,0x22,record[kk],0x22,ifyrn,ifmon,ifday,ifhrn,ifmin,(int)fsek,ityrn,itmon,itday,ithrn,itmin,(int)tsek,PATHANDFIL,slconn->sladdr);
    sprintf(syscmd,"%s/bin/getwindow -S %c%s%c -tw %d,%d,%d,%d,%d,%d:%d,%d,%d,%d,%d,%d -nt 5 -nd 5 -o %s %s",topdir_rt,0x22,stasjon,0x22,ifyrn,ifmon,ifday,ifhrn,ifmin,(int)fsek,ityrn,itmon,itday,ithrn,itmin,(int)tsek,PATHANDFIL,ipserv);
    printf("%s\n",syscmd);  
    fprintf(req,"%s\n",syscmd);
    rt1=system(syscmd);
  }
  fclose(req);
  sprintf(comm,"chmod +x %s",reqnam);
  rt1=system(comm);
  for(kk=0;kk<MAXCHA;kk++)
  {
    varighet[kk] = DURTRG[kk];
    DURTRG[kk] = 0;
  }
  printf("rtdet: CAT_DELAY call Create_Sfile\n");
//  Create_Sfile(MINTRGTID,FILNAVN,no_to_plot,varighet,thr,tmn,tsc,tms,start_trg);
  Create_Sfile(MINTRGTID,FILNAVN,totalchannels,varighet);
  
  printf("rtdet: CAT_DELAY SFILEPATH: %s\n",sfilepath);
  printf("rtdet: CAT_DELAY DBNAME: %s\n",dbname);
  printf("rtdet: CAT_DELAY detection_file: %s\n",detection_file);

  sprintf(syscmd,"%s/bin/rtpick -sfile %s -wavefile %s -iter 200 -maxres 3.0",topdir_rt,SFILETOPICK,PATHANDFIL); 
  printf("rtdet: CAT_DELAY %s\n",syscmd);
  rt1=system(syscmd);
    
  CAT_DEL_BUSY = 0;
    
}




/*---------------------------------------------------------*/
/*     CAT_DELAY Thread                                    */
/*---------------------------------------------------------*/
void *CAT_DELAY(int maxdur)
{
  FILE   *req;
  char   reqnam[200];
  char   comm[200];
  char   stasjon[20];
  char   ipserv[50];
  int    cr;
  double stop_time;
  double start_time;
  char   FILNAVN[1024];
  char   CRTDIR[256];
  char   PATHANDFIL[256];
  char   syscmd[512];
  int    varighet[MAXCHA];
  long   fyrn;
  long   fdoy;
  long   fmon;
  long   fday;
  long   fhrn;
  long   fmin;

  int   ifyrn;
  int   ifdoy;
  int   ifmon;
  int   ifday;
  int   ifhrn;
  int   ifmin;
  
  int   ityrn;
  int   itdoy;
  int   itmon;
  int   itday;
  int   ithrn;
  int   itmin;
  
  long   tyrn;
  long   tdoy;
  long   tmon;
  long   tday;
  long   thrn;
  long   tmin;
    

  float  tsek;
  
  int   kk;
  int   rt1;
  int   pp;
  float  fsek;
  
  printf("********************************************************************************\n");
  printf("rtdet:                       CAT_DELAY started\n");
  printf("********************************************************************************\n"); 

CAT_DEL_BUSY=1;

  main_cnd=0;                    // change condition variable and let main goon
  if( main_cnd == 0 )
  {
    pthread_cond_signal( &cnd_cnd_main );
  }
  printf("rtdet: CAT_DELAY maxdur: %d\n",maxdur);
    start_time = MINSTETID - preevent;
  stop_time = MINSTETID + maxdur + postevent;
  SECTIM(start_time,&fyrn,&fdoy,&fmon,&fday,&fhrn,&fmin,&fsek);

  ifyrn=fyrn;
  ifmon=fmon;
  ifday=fday;
  ifhrn=fhrn;
  ifmin=fmin;

//  sprintf(from, "%4d-%2d-%2d-%2d%2d-%2d.NNSN__%3d_%2d",ifyrn,ifmon,ifday,ifhrn,ifmin,(int)fsek,no_to_plot,klon);
  sprintf(FILNAVN, "%4d-%2d-%2d-%2d%2d-%2d.NNSN__%3d_%2d",ifyrn,ifmon,ifday,ifhrn,ifmin,(int)fsek,totalchannels,klon);

  for(kk=0;kk<32;kk++)
    if(FILNAVN[kk] == ' ') FILNAVN[kk]='0';

  FILNAVN[31]='\0';
  FILNAVN[19] = dbname[0];
  FILNAVN[20] = dbname[1];
  FILNAVN[21] = dbname[2];
  FILNAVN[22] = dbname[3];
  FILNAVN[23] = dbname[4];
  printf("rtdet: CAT_DELAY FILNAVN: %s\n",FILNAVN);
  
//--------------------------------------------------------------
// check if waveform is to be stored in WOR (no database structure,
// or in WAV seisan database structure.
//-----------------------------------------------------------------
  if(dbase_switch == 1)
  {
    sprintf(PATHANDFIL,"%s/%s/%2d/%2d/%s",trgpath,dbname,ifyrn,ifmon,FILNAVN);

    for(kk=0;kk<256;kk++)
      if(PATHANDFIL[kk] == ' ') PATHANDFIL[kk] = '0';
    printf("rtdet: CAT_DELAY PATHANDFIL: %s\n",PATHANDFIL);  
    sprintf(CRTDIR,"%s/%s/%2d/%2d",trgpath,dbname,ifyrn,ifmon);

    for(kk=0;kk<256;kk++)
      if(CRTDIR[kk] == ' ') CRTDIR[kk] = '0';
    printf("rtdet: CAT_DELAY CRTDIR: %s\n",CRTDIR);   
    CreateDirectory(CRTDIR);
  }else{
    sprintf(PATHANDFIL,"%s/%s",trgpath,FILNAVN);
    printf("rtdet: CAT_DELAY PATHANDFIL: %s\n",PATHANDFIL); 
  }

  SECTIM(stop_time,&tyrn,&tdoy,&tmon,&tday,&thrn,&tmin,&tsek);

  ityrn=tyrn;
  itmon=tmon;
  itday=tday;
  ithrn=thrn;
  itmin=tmin;

  printf("rtdet: CAT_DET to  : %4d/%2d/%2d %2d:%2d:%4.1f\n",ityrn,itmon,itday,ithrn,itmin,tsek);
  sprintf(reqnam,"%s/req/%s",topdir_rt,FILNAVN);
  if ((req = fopen (reqnam, "w")) == NULL)
  {
    printf("rtdet: CAT_DET Can't open: %s\n",reqnam);
  }
  printf("********************************************************************************\n");
  printf("rtdet: CAT_DELAY Extracting data from SeedLink server........\n");
  printf("********************************************************************************\n");
  for(kk=0;kk<no_to_record;kk++)
  {
    ifyrn=fyrn;
    ifmon=fmon;
    ifday=fday;
    ifhrn=fhrn;
    ifmin=fmin;

    ityrn=tyrn;
    itmon=tmon;
    itday=tday;
    ithrn=thrn;
    itmin=tmin;


    sscanf(record[kk],"%s %s",stasjon,ipserv);
    
   // sprintf(syscmd,"%s/bin/getwindow -S %c%s%c -tw %d,%d,%d,%d,%d,%d:%d,%d,%d,%d,%d,%d -nt 10 -o %s  %s",topdir_rt,0x22,record[kk],0x22,ifyrn,ifmon,ifday,ifhrn,ifmin,(int)fsek,ityrn,itmon,itday,ithrn,itmin,(int)tsek,PATHANDFIL,slconn->sladdr);
    sprintf(syscmd,"%s/bin/getwindow -S %c%s%c -tw %d,%d,%d,%d,%d,%d:%d,%d,%d,%d,%d,%d -nt 5 -nd 5 -o %s %s",topdir_rt,0x22,stasjon,0x22,ifyrn,ifmon,ifday,ifhrn,ifmin,(int)fsek,ityrn,itmon,itday,ithrn,itmin,(int)tsek,PATHANDFIL,ipserv);
    printf("%s\n",syscmd);  
    fprintf(req,"%s\n",syscmd);
    rt1=system(syscmd);
  }
  fclose(req);
  sprintf(comm,"chmod +x %s",reqnam);
  rt1=system(comm);
  for(kk=0;kk<MAXCHA;kk++)
  {
    varighet[kk] = DURTRG[kk];
    DURTRG[kk] = 0;
  }
  printf("rtdet: CAT_DELAY call Create_Sfile\n");
//  Create_Sfile(MINTRGTID,FILNAVN,no_to_plot,varighet,thr,tmn,tsc,tms,start_trg);
  Create_Sfile(MINTRGTID,FILNAVN,totalchannels,varighet);
  
  printf("rtdet: CAT_DELAY SFILEPATH: %s\n",sfilepath);
  printf("rtdet: CAT_DELAY DBNAME: %s\n",dbname);
  printf("rtdet: CAT_DELAY detection_file: %s\n",detection_file);

  sprintf(syscmd,"%s/bin/rtpick -sfile %s -wavefile %s -iter 200 -maxres 3.0",topdir_rt,SFILETOPICK,PATHANDFIL); 
  printf("rtdet: CAT_DELAY %s\n",syscmd);
  rt1=system(syscmd);
    
  CAT_DEL_BUSY = 0;
    
}
/*---------------------------------------------------------*/
/*     Delay buffer shufle  BUFFER_SHUFLE Thread           */
/*---------------------------------------------------------*/
void *BUFFER_SHUFLE(int *parno)
{
  char dummy[256];
  long   yrn;
  long   mon;
  long   day;
  long   hrn;
  long   min;
  long   doy;
  int   iyrn;
  int   imon;
  int   iday;
  int   ihrn;
  int   imin;
  int   isec;
  int   i,j;
  int   BUFSECS;
  float  sek;
  char dum[50];
  double MSECS_OLD=0;
  double MSECS_NEW=0;
  double DIFF=0;

/******** SIGNAL to main thread to go on **************/
  main_cnd=0;                    // change condition variable and let main goon
  if( main_cnd == 0 )
  {
    pthread_cond_signal( &cnd_cnd_main );
  }  
  BUFSECS = DELAY_BUFFER * 60;
  MSECS_OLD = TIME_NOW;
  for(;;)
  {
//    printf("BUFFER_SHUFLE lock\n");    
    pthread_mutex_lock(&shift_mutex);

    
    time_t now = time(NULL);
    struct tm *now_s = localtime(&now);
    sprintf(dummy,"%d-%02d-%02d_%02d:%02d:%02d", 1900+now_s->tm_year, ++now_s ->tm_mon,now_s->tm_mday, now_s->tm_hour, now_s->tm_min,now_s->tm_sec);
    sscanf(dummy,"%4d%1c%2d%1c%2d%1c%2d%1c%2d%1c%2d",&iyrn,dum,&imon,dum,&iday,dum,&ihrn,dum,&imin,dum,&isec);
    yrn=iyrn;
    yrn=yrn-2000;
    mon=imon;
    day=iday;
    hrn=ihrn;
    min=imin;
    mon=imon;
    sek=isec;
    
    TIMSEC(yrn,mon,day,hrn,min,sek,&MSECS_NEW); 
    DIFF = MSECS_NEW - MSECS_OLD;
    if(DIFF >= SECONDS2SHUFLE)
    {
      MSECS_OLD = MSECS_NEW;
      TIME_NOW = MSECS_NEW;
//      printf("DIFF: %6.3f SHIFFT\n",DIFF);

      for(i=0;i<MAXCHA;i++)
      {
        for(j=0;j<(BUFSECS-SECONDS2SHUFLE);j++)
	{
          spt->ttdly[klon][i][j] = spt->ttdly[klon][i][j+SECONDS2SHUFLE];
          trgdly[i][j] = trgdly[i][j+SECONDS2SHUFLE];	  
	}
      }
    }
//    printf("signal_shift\n");
//    pthread_cond_signal(&signal_shift); 
    pthread_mutex_unlock(&shift_mutex);
    sleep(1);

  }

}

/**************************************************************************/
/*         Read MINISEED packets from SEEDLINK server Thread              */
/**************************************************************************/
void READ_PACKETS(void *ptr)
{
  int ch;
  int ne;
  int k;
  int     seqnum;
  int     ptype;
  int     fnd=0;
  int tr;
  int br = 0;
  int ret1;
  char all[40];
  char det[40];
  
    int  lthread_no;
    char lipaddr[100];
    char lstreams[100];
    char lstations[100];
    int  lno_comp;  
  
  thdata *data;            
  data = (thdata *) ptr;  /* type cast to a pointer to thdata */
  
  SLCD * slconn;	                           // connection parameters each SL server 
  static  SLCD * slconn2;
  static  SLCD * slconn3;
  static  SLCD * slconn4;
  static  SLCD * slconn5; 
  
  SLpacket * slpack;

  char totalstreams[255];
  char detect[255];
  char *stationfile  = 0;      /* station list file for reading streams */  
  char *streamfile   = 0;	    /* stream list file for configuring streams */  
  char addr[256];
  char *selectors   = 0;
  char *multiselect = 0;
  
  lthread_no = data->thread_no;
  sprintf(lipaddr,"%s",data->ipaddr);
  sprintf(lstreams,"%s",data->streams);
  sprintf(lstations,"%s",data->stations);
  lno_comp = data->no_comp;
  
  printf("****************************************************************************\n");
  printf("thread %d connect to: %s\n", lthread_no, lipaddr);
    
// Allocate and initialize a new connection description SEEDLINK
  
//   if(lthread_no == 1)
     slconn = sl_newslcd();
//   if(lthread_no == 2)
//     slconn2 = sl_newslcd();
//   if(lthread_no == 3)
//     slconn3 = sl_newslcd();
//   if(lthread_no == 4)
//     slconn4 = sl_newslcd();
//   if(lthread_no == 5)
//     slconn5 = sl_newslcd();
   
// connect to seedlink server this address
   
   sprintf(addr,"%s",lipaddr);
//   if(lthread_no == 1)  
     slconn->sladdr = addr;
//   if(lthread_no == 2)  
//     slconn2->sladdr = addr;   
//   if(lthread_no == 3)  
//     slconn3->sladdr = addr;
//   if(lthread_no == 4)  
//     slconn4->sladdr = addr;
//   if(lthread_no == 5)  
//     slconn5->sladdr = addr;   
   
// connect input streams to specified seedlink server   
    
  sprintf(totalstreams,"%s/par/%s/%s",topdir_rt,cfgfile,lstreams);
  printf("Connect inputstreams to seedlink server: %s\n",totalstreams);
  streamfile = totalstreams;  


  
//  if(lthread_no == 1)   
    sl_read_streamlist (slconn, streamfile, selectors); 
//  if(lthread_no == 2)   
//    sl_read_streamlist (slconn2, streamfile, selectors); 
//  if(lthread_no == 3)   
//    sl_read_streamlist (slconn3, streamfile, selectors);
//  if(lthread_no == 4)   
//    sl_read_streamlist (slconn4, streamfile, selectors);
//  if(lthread_no == 5)   
//    sl_read_streamlist (slconn5, streamfile, selectors);  
  

//----------------------------------------------------------------
// read detection file
//---------------------------------------------------------------- 
//  printf("********************************************************************\n");
//  printf("Read detection-file thread %2d\n",data->thread_no);
//  sprintf(detect,"%s/par/%s/%s",topdir_rt,cfgfile,data->stations);
//  ch =read_detectionfile (detect); 
//  totalchannels=totalchannels+ch;
//  printf("thread %d totalchannels: %d\n",data->thread_no,totalchannels);

// Never-ending loop reading defined inputstreams for detection 

  
  for(;;)
  {
//    if(lthread_no == 1)
//    {
//      tr=1;
	  tr=lthread_no;
      if( sl_collect (slconn, &slpack))              // Connect to seedlink server
      {
        pthread_mutex_lock(&shufle_mutex);           // ******LOCK******
        ptype  = sl_packettype (slpack);             // get packet type
        seqnum = sl_sequence (slpack);               // get sequence number
        fnd=packet_handler ((char *) &slpack->msrecord, ptype, seqnum, SLRECSIZE,slconn);
        if(fnd != -1)                                // PACKET FOUND ?
        {
          ch=fnd;                                    // YES, SAVE STATION NUMBER
          ctrs[ch]++;
          PROCESS_BLOCK(ch,tr);
          fnd=-1;                                    // RESET 'fnd'
        }
        pthread_mutex_unlock(&shufle_mutex);         // *****UNLOCK******
      }
//    }
/*    
    if(lthread_no == 2)
    {
      tr=2;
      if( sl_collect (slconn2, &slpack))             // Connect to seedlink server
      {
        pthread_mutex_lock(&shufle_mutex);           // ******LOCK******
        ptype  = sl_packettype (slpack);             // get packet type
        seqnum = sl_sequence (slpack);               // get sequence number
        fnd=packet_handler ((char *) &slpack->msrecord, ptype, seqnum, SLRECSIZE,slconn2);
        if(fnd != -1)                                // PACKET FOUND ?
        {
          ch=fnd;   // YES, SAVE STATION NUMBER
          ctrs[ch]++;
          PROCESS_BLOCK(ch,tr);
          fnd=-1;                                    // RESET 'fnd'
        }
        pthread_mutex_unlock(&shufle_mutex);         // *****UNLOCK******
      }  
    }
    if(lthread_no == 3)
    {
      tr=3;
      if( sl_collect (slconn3, &slpack))             // Connect to seedlink server
      {
        pthread_mutex_lock(&shufle_mutex);           // ******LOCK******
        ptype  = sl_packettype (slpack);             // get packet type
        seqnum = sl_sequence (slpack);               // get sequence number

        fnd=packet_handler ((char *) &slpack->msrecord, ptype, seqnum, SLRECSIZE,slconn3);
        if(fnd != -1)                                // PACKET FOUND ?
        {
          ch=fnd;   // YES, SAVE STATION NUMBER
          ctrs[ch]++;
	  PROCESS_BLOCK(ch,tr);
          fnd=-1;                                    // RESET 'fnd'
        }
        pthread_mutex_unlock(&shufle_mutex);         // *****UNLOCK******
      }  
    }  
    if(lthread_no == 4)
    {
      tr=4;
      if( sl_collect (slconn4, &slpack))             // Connect to seedlink server
      {
        pthread_mutex_lock(&shufle_mutex);           // ******LOCK******
        ptype  = sl_packettype (slpack);             // get packet type
        seqnum = sl_sequence (slpack);               // get sequence number
        fnd=packet_handler ((char *) &slpack->msrecord, ptype, seqnum, SLRECSIZE,slconn4);
        if(fnd != -1)                                // PACKET FOUND ?
        {
          ch=fnd;   // YES, SAVE STATION NUMBER
          ctrs[ch]++;
          PROCESS_BLOCK(ch,tr);
          fnd=-1;                                    // RESET 'fnd'
        }
        pthread_mutex_unlock(&shufle_mutex);         // *****UNLOCK******
      }  
    }  
    if(lthread_no == 5)
    {
      tr=5;
      if( sl_collect (slconn5, &slpack))             // Connect to seedlink server
      {
        pthread_mutex_lock(&shufle_mutex);           // ******LOCK******
        ptype  = sl_packettype (slpack);             // get packet type
        seqnum = sl_sequence (slpack);               // get sequence number
        fnd=packet_handler ((char *) &slpack->msrecord, ptype, seqnum, SLRECSIZE,slconn5);
        if(fnd != -1)                                // PACKET FOUND ?
        {
          ch=fnd;   // YES, SAVE STATION NUMBER
          ctrs[ch]++;
          PROCESS_BLOCK(ch,tr);
          fnd=-1;                                    // RESET 'fnd'
        }
        pthread_mutex_unlock(&shufle_mutex);         // *****UNLOCK******
      }  
    }     
*/   
   
   
   
   
  }
}
PROCESS_BLOCK(int ch,int tr)
{

  int    nsta;
  int    nlta;
  int    nnoi;
  float  sta1;                     // STA at current sample
  float  lta1;                     // LTA at current sample
  float  noi1;                     // noise level
  float  stamax;                   // Maximum STA within buffer
  int    ixmax;
  int    sw_hold=0;
  int sw_trg=0;  
  int ixx,k1;


  int pindex;
  int nn;  
  int sekunder;  
  int ant;
  float MxAmp;
  int ws=5;                  // sta in samples
  int wl=100;                // lta in samples  
  float dt;
  float srate;
  int npts;
  

  
  
  
  dc[ch] = 0.0;                                 // Initialize dc to zero  
  ixx = RTBUFSIZ-1;  

  for(k1=0;k1<(RTBUFSIZ-ns[ch]);k1++)           // shift out bottom ns samples
  {
    values[ch][ixx] = values[ch][ixx-ns[ch]];
    ixx = ixx -1;
  }
  for(k1=0;k1<ns[ch];k1++)                      // put ns new samples in on top
    values[ch][ns[ch]-k1-1] = (float)seismo[ch][k1];
  
  for(k1=0;k1<RTBUFSIZ;k1++)                    // add all samples in buffer
    dc[ch] = dc[ch] + values[ch][k1];
  dc[ch] = dc[ch]/(float)RTBUFSIZ;              // dc of tot samples
  spt->cdcavg[klon][ch] = dc[ch];               // Update dc

  for(k1=0;k1<ns[ch];k1++)                      // REMOVE DC
    fseismo[ch][k1]=((float)(seismo[ch][k1])-spt->cdcavg[klon][ch]);
  LATENCY(ch);

  if(pk < 20)
    printf("pk: %d\n",pk);
  if(pk > 20)                                   // let dc stabelize for 20 blocks before starting
  {
    for(k1=0;k1<RTBUFSIZ;k1++)                  // remove DC this channel, for PICKING
      ftemp[ch][k1]=values[ch][RTBUFSIZ-1-k1]-spt->cdcavg[klon][ch];

    dt=srate;
    npts=RTBUFSIZ;
    dt = 1.0/(float)(sr[ch]);
    srate = dt;
    ixx=npts-1;
    for(k1=0;k1<npts;k1++)                      // get seismogram for PICKING processing
      seis[k1] = ftemp[ch][k1];
    
    appl_pick(ch,seis);                         // bandpass filter
    
    nsta=(int)(sta_par[ch]*(float)(sr[ch]));    // number of samples in sta window
    nlta=(int)(lta_par[ch]*(float)(sr[ch]));    // number of samples in lta window
    nnoi=(int)(lta_par[ch]*(float)(sr[ch]));    // number of samples to measure noise-level
 
    if(fl_par[ch] != 0.0 && fh_par[ch] != 0.0)  // FILTER DATA ?
    {
//  printf("START %d\n",tr);      
      appl(ch);                                 // FILTER ONE BUFFER
      sta1=spt->csta[klon][ch];                 // get previous sta
      lta1=spt->clta[klon][ch];                 // get previous lta
      noi1=spt->cnoi[klon][ch];                 // get previous noise-level
      STA_LTA(&sta1,&lta1,&noi1,&stamax,ch,ns[ch],nsta,nlta,nnoi,&ixmax);
//printf(" 3 tr: %d ch: %2d\n",tr,ch);
      if(hold[ch] < VENT)                       // wait for sta-lta to be stable each component
      {
	if(sw_hold == 0)
	{
//		printf("READ_PACKETS...:Receiving data from server......\n");
	  sw_hold = 1;
	}
        spt->csta[klon][ch]=sta1;               // update sta
        spt->clta[klon][ch]=sta1;               // set lta = sta until stable
        spt->cnoi[klon][ch]=sta1;
        hold[ch] = hold[ch] + ns[ch]/sr[ch];    // count blocks holding processing in wait
        spt->age[klon][ch][4] = hold[ch];
        if(spt->age[klon][ch][4] >= VENT)
          spt->age[klon][ch][4] = 0;
//printf(" 4 tr: %d ch: %2d\n",tr,ch);
      }else{   // hold
              //--------------------------------------------------------
              // start single-channel trigger after initializing sta lta
              //--------------------------------------------------------
        if(sw_trg == 0)
	{
//          printf("READ_PACKETS...:Starting detection.....\n");
          sw_trg = 1;
	}
        spt->csta[klon][ch]=sta1;                                 // store new STA in shared
        rat[ch]=spt->csta[klon][ch]/spt->clta[klon][ch];          // compute current ratio
        if(rat[ch] >= trg_par[ch])                                // check for trigger this channel
        {
          if(trig_flag[ch] == 0 && det_flg == 0)                  // compute trigger time, look for P
          {
	    first[ch]=0;
            spt->coda[klon][ch]=spt->cnoi[klon][ch];              // save noise-level at trigger point
            ant=ns[ch];                                           // number of samples last buffer this channel
            ZERO_START(seis);                                     // zero start of signal after filtering
            MaxAmp(RTBUFSIZ,seis,&MxAmp);                         // Find maximum amplitude
            Scale_to_1(RTBUFSIZ,seis,MxAmp);                      // Scale to max 1
            STALTAPHFL(RTBUFSIZ,seis, ws, wl, ratios);            // compute STA/LTA ratios, store in rat

            pindex=FIND_P(ant,RTBUFSIZ,ratios);                   // find P in detection buffer (last buffer)

	    sekunder = ns[ch]/sr[ch];                  
            TRIGGER_TIME_P(ws,pindex,ch,srate,sekunder);          // detection buffer-time + time to P
            printf("READ_PACKETS...:Trigger CH: %2d ant: %4d MxAmp: %8.1f nlev: %8.1f sta:%6.1f lta:%6.1f rat:%6.1f %12.1f %s\n",ch,ant,MxAmp,spt->coda[klon][ch],spt->csta[klon][ch],spt->clta[klon][ch],rat[ch],spt->tt[klon][ch],toplot[ch]);
            ON_OFF[ch] = 1;
          }  // trig_flag
          trig_flag[ch] = 1;                                      // set trigger flag
          spt->age[klon][ch][3] = 1;                              // set flag in shared
          spt->dur[klon][ch]=spt->dur[klon][ch]+ns[ch]/sr[ch];    // increment duration
          if(spt->dur[klon][ch] > 300)
          {
            printf("Channel %2d more than 300 secs. duration.\n",ch);
            trig_flag[ch] = 0;
          }
          sekunder = ns[ch]/sr[ch];
          nn=first[ch];
          first[ch]++;
        }else{   // if ratio.....ratio < trg_par
          if(rat[ch] < dtrg_par[ch])                              // check for de-trigger this channel
          {
            if(trig_flag[ch] == 1)                                // if less than de-trig lev., but still trigger mode
            {
              printf("READ_PACKETS..:klon: %d %s turned off. Dur: %3d\n",klon,toplot[ch],spt->dur[klon][ch]); // turn off trigger flag
              trig_dur[ch] = spt->dur[klon][ch]; 
              trig_flag[ch] = 0;                                  // turn off trigger flag
              spt->age[klon][ch][3] = 0;
              duration[ch] = trig_dur[ch];
              nn=duration[ch];
              if(ON_OFF[ch] == 1)
              {
                ON_OFF[ch] = 0;
                TRIGGER_DUR(sekunder,ch,nn);
              }
            }                                                     // if trig_flag == 1
          }                                                       // if rat < dtrg_par
          if(trig_flag[ch] == 1)
          {
            spt->dur[klon][ch]=spt->dur[klon][ch]+ns[ch]/sr[ch];

          }
        }                                                         // if rat < trg_pr
        spt->cnoi[klon][ch] = noi1;
        if(trig_flag[ch] == 0)
        {
          spt->clta[klon][ch]=lta1;                               // update lta
          if(rat[ch] < 0.6)
          {
            spt->clta[klon][ch]=spt->clta[klon][ch]-(spt->clta[klon][ch] * 20.0)/100.0;
          }
        }
      }     // hold 
    }       // if filter ?
  }else{
    pk++;        // check pk > 20
}
  
}
void ZERO_START(float scr[])
{
  int s;

  for (s=0;s<300;s++)
    scr[s]=0.0;
}

void STALTAPHFL(int ne, float kanal[],int ws,int wl,float rat[])
  {
    float extra=(float)0.0;
    float sta1=(float)0.0;
    float lta1=(float)0.0;
    float k1=(float)0.0;
    float k2=(float)0.0;
    float R=(float)0.0;
    int s,ss;
    sta1=(float)0.0;
    lta1=(float)0.0;
    
//      System.out.println("STALTAPHFL: ne:"+ne);

    for(s=1;s<800;s++)
    {
      extra=(float)kanal[s]-(float)kanal[s-1];
      extra=extra * extra;
      k1=fabsf((float)kanal[s-1]);
      k2=k1 * k1;
      sta1=sta1+(k2+ (float)3.0*extra-sta1)/(float)ws;
      k1=fabsf((float)kanal[s]);
      k2=k1 * k1;
      lta1=lta1+(k2-lta1)/(float)wl;
    }

    for(ss=1;ss<(ne-1);ss++)
    {
      extra=(float)kanal[ss]-(float)kanal[ss-1];
      extra=extra * extra;
      k1=fabsf((float)kanal[ss-1]);
      k2=k1 * k1;
      sta1=sta1+(k2+ (float)3.0*extra-sta1)/(float)ws;
      k1=fabsf((float)kanal[ss]);
      k2=k1 * k1;
      lta1=lta1+(k2-lta1)/(float)wl;
      R=sta1/lta1;
      rat[ss]=R;
    }

  }
int FIND_P(int ant,int tot,float rati[])
{
  int indx=0;
  int tel=0;
  int k;
  float max;
  max=0.0;
  for(k=(5000-ant);k<tot;k++)
  {
//    printf("%4d  %8.2f max: %8.2f indx: %d\n",k,rati[k],max,indx);
    if(rati[k]>max)
    {
      max=rati[k];
      indx=tel;
    }
    tel++;
  }
  return(indx);
}  




/*  Subroutine to apply an iir filter to a data sequence.                   */
/*    The filter is assumed to be stored as second order sections.          */
/*    Filtering is in-place.                                                */
/*    Zero-phase (forward and reverse) is an option.                        */

void appl(int fnd)
{
    /* System generated locals */
  int      i1;
  int      i2;

    /* Local variables */
  int      jptr;
  int      i;
  int      j;
  float    b0;
  float    b1;
  float    b2;
  float    a1;
  float    a2;
  float    x1;
  float    x2;
  float    y1;
  float    y2;
  float    output;

/* Parameter adjustments                                                    */

/* Function Body                                                            */
  jptr = 1;
  i1 = cset[fnd];

  for (j = 1; j <= i1; ++j)
  {
    x1 = save_x1[fnd][j];
    x2 = save_x2[fnd][j];
    y1 = save_y1[fnd][j];
    y2 = save_y2[fnd][j];
    b0 = snc[fnd][jptr];
    b1 = snc[fnd][jptr + 1];
    b2 = snc[fnd][jptr + 2];
    a1 = sdc[fnd][jptr + 1];
    a2 = sdc[fnd][jptr + 2];
    i2 = ns[fnd];

    for (i = 0; i < i2; ++i)
    {
      output = b0 * fseismo[fnd][i] + b1 * x1 + b2 * x2;
      output -= a1 * y1 + a2 * y2;
      y2 = y1;
      y1 = output;
      x2 = x1;
      x1 = fseismo[fnd][i];
      fseismo[fnd][i] = output;
    }
    jptr += 3;

    save_y2[fnd][j]=y2;
    save_y1[fnd][j]=y1;
    save_x2[fnd][j]=x2;
    save_x1[fnd][j]=x1;
  }
}
int main(int argc, char **argv)
{
  int  idum;
  void      *shared_memory_rt = (void *)0;
  int       shmid_rt; 
  int i;
  int q;
  int p;
  int nc;
  int ix;

  
  char streamsfull[255]; 
  char strpath[255];

  pthread_t trg_mul_thread;            // definition for TRG_MUL thread
  pthread_t trg_delay_thread;          // definition for TRG_DELAY thread
  pthread_t buffer_shufle_thread;      // definition for BUFFER_SHUFLE thread
  pthread_t read_packets_thread1, read_packets_thread2, read_packets_thread3, read_packets_thread4, read_packets_thread5;       // definition for READ_PACKETS thread
  thdata data1, data2, data3, data4, data5;
  trgmul trginfo1, trginfo2, trginfo3;


    
  fl = FL_PRESET;                      // set default filter
  fh = FH_PRESET;                      // set default filter 
    
//------------------------------------------------------------------------
// set path to SEISAN_TOP as default
//------------------------------------------------------------------------
  topdir = (char*)getenv("SEISAN_TOP");
  if(topdir)
  {
    printf("RTDET: SEISAN_TOP: %s\n", topdir);    
  }else{
    printf("RTDET: SEISAN_TOP not defined.\n");
    printf("Install SEISAN !\n");
    exit(0);    
  }    
//------------------------------------------------------------------------
// set path to RTQUAKE_TOP as default
//------------------------------------------------------------------------
  topdir_rt = (char*)getenv("RTQUAKE_TOP");
  if (topdir_rt)
  {
    printf("RTDET: RTQUAKE_TOP: %s\n", topdir_rt);
  }else{
    printf("RTDET: RTQUAKE_TOP not defined\n");
    printf("Include setup_rt.bash or setup_rt.csh in your .bashrc or .csh\n");
    exit(0);      
  } 
//-------------------------------------------------------------------------
// open shared memory region                                                
//--------------------------------------------------------------------------
//  printf("Size shared module %d\n",(int)sizeof(rtmod));
  shmid_rt = shmget((key_t)5678, sizeof(rtmod), 0666 | IPC_CREAT);
  if(shmid_rt == -1)
  {
    fprintf(stderr, "RTDET: shmget failed  2\n");
    exit(EXIT_FAILURE);
  }
  shared_memory_rt = shmat(shmid_rt, (void *)0, 0);
  if(shared_memory_rt == (void *)-1)
  {
    fprintf(stderr, "RTDET: shmat failed\n");
    exit(EXIT_FAILURE);
  }
//-------------------------------------------------------------------------
// Compute pointer to shared memory region                                 
//-------------------------------------------------------------------------
  spt=(rtmod *)shared_memory_rt; 
//-------------------------------------------------------------------------
// Process command line parameters
//-------------------------------------------------------------------------
  if (parameter_proc (argc, argv) < 0)
  {
    fprintf(stderr, "RTDET: Parameter processing failed\n\n");
    fprintf(stderr, "       Try '-h' for detailed help\n");
    return -1;
  }
//--------------------------------------------------------------------------
// Initialize tables and variables
//--------------------------------------------------------------------------
  for(i=0;i<MAXCHA;i++)
  {
    for(p=0;p<MAXDLY;p++)
    {
      spt->ttdly[klon][i][p] = -1;
      trgdly[i][p] = -1.0;      
    }
  }
  for(p=0;p<MAXCHA;p++)
  {
    spt->csta[klon][p]=0.0001;            // initialize to 0.0
    spt->clta[klon][p]=0.0001;            // initialize to 0.0
    spt->dur[klon][p]=0;                  // initialize to 0
    spt->cdcavg[klon][p]=0;               // initialize to 0

    latency[p]=0;
    spt->latency[klon][p]=0;
  }
  for(p=0;p<MAXCHA;p++)
  {
    spt->tt[klon][p]=-1;                // initialize to -1
    for(q=0;q<5;q++)
    {
      spt->age[klon][p][q] = 0;        // initialize to 0
    }
  }
  for(p=0;p<QUEUE;p++)
  {
    for(q=0;q<MAXCHA;q++)
    {
      trig_flag[q] = 0;
      trig_dur[q]=0;
    }
  }
//------------------------------------------------------------------------
// read pic.def if exist, otherwise use defaults
//------------------------------------------------------------------------
  Read_Parameters(); 
//---------------------------------------------------------
// Set TIME_NOW initial value to current CPU time
//---------------------------------------------------------
  CURRENT_TIME();  
  
  main_cnd=1;                          // set conditon to WAIT
//----------------------------------------------------------------
// Start trigger thread BUFFER_SHUFLE
//----------------------------------------------------------------
  if(pthread_create(&buffer_shufle_thread,NULL,(void *)BUFFER_SHUFLE,(void *)&i))    
  {
    printf("rtdet: main Start BUFFER_SHUFLE thread failed: EXIT\n");
    abort();
  }
  while( main_cnd != 0 )               // wait for signal to go on
  {
    if(LOCK==1)
      pthread_mutex_lock(&cnd_mtx_main);
    pthread_cond_wait( &cnd_cnd_main, &cnd_mtx_main );
  }
  printf("rtdet: main Ready from BUFFER_SHUFLE to go on\n");
  printf("************************************************************************\n");
//----------------------------------------------------------------
// Read specified profile file
//----------------------------------------------------------------
  sprintf(streamsfull,"%s/par/%s/profile",topdir_rt,cfgfile); 
  printf("PROFILE: %s\n",streamsfull);
  nc =read_configfile (streamsfull);
  printf("configfile contains %2d lines.\n",nc);
  for(p=0;p<nc;p++)
    printf("%s %s %2d %5.2f %5.2f %5.2f %5.2f %5.2f %5.2f %s\n",streams[p],store[p],trgmin[p],lpf[p],hpf[p],staw[p],lta[p],trg[p],dtrg[p],slserv[p]);
//----------------------------------------------------------------
// Read streams files specified in configfile
//----------------------------------------------------------------
  printf("**************************************************************************\n");
  printf("Read input streams specified in configfile:\n");
  for(p=0;p<nc;p++)
  {
    sprintf(strpath,"%s/par/%s/%s",topdir_rt,cfgfile,streams[p]);
    printf("Read streams-file: %s\n",strpath);
    read_inputstreams(strpath,p);
  }  
  printf("total number of input-streams  stream_count: %d\n",stream_count);
 
  for(p=0;p<stream_count;p++)
    printf("%3d %s\n",p,allstreams[p]);
//------------------------------------------------------------------------------------
// Create detection tables
//------------------------------------------------------------------------------------
  printf("***************************************************************************\n");

  create_detectiontable();
  totalchannels = stream_count;
  spt->val20[klon]=totalchannels;
//---------------------------------------------------------------------------
// Read record file specified in configfile and add on seedlinkserver address
//--------------------------------------------------------------------------- 
  printf("**************************************************************************\n");
  printf("Recording streams specified in configfile:\n");

  for(p=0;p<nc;p++)
    printf("%s %s %s\n",streams[p],store[p],slserv[p]);
//  if(mintrg == 0)          // Read all recording files corresponding to the subnets
//  {  
    for(p=0;p<nc;p++)
    {
      sprintf(recpath,"%s/par/%s/%s",topdir_rt,cfgfile,store[p]);
      printf("Read record file: %s\n",recpath);
      read_recordfile (recpath,stream_count,p);
    }
//  }else{                   // Read ONLY first recording file corresponding to whole network
//      p=0;
//      sprintf(recpath,"%s/par/%s/%s",topdir_rt,cfgfile,store[p]);
//      printf("Read record file: %s\n",recpath);
//      read_recordfile (recpath,stream_count,p);    
//  }
  printf("total number of record-streams  rec_count: %2d\n",rec_count);
  for(p=0;p<rec_count;p++)
    printf("%3d %s\n",p,record[p]);

  p=0;
  fra[p] = 0;
  til[p] = kanaler_hver_stream[0];
  printf("%2d %2d %2d %2d\n",p,kanaler_hver_stream[p],fra[p],til[p]);  
  for(p=1;p<nc;p++)
  {
    fra[p] = til[p-1];
    til[p] = fra[p] + kanaler_hver_stream[p];    
    printf("%2d %2d %2d %2d\n",p,kanaler_hver_stream[p],fra[p],til[p]);
  }
  
  


//----------------------------------------------------------------
// Start threads
//----------------------------------------------------------------
  for(p=0;p<nc;p++)
  {
//----------------------------------------------------------------
// Prepare structure for threads
//----------------------------------------------------------------
    data1.thread_no = p+1;    
    strcpy(data1.ipaddr, slserv[p]);    
    strcpy(data1.streams,streams[p]);    
    strcpy(data1.stations,stations[p]);    
    data1.no_comp = 0;
      
    pthread_create (&read_packets_thread1, NULL, (void *) &READ_PACKETS, (void *) &data1);
    sleep(2);
  }
//  sleep(2);

    
/*              
  main_cnd=1;                          // set conditon to WAIT
//----------------------------------------------------------------
// Start trigger thread TRG_DELAY
//----------------------------------------------------------------
  if(pthread_create(&trg_delay_thread,NULL,(void *)TRG_DELAY,(void *)&i))    
  {
    printf("rtdet: main Start TRG_DELAY thread failed: EXIT\n");
    abort();
  }
  while( main_cnd != 0 )               // wait for signal to go on
  {
    if(LOCK==1)
      pthread_mutex_lock(&cnd_mtx_main);
    pthread_cond_wait( &cnd_cnd_main, &cnd_mtx_main );
  }
  printf("rtdet: main Ready from TRG_DELAY to go on\n");
    
*/
  
printf("MINTRG: %d\n",mintrg);
//exit(0);
  
  main_cnd=1;                          // set conditon to WAIT
//----------------------------------------------------------------
// Start trigger thread TRG_MUL
//----------------------------------------------------------------

if(mintrg == 0)                    // Start all subnet trigger threads
{  
  for(p=0;p<nc;p++)
  {
      trginfo1.thread_no           = p+1;
      trginfo1.antkan              = kanaler_hver_stream[p];
      trginfo1.fra                 = fra[p];
      trginfo1.til                 = til[p];
      trginfo1.minimum_no_triggers = trgmin[p];
      pthread_create(&trg_mul_thread, NULL, (void *) &TRG_MUL,(void *) &trginfo1);
      printf("rtdet: TRG_MUL thread: %2d started. kanaler: %2d from: %2d to: %2d\n",trginfo1.thread_no,trginfo1.antkan,trginfo1.fra,trginfo1.til);       
      sleep(1);    
  }
}else{                            // Start trigger thread to do network trigger
      trginfo1.thread_no           = 1;
      trginfo1.antkan              = stream_count;
      trginfo1.fra                 = 0;
      trginfo1.til                 = stream_count;
      trginfo1.minimum_no_triggers = mintrg;
      pthread_create(&trg_mul_thread, NULL, (void *) &TRG_MUL,(void *) &trginfo1);
      printf("rtdet: TRG_MUL thread: %2d started. kanaler: %2d from: %2d to: %2d\n",trginfo1.thread_no,trginfo1.antkan,trginfo1.fra,trginfo1.til);       
      sleep(1);      
}

  
  
  
  for(;;)                              // let main take siesta
  {
    sleep(1);
  }  
  return 0;
}				/* End of main() */



/***************************************************************************
 * packet_handler():
 * Process a received packet based on packet type.
 ***************************************************************************/
static int
packet_handler (char *msrecord, int packet_type, int seqnum, int packet_size,SLCD * slconn)
{
  static SLMSrecord * msr = NULL;
  int trace;
  double dtime;			/* Epoch time */
  double secfrac;		/* Fractional part of epoch time */
  time_t itime;			/* Integer part of epoch time */
  char timestamp[20];
  struct tm *timep;

  /* The following is dependent on the packet type values in libslink.h */
  char *type[]  = { "Data", "Detection", "Calibration", "Timing",
		    "Message", "General", "Request", "Info",
                    "Info (terminated)", "KeepAlive" };

  /* Build a current local time string */

  dtime   = sl_dtime ();
  secfrac = (double) ((double)dtime - (int)dtime);
  itime   = (time_t) dtime;
  timep   = localtime (&itime);
  sprintf (timestamp,  "%04d.%03d.%02d:%02d:%02d.%01.0f",
	    timep->tm_year + 1900, timep->tm_yday + 1, timep->tm_hour,
	    timep->tm_min, timep->tm_sec, secfrac);

  /* Process waveform data */
  if ( packet_type == SLDATA )
    {
      sl_log (0, 1, "%s, seq %d, Received %s blockette:\n",
	      timestamp, seqnum, type[packet_type]);

      sl_msr_parse (slconn->log, msrecord, &msr, 1, 0);

      if ( verbose || ppackets )
	sl_msr_print (slconn->log, msr, ppackets);
    }
  else if ( packet_type == SLKEEP )
    {
      sl_log (0, 2, "Keep alive packet received\n");
    }
  else
    {
      sl_log (0, 1, "%s, seq %d, Received %s blockette\n",
	      timestamp, seqnum, type[packet_type]);
    }

  /* Write packet to dumpfile if defined */
  if ( dumpfile )
    {
      if (fwrite (msrecord, packet_size, 1, outfile) <= 0)
	sl_log (2, 0, "fwrite(): error writing data to %s\n", dumpfile);
//      memcpy(buf,msrecord,seed_size);
	sl_msr_parse (slconn->log, msrecord, &msr, 1, 1);
//        trace=unpack_samples (msr);
        return(1);
    }
/* Plot selected data */
if( location )
{
//  printf("%s, seq %d, Received %s blockette:\n",timestamp, seqnum, type[packet_type]);
//  printf("smp:%s\n",timestamp);

  sl_msr_parse (slconn->log, msrecord, &msr, 1, 1);
  if(msr->unpackerr != MSD_UNKNOWNFORMAT)
  {
    trace=unpack_samples (msr,seqnum);
    sprintf(tid[trace],"%s",timestamp);
    return(trace);
  }else{
	printf("Trouble unpacking buffer\n");
	return(0);
  }
}
return(0);

}				/* End of packet_handler() */

/***************************************************************************
 * print_samples:
 * Print samples in the supplied MSrecord with a simple format.
 ***************************************************************************/
int
unpack_samples (SLMSrecord *msr, int seqnum)
{
  char tempo[20];
  char search[20];
  char tmp[80];
  char dd[80];

  int iryrn;
  int irday;
  int irhrn;
  int irmin;

  int j,pp;
  int retur=-1;
  int cnt,p,l,ret;
  for(j=0;j<20;j++)
    search[j]='\0';
  sprintf(tempo,"%s",msr->fsdh.station);
  strncpy(search,tempo,10);
//printf("search: %s\n",search);
//  if(search[5] == ' ')search[5]='0';
//  if(search[6] == ' ')search[6]='0';
//  printf("unpack: %3d\n",stream_count);
  for(l=0;l<stream_count;l++)
  {
//    printf("%s  %s\n",search,allstreams[l]);
    for(pp=0;pp<10;pp++)
      dd[pp]=allstreams[l][pp+3];
    dd[pp]='\0';
    ret=strcmp(search,dd);
    if(ret == 0)                   // component found
    {
//printf("FOUND\n");
      retur=l;
      if ( msr->datasamples != NULL )            //EXTRACT DATA FROM MINISEED BUFFER
      {
        ns[l]   = msr->numsamples;
        ryrn[l] = msr->fsdh.start_time.year;
        rday[l] = msr->fsdh.start_time.day;
        rhrn[l] = msr->fsdh.start_time.hour;
        rmin[l] = msr->fsdh.start_time.min;
        risec[l]= msr->fsdh.start_time.sec;
        rsecs[l]= msr->fsdh.start_time.fract; 
        sr[l]   = msr->fsdh.samprate_fact;

        iryrn=ryrn[l];
        irday=rday[l];
        irhrn=rhrn[l];
        irmin=rmin[l];

        sprintf(tmp,"%4d %3d %2d:%2d:%2d.%4d",iryrn,irday,irhrn,irmin,risec[l],rsecs[l]);
        if(tmp[21]==' ')tmp[21]='0';
        if(tmp[20]==' ')tmp[20]='0';
        if(tmp[19]==' ')tmp[19]='0';
        if(tmp[18]==' ')tmp[18]='0';
        if(tmp[15]==' ')tmp[15]='0';

//printf("%2d %2x\n",l,msr->fsdh.dq_flags);

        sprintf(rtid[l],"%s",tmp);
        sprintf(spt->rtid[klon][l],"%s",tmp);
		if(msr->fsdh.dq_flags == 0)
		{
		  time_quality[l]=0;
		}else{
		  time_quality[l]=1;
		}
   
//        printf("NS: %3d %3d %3d   %s  %s  %8d\n",ns[l],msr->fsdh.samprate_fact,msr->fsdh.samprate_mult,msr->fsdh.station,rtid[l],seqnum);
        for(pp=0;pp<22;pp++)
          if(tmp[pp]==' ')tmp[pp]='0';   
        sscanf(tmp,"%15s%f7.4",dd,&ftimea[l]);
//        printf("FTIME: %f\n",ftimea[l]);

//printf("incr: %f\n",incr[l]);
/* COMPUTE NEW FILTER COEF. EACH BUFFER. THEY MAY HAVE DIFFERENT SAMPLERATE */
        eqavst=1.0/(float)msr->fsdh.samprate_fact;
        orden=4;
        if(fl_par[l] != 0.0 && fh_par[l] != 0.0)
        {
          design(orden,"BP","BU",30.0,0.3,fl_par[l],fh_par[l],eqavst);
          for(j=0;j<(nsects*3+1);j++)
          {
            snc[l][j]=sn[j];
            sdc[l][j]=sd[j];
//      printf("%d %f %f\n",j,sn[j],sd[j]);
          }
          cset[l]=nsects;
        }
        for ( cnt = 0; cnt < ns[l]; cnt++ )      // EXTRACT DATA SAMPLES
          seismo[l][cnt]=*(msr->datasamples + cnt);
        
      return(retur);


      }    // if(msr->data.........
    }      // if(ret......
  }        // for(no_to_plot........ 
//  		if(l==14)
//			printf("unpack2 FAC:\n");
  return(retur);
}  /* End of print_samples() */

/***************************************************************************
 * parameter_proc:
 *
 * Process the command line parameters.
 *
 * Returns 0 on success, and -1 on failure
 ***************************************************************************/
int
parameter_proc (int argcount, char **argvec)
{
  int optind;
  int error = 0;
  char tm[80];  
  char streamsfull[80]; 
  char *multiselect = 0;
  char *selectors   = 0;

  if (argcount <= 1)
    error++;

  printf("argcount: %d\n",argcount);

  /* Process all command line arguments */
  for (optind = 1; optind < argcount; optind++)
  {
//    printf("OPTIND: %d\n",optind);
    if (strcmp (argvec[optind], "-V") == 0)
    {
//      fprintf(stderr, "%s version: %s\n", PACKAGE, VERSION);
      exit (0);
    }
//    else if (strcmp (argvec[optind], "-h") == 0)
//    {
//      usage();
//      exit (0);
//    }
    else if (strcmp (argvec[optind], "-prt") == 0)
    {
      printarg = atoi (argvec[++optind]);
      printf("printarg: %d\n",printarg);
    }
    else if (strcmp (argvec[optind], "-dbn") == 0)         // database name
    {
      strcpy(dbname, argvec[++optind]);
      printf("database name: %s\n",dbname);
    }
    else if (strcmp (argvec[optind], "-sfl") == 0)         // s-file path
    {
      strcpy(sfilepath, argvec[++optind]);
      printf("s-file path: %s\n",sfilepath);
    }
    else if (strcmp (argvec[optind], "-cfg") == 0)         // input config file
    {
      strcpy(cfgfile, argvec[++optind]);
      printf("Config: %s\n",cfgfile);
    }    
//    else if (strcmp (argvec[optind], "-l") == 0)           // input stream file
//    {
//      strcpy(streamfile, argvec[++optind]);
//      printf("Streams: %s\n",streamfile);
//    }
//    else if (strcmp (argvec[optind], "-f") == 0)           // detection file
//    {
//      strcpy(detfile, argvec[++optind]);
//      printf("Detection: %s\n",detfile);
//    }
//    else if (strcmp (argvec[optind], "-r") == 0)           // recording file
//    {
//      strcpy(recordfile, argvec[++optind]);
//      printf("Recording: %s\n",recordfile);
//    }
//      else if (strcmp (argvec[optind], "-k") == 0)
//	{
//	  slconn->keepalive = atoi (argvec[++optind]);
//	}
    else if (strcmp (argvec[optind], "-trg") == 0)         // minimum number of triggers
    {
      mintrg=atoi (argvec[++optind]);
      printf("mintrg= %d\n",mintrg);

    }
    else if (strcmp (argvec[optind], "-pre") == 0)         // pre-event memory in seconds
    {
      preevent = atoi (argvec[++optind]);
      printf("preevent= %d\n",preevent);
    }
    else if (strcmp (argvec[optind], "-pst") == 0)         // post-event memory in seconds
    {
      postevent = atoi (argvec[++optind]);
      printf("postevent= %d\n",postevent);
    }
//    else if (strcmp (argvec[optind], "-wnd") == 0)         // array-propagation window in seconds
//    {
//      arrwnd = atoi (argvec[++optind]);
//      printf("arrwnd= %d\n",arrwnd);
//    }
//    else if (strcmp (argvec[optind], "-dly") == 0)         // delay before retreiving data in seconds
//    {
//      waitforisdn = atoi (argvec[++optind]);
//      printf("waitforisdn= %d\n",waitforisdn);
//    }
    else if (strcmp (argvec[optind], "-par") == 0)         // parameter-set
    {
      klon = atoi(argvec[++optind]);
      printf("klon: %d\n",klon);
    }
//    else if (strcmp (argvec[optind], "-top") == 0)         // seisan top directory
//    {
//      strcpy(topdir, argvec[++optind]);
//      printf("top directory: %s\n",topdir);
//    }
    else if (strcmp (argvec[optind], "-tgg") == 0)         // events directory
    {
      dbase_switch = 1;
      strcpy(trgdir, argvec[++optind]);
      printf("events directory: %s\n",trgdir);
    }
      else if (strcmp (argvec[optind], "-aut") == 0)
	{
	  autolocate = atoi (argvec[++optind]);
          printf("autolocate: %d\n",autolocate);
	}
//      else if (strncmp (argvec[optind], "-", 1 ) == 0)
//	{
//	  fprintf(stderr, "Unknown option1: %s\n", argvec[optind]);
//	  exit (1);
//	}
//	slconn->sladdr = argvec[optind];
    }

  /* Make sure a server was specified */
//  if ( ! slconn->sladdr )
//    {
//      fprintf(stderr, "No SeedLink server specified\n\n");
//      fprintf(stderr, "Usage: %s [options] [host][:port]\n", PACKAGE);
//      fprintf(stderr, "Try '-h' for detailed help\n");
//      exit (1);
//    }

  /* Initialize the verbosity for the sl_log function */
//  sl_loginit (verbose, NULL, NULL, NULL, NULL);





  
  /* Report the program version */
//  sl_log (0, 1, "%s version: %s\n", PACKAGE, VERSION);
  
  /* If errors then report the usage message and quit */
//  if (error)
//    {
//      usage ();
//      exit (1);
//    }

  /* If verbosity is 2 or greater print detailed packet infor */
//  if ( verbose >= 2 )
//    ppackets = 1;
  
  printf("READING INPUTFILES\n");
/*******************************************************/
/*                   STREAMS                           */
/*******************************************************/  
  /* Load the stream list from a file if specified */
//  if ( strlen(streamfile) )
//  {
//    sprintf(streampath,"%s/par/%s",topdir_rt,streamfile);
//    printf("Read specified streamfile: %s\n",streampath);
//    read_print_streams(streampath);
//    printf("AAAAAAAAAAAAAAAAAAAA:      %s %s %s\n",slconn->sladdr,streampath,selectors);
//    sl_read_streamlist (slconn, streampath, selectors);
//  }else{
//    sprintf(streampath,"%s/par/streams.rtdet",topdir_rt);
//    printf("Read default streamfile: %s\n",streampath);
//    read_print_streams(streampath);
//     printf("BBBBBBBBBBBBBBBBBBB:      %s %s %s\n",slconn->sladdr,streampath,selectors);   
//    sl_read_streamlist (slconn, streampath, selectors);
//  }
/*******************************************************/
/*                   RECORD STREAMS                    */
/*******************************************************/ 
  /* Load the record list from a file if specified */
/*
  if ( strlen(recordfile) )
  {
    sprintf(recpath,"%s/par/%s",topdir_rt,recordfile);
    printf("Read specified rec_streams file: %s\n",recpath);
    tu_read_recordlist (recpath);
  }else{
    sprintf(recpath,"%s/par/rec_streams.rtdet",topdir_rt);
    printf("Read default rec_streams file: %s\n",recpath);
    tu_read_recordlist (recpath);
  }
*/  
/*******************************************************/
/*                   DETECTION STREAMS                 */
/*******************************************************/ 
  /* Load the station list from a file if specified */
//  if ( strlen(detfile) )
//  {
//    sprintf(detpath,"%s/par/%s/%s",topdir_rt,cfgfile,detfile);
//    printf("Read specified det_streams file: %s\n",detpath);
//    tu_read_stationlist (detpath);
//  }else{
//    sprintf(detpath,"%s/par/det_streams.rtdet",topdir_rt);
//    printf("Read default det_streams file: %s\n",detpath);
//    tu_read_stationlist (detpath);
//  }
//  sprintf(detection_file,"%s",detpath);
/*******************************************************/
/*                   EVENTS PATH                       */
/*******************************************************/
//  if(strlen(trgdir)
//  {
//    printf("Specified events directory: %s\n",trgdir);
//  }else{
//    sprintf(trgdir,"WOR");
//    printf("Default events directory: %s\n",trgdir);
//  } 
  if ( strlen(trgdir) )
  {
    sprintf(trgpath,"%s/%s",topdir,trgdir);
    printf("Specified events path: %s\n",trgpath);
  }else{
    sprintf(trgpath,"%s/WAV",topdir);
    printf("Default events path: %s\n",trgpath);
  }
/*******************************************************/
/*                SEISAN DATABASE NAME                 */
/*******************************************************/ 
  if ( strlen(dbname) )
  {
    printf("Specified database name: %s\n",dbname);
  }else{
    sprintf(streamsfull,"TST__");
    strcpy(dbname, streamsfull);
    printf("Default database name: %s\n",dbname);
  }
/*******************************************************/
/*                SEISAN S-FILE PATH                   */
/*******************************************************/ 
  if ( strlen(sfilepath) )
  {
    sprintf(streamsfull,"%s",sfilepath);
    strcpy(sfilepath, streamsfull);
    printf("Specified s-file path: %s\n",sfilepath);
  }else{
    sprintf(streamsfull,"%s/REA",topdir);
    strcpy(sfilepath, streamsfull);
    printf("Default s-file path: %s\n",sfilepath);
  }
  

  
  return 0;
}				/* End of parameter_proc() */

//*=========================================================================      
//*                                                                               
//* Routine to convert from day-of-year to date                                   
//*                                                         Leif Kvamme 12-1-85   
void DTE (DOY,DAY,MON,YR)                                          
int DOY;
int *DAY;
int *MON;
int YR;
{
int MTH[14],J,M,N;
for(J=1;J<8;J=J+2)
    MTH[J] = 31;
for(J=8;J<13;J=J+2)
    MTH[J] = 31;
MTH[2] = 28;
MTH[4] = 30;
MTH[6] = 30;
MTH[9] = 30;
MTH[11]= 30;
if ((YR%4) == 0) MTH[2] = 29;
M = 0;                                                                    
for(J=1;J<13;J++)
{
    M = M + MTH[J];
    N = DOY - M;                                                              
    if (N <= 0)
    {                                                       
        *MON = J;
        *DAY = N + MTH[J];                                                     
        goto four;                                                               
    }
}
four:                                                                   
J=0;
}
void TIMSEC (YR,MTH,DAY,HR,MIN,SECS,MSECS)                         
int YR;
int MTH;
int DAY;
int HR;
int MIN;
float SECS;
double *MSECS;                         /* total seconds to be returned      */
{
int DYR;                               /* flag for leap year                */
int IYR;                               /* number of leap-years since 1900   */
int YDY;                               /* number of days in current year    */

if(YR <= 50) YR=YR+100;                /* check for 2000 or more in 2 digits*/

if(YR >= 1900) YR=YR - 1900;
DYR = 0;
if((YR % 4) == 0) DYR = 1;
IYR = YR/4 - DYR;
//                -- Seconds to beginning of     
*MSECS = (float)(IYR*366) + (float)((YR-IYR)*365);
//                -- current year                
*MSECS = *MSECS*86400.0;
//                -- January                     
if (MTH == 1) YDY = DAY;
//                -- February                    
if (MTH == 2) YDY = DAY + 31;
//                -- ....                        
if (MTH == 3) YDY = DAY + DYR + 59;       
if (MTH == 4) YDY = DAY + DYR + 90;                                     
if (MTH == 5) YDY = DAY + DYR + 120;                                    
if (MTH == 6) YDY = DAY + DYR + 151;                                    
if (MTH == 7) YDY = DAY + DYR + 181;                                    
if (MTH == 8) YDY = DAY + DYR + 212;                                    
if (MTH == 9) YDY = DAY + DYR + 243;                                    
if (MTH ==10) YDY = DAY + DYR + 273;                                    
if (MTH ==11) YDY = DAY + DYR + 304;                                    
if (MTH ==12) YDY = DAY + DYR + 334;                                    
*MSECS = *MSECS + (float)(YDY*86400 + HR*3600 + MIN*60) + SECS;
}
/*  Subroutine to design IIR digital filters from analog prototypes. */
/*  Input Arguments: */
/*  ---------------- */
/*    IORD                Filter order (10 MAXIMUM) */
/*    TYPE                Character*2 variable containing filter type */
/*                          LOWPASS (LP) */
/*                          HIGHPASS (HP) */
/*                          BANDPASS (BP) */
/*                          BANDREJECT (BR) */
/*   APROTO              Character*2 variable designating analog prototype*/
/*                          Butterworth (BU) */
/*                          Bessel (BE) */
/*                          Chebyshev Type I (C1) */
/*                          Chebyshev Type II (C2) */
/*    A                   Chebyshev stopband attenuation factor */
/*    TRBNDW              Chebyshev transition bandwidth (fraction of */
/*                          lowpass prototype passband width) */
/*    FL                  Low-frequency cutoff */
/*    FH                  High-frequency cutoff */
/*    TS                  Sampling interval (in seconds) */
/*  Output Arguments: */
/*  ----------------- */
/*    SN                  Array containing numerator coefficients of */
/*                        second-order sections packed head-to-tail. */
/*    SD                  Array containing denominator coefficients */
/*                        of second-order sections packed head-to-tail. */

void design( iord, type,aproto,  a,trbndw,  fl,  fh,  ts)
int iord;
char *type;
char *aproto;
float a;
float trbndw;
float fl;
float fh;
float ts;
{
    /* System generated locals */
    float r__1;

    /* Local variables */
    complex p[10], z[10];
    char stype[3*10];
    float omegar, ripple;
    float fhw, eps, flw, dcvalue;

    /*  Analog prototype selection */

    if (strncmp(aproto, "BU", 2) == 0) {
    buroots(p, stype, &dcvalue, iord);
    } else if (strncmp(aproto, "BE", 2) == 0) {
    beroots(p, stype, &dcvalue, iord);
    } else if (strncmp(aproto, "C1", 2) == 0) {
    chebparm(a, trbndw, iord, &eps, &ripple);
    c1roots(p, stype, &dcvalue, iord, &eps);
    } else if (strncmp(aproto, "C2", 2) == 0) {
    omegar = trbndw + (float)1.;
    c2roots(p, z, stype, &dcvalue, iord, a, omegar);
    }

    /*  Analog mapping selection */

    if (strncmp(type, "BP", 2) == 0) {
    r__1 = fl * ts / (float)2.;
    flw = warp(&r__1, &c_b12);
    r__1 = fh * ts / (float)2.;
    fhw = warp(&r__1, &c_b12);
    lptbp(p, z, stype, &dcvalue, &flw, &fhw);
    } else if (strncmp(type, "BR", 2) == 0) {
    r__1 = fl * ts / (float)2.;
    flw = warp(&r__1, &c_b12);
    r__1 = fh * ts / (float)2.;
    fhw = warp(&r__1, &c_b12);
    lptbr(p, z, stype, &dcvalue, &flw, &fhw, &sn[1], &sd[1]);
    } else if (strncmp(type, "LP", 2) == 0) {
    r__1 = fh * ts / (float)2.;
    fhw = warp(&r__1, &c_b12);
    lp(p, z, stype, &dcvalue, &sn[1], &sd[1]);
    cutoffs(&sn[1], &sd[1], &fhw);
    } else if (strncmp(type, "HP", 2) == 0) {
    r__1 = fl * ts / (float)2.;
    flw = warp(&r__1, &c_b12);
    lpthp(p, z, stype, &dcvalue, &sn[1], &sd[1]);
    cutoffs(&sn[1], &sd[1], &flw);
    }

    /*  Bilinear analog to digital transformation */
    bilin2(&sn[1], &sd[1]);

    return;
}

/* BUROOTS -- SUBROUTINE TO COMPUTE BUTTERWORTH POLES FOR */
/*   NORMALIZED LOWPASS FILTER */
/* LAST MODIFIED:  SEPTEMBER 7, 1990 */
/*  OUTPUT ARGUMENTS: */
/*  ----------------- */
/*      P              COMPLEX ARRAY CONTAINING POLES */
/*                       CONTAINS ONLY ONE FROM EACH */
/*                       COMPLEX CONJUGATE PAIR, AND */
/*                       ALL REAL POLES */
/*      RTYPE          CHARACTER ARRAY INDICATING 2ND ORDER SECTION */
/*                       TYPE: */
/*                         (SP)  SINGLE REAL POLE */
/*                         (CP)  COMPLEX CONJUGATE POLE PAIR */
/*                         (CPZ) COMPLEX CONJUGATE POLE-ZERO PAIRS */
/*      DCVALUE        MAGNITUDE OF FILTER AT ZERO FREQUENCY */
/*  INPUT ARGUMENTS: */
/*  ---------------- */
/*      IORD           DESIRED FILTER ORDER */
int buroots(p,rtype, dcvalue, iord)
complex *p;
char *rtype;
float *dcvalue;
int iord;
{
    /* System generated locals */
    int i__1, i__2;
    double d__1, d__2;
    complex q__1;

    /* Local variables */
    int half, k;
    float angle, pi;

    /* Parameter adjustments */
    rtype -= 3;
    --p;

    /* Function Body */
    pi = (float)3.14159265;

    half = iord / 2;

    /* TEST FOR ODD ORDER, AND ADD POLE AT -1 */

    nsects = 0;
    if (half << 1 < iord) {
    p[1].r = (float)-1., p[1].i = (float)0.;
    strncpy(rtype + 3, "SP", 2);
    nsects = 1;
    }
    i__1 = half;
    for (k = 1; k <= i__1; ++k) {
    angle = pi * ((float) ((k << 1) - 1)/(float) (iord << 1)+(float).5);
    ++(nsects);
    i__2 = nsects;
    d__1 = cos(angle);
    d__2 = sin(angle);
    q__1.r = d__1, q__1.i = d__2;
    p[i__2].r = q__1.r, p[i__2].i = q__1.i;
        strncpy(rtype + nsects * 3, "CP", 2);
    }
    *dcvalue = (float)1.;
    return TRUE;
}

/*  CHEBPARM - Calculates Chebyshev type I and II design parameters */
/*  INPUT ARGUMENTS */
/*  --------------- */
/*       A                Desired stopband attenuation */
/*                          i.e. max stopband amplitude is 1/ATTEN */
/*       TRBNDW           Transition bandwidth between stop and passbands */
/*                          as a fraction of the passband width */
/*       IORD             Filter order (number of poles) */
/*  OUTPUT ARGUMENTS */
/*  ---------------- */
/*       EPS              Chebyshev passband parameter */
/*       RIPPLE           Passband ripple */

static int chebparm(a, trbndw, iord, eps, ripple)
float a, trbndw;
int iord;
float *eps, *ripple;
{
    /* System generated locals */
    float r__1, r__2;

    /* Local variables */
    float g, alpha, omegar;

    omegar = trbndw + 1.;
    /* Computing 2nd power */
    r__2 = omegar;
    r__1 = omegar + sqrt(r__2 * r__2 - 1.);
    alpha = pow((double)r__1, (double)iord);
    /* Computing 2nd power */
    r__1 = alpha;
    g = (r__1 * r__1 + (float)1.) / (alpha * (float)2.);
    /* Computing 2nd power */
    r__1 = a;
    *eps = sqrt(r__1 * r__1 - (float)1.) / g;
    /* Computing 2nd power */
    r__1 = *eps;
    *ripple = (float)1. / sqrt(r__1 * r__1 + (float)1.);

    return TRUE;
}

/* C1ROOTS -- SUBROUTINE TO COMPUTE CHEBYSHEV TYPE I POLES FOR */
/*   NORMALIZED LOWPASS FILTER */
/* LAST MODIFIED:  SEPTEMBER 7, 1990 */
/*  OUTPUT ARGUMENTS: */
/*  ----------------- */
/*      P              COMPLEX ARRAY CONTAINING POLES */
/*                       CONTAINS ONLY ONE FROM EACH */
/*                       COMPLEX CONJUGATE PAIR, AND */
/*                       ALL REAL POLES */
/*      RTYPE          CHARACTER ARRAY INDICATING 2ND ORDER SECTION */
/*                       TYPE: */
/*                         (SP)  SINGLE REAL POLE */
/*                         (CP)  COMPLEX CONJUGATE POLE PAIR */
/*                         (CPZ) COMPLEX CONJUGATE POLE-ZERO PAIRS */
/*      DCVALUE        RESPONSE OF FILTER AT ZERO FREQUENCY */
/*  INPUT ARGUMENTS: */
/*  ---------------- */
/*      IORD           DESIRED FILTER ORDER */
/*      EPS            CHEBYSHEV PAR RELATED TO PASSBAND RIPPLE */

static int c1roots(p, rtype, dcvalue, iord, eps)
complex *p;
char *rtype;
float *dcvalue;
int iord;
float *eps;
{
    /* System generated locals */
    int i__1, i__2;
    float r__1;
    double d__1;
    complex q__1;

    /* Local variables */
    int half;
    float c;
    int i;
    float gamma, s, angle, omega, sigma, pi;

    /* Parameter adjustments */
    rtype -= 3;
    --p;

    /* Function Body */
    pi = (float)3.14159265;
    half = iord / 2;

    /*  INTERMEDIATE DESIGN PARS */

    gamma = (sqrt(*eps * *eps + (float)1.) + (float)1.) / *eps;
    gamma = log(gamma) / (float) (iord);
    gamma = exp(gamma);
    s = (gamma - (float)1. / gamma) * (float).5;
    c = (gamma + (float)1. / gamma) * (float).5;

    /*  CALCULATE POLES */

    nsects = 0;
    i__1 = half;
    for (i = 1; i <= i__1; ++i) {
    strncpy(rtype + i * 3, "CP", 2);
    angle = (float) ((i << 1) - 1) * pi / (float) (iord << 1);
    sigma = -(double)s * sin(angle);
    omega = c * cos(angle);
    i__2 = i;
    q__1.r = sigma, q__1.i = omega;
    p[i__2].r = q__1.r, p[i__2].i = q__1.i;
    ++(nsects);
    }
    if (half << 1 < iord) {
    strncpy(rtype + (half + 1) * 3, "SP", 2);
    i__1 = half + 1;
    d__1 = -(double)s;
    q__1.r = d__1, q__1.i = (float)0.;
    p[i__1].r = q__1.r, p[i__1].i = q__1.i;
    ++(nsects);
    *dcvalue = (float)1.;
    } else {
    /* Computing 2nd power */
    r__1 = *eps;
    *dcvalue = (float)1. / sqrt(r__1 * r__1 + 1);
    }
    return TRUE;
}

/* C2ROOTS -- SUBROUTINE TO COMPUTE ROOTS FOR NORMALIZED LOWPASS */
/*   CHEBYSHEV TYPE 2 FILTER */
/* LAST MODIFIED:  SEPTEMBER 7, 1990 */
/*  OUTPUT ARGUMENTS: */
/*  ----------------- */
/*      P              COMPLEX ARRAY CONTAINING POLES */
/*                       CONTAINS ONLY ONE FROM EACH */
/*                       COMPLEX CONJUGATE PAIR, AND */
/*                       ALL REAL POLES */
/*      Z              COMPLEX ARRAY CONTAINING ZEROS */
/*                       CONTAINS ONLY ONE FROM EACH */
/*                       COMPLEX CONJUGATE PAIR, AND */
/*                       ALL REAL ZEROS */
/*      RTYPE          CHARACTER ARRAY INDICATING 2ND ORDER SECTION */
/*                       TYPE: */
/*                         (SP)  SINGLE REAL POLE */
/*                         (CP)  COMPLEX CONJUGATE POLE PAIR */
/*                         (CPZ) COMPLEX CONJUGATE POLE-ZERO PAIRS */
/*      DCVALUE        MAGNITUDE OF FILTER AT ZERO FREQUENCY */
/*  INPUT ARGUMENTS: */
/*  ---------------- */
/*      IORD           DESIRED FILTER ORDER */
/*      A              STOPBAND ATTENUATION FACTOR */
/*      OMEGAR         CUTOFF FREQUENCY OF STOPBAND */
/*                     PASSBAND CUTOFF IS AT 1.0 HERTZ */

static int c2roots(p, z, rtype, dcvalue, iord, a, omegar)
complex *p, *z;
char *rtype;
float *dcvalue;
int iord;
float a, omegar;
{
    /* System generated locals */
    int i__1, i__2;
    double d__1;
    complex q__1;

    /* Local variables */
    int half;
    float beta, c;
    int i;
    float gamma, s, alpha, angle, omega, sigma, denom, pi;

    /* Parameter adjustments */
    rtype -= 3;
    --z;
    --p;

    /* Function Body */
    pi = (float)3.14159265;
    half = iord / 2;

/*  INTERMEDIATE DESIGN PARS */

    gamma = a + sqrt(a * a - (float)1.);
    gamma = log(gamma) / (float) (iord);
    gamma = exp(gamma);
    s = (gamma - (float)1. / gamma) * (float).5;
    c = (gamma + (float)1. / gamma) * (float).5;
    nsects = 0;
    i__1 = half;
    for (i = 1; i <= i__1; ++i) {

/*  CALCULATE POLES */

    strncpy(rtype + i * 3, "CPZ", 3);
    angle = (float) ((i << 1) - 1) * pi / (float) (iord << 1);
    alpha = -(double)s * sin(angle);
    beta = c * cos(angle);
    denom = alpha * alpha + beta * beta;
    sigma = omegar * alpha / denom;
    omega = -(double)(omegar) * beta / denom;
    i__2 = i;
    q__1.r = sigma, q__1.i = omega;
    p[i__2].r = q__1.r, p[i__2].i = q__1.i;

/*  CALCULATE ZEROS */

    omega = omegar / cos(angle);
    i__2 = i;
    q__1.r = (float)0., q__1.i = omega;
    z[i__2].r = q__1.r, z[i__2].i = q__1.i;
    ++(nsects);
    }

/*  ODD-ORDER FILTERS */

    if (half << 1 < iord) {
    strncpy(rtype + (half + 1) * 3, "SP", 2);
    i__1 = half + 1;
    d__1 = -(double)(omegar) / s;
    q__1.r = d__1, q__1.i = (float)0.;
    p[i__1].r = q__1.r, p[i__1].i = q__1.i;
    ++(nsects);
    }

/*  DC VALUE */

    *dcvalue = 1.;
    return TRUE;
}

/* Subroutine to convert an prototype lowpass filter to a bandpass filter via
*/
/*    the analog polynomial transformation.  The lowpass filter is */
/*   described in terms of its poles and zeros (as input to this routine).*/
/*    The output consists of the parameters for second order sections. */
/*  Input Arguments: */
/*  ---------------- */
/*    P                       Array containing poles */
/*    Z                       Array containing zeros */
/*    RTYPE                   Character array containing type information */
/*                              (SP) single real pole  or */
/*                              (CP) complex conjugate pole pair  or */
/*                              (CPZ) complex conjugate pole/zero pairs */
/*    DCVALUE                 Zero frequency value of filter */
/*    FL                      Low-frequency cutoff */
/*    FH                      High-frequency cutoff */
/*  Output Arguments: */
/*  ----------------- */
/*    SN                      Numerator polynomials for second order */
/*                              sections. */
/*    SD                      Denominator polynomials for second order */
/*                              sections. */
/*                              This subroutine doubles the number of */
/*                              sections. */

static int lptbp(p, z, rtype, dcvalue, fl, fh)
complex *p, *z;
char *rtype;
float *dcvalue;
float *fl, *fh;
{
    /* System generated locals */
    int i__1, i__2, i__3, i__4, i__5, i__6, i__7;
    double d__1;
    complex q__1, q__2, q__3, q__4, q__5, q__6, q__7, q__8, q__9, q__10;

    /* Local variables */
    int iptr;
    float a, b;
    complex h;
    int i, n;
    complex s;
    float scale;
    complex ctemp, p1, p2;
    float twopi;
    complex z1, z2;
    float pi;

    /* Parameter adjustments */
    rtype -= 3;
    --z;
    --p;

    /* Function Body */
    pi = (float)3.14159265;
    twopi = pi * (float)2.;
    a = twopi * twopi * *fl * *fh;
    b = twopi * (*fh - *fl);

    n = nsects;
    nsects = 0;
    iptr = 1;
    i__1 = n;
    for (i = 1; i <= i__1; ++i) {
    if (strncmp(rtype + i * 3, "CPZ", 3) == 0) {
        i__2 = i;
        q__3.r = b * z[i__2].r, q__3.i = b * z[i__2].i;
            q__2 = cpowi(q__3, 2);
        d__1 = a * (float)4.;
        q__1.r = q__2.r - d__1, q__1.i = q__2.i;
        ctemp.r = q__1.r, ctemp.i = q__1.i;
            q__1 = csqrt1(ctemp);
        ctemp.r = q__1.r, ctemp.i = q__1.i;
        i__2 = i;
        q__3.r = b * z[i__2].r, q__3.i = b * z[i__2].i;
        q__2.r = q__3.r + ctemp.r, q__2.i = q__3.i + ctemp.i;
        q__1.r = q__2.r * (float).5, q__1.i = q__2.i * (float).5;
        z1.r = q__1.r, z1.i = q__1.i;
        i__2 = i;
        q__3.r = b * z[i__2].r, q__3.i = b * z[i__2].i;
        q__2.r = q__3.r - ctemp.r, q__2.i = q__3.i - ctemp.i;
        q__1.r = q__2.r * (float).5, q__1.i = q__2.i * (float).5;
        z2.r = q__1.r, z2.i = q__1.i;
        i__2 = i;
        q__3.r = b * p[i__2].r, q__3.i = b * p[i__2].i;
            q__2 = cpowi(q__3, 2);
        d__1 = a * (float)4.;
        q__1.r = q__2.r - d__1, q__1.i = q__2.i;
        ctemp.r = q__1.r, ctemp.i = q__1.i;
            q__1 = csqrt1(ctemp);
        ctemp.r = q__1.r, ctemp.i = q__1.i;
        i__2 = i;
        q__3.r = b * p[i__2].r, q__3.i = b * p[i__2].i;
        q__2.r = q__3.r + ctemp.r, q__2.i = q__3.i + ctemp.i;
        q__1.r = q__2.r * (float).5, q__1.i = q__2.i * (float).5;
        p1.r = q__1.r, p1.i = q__1.i;
        i__2 = i;
        q__3.r = b * p[i__2].r, q__3.i = b * p[i__2].i;
        q__2.r = q__3.r - ctemp.r, q__2.i = q__3.i - ctemp.i;
        q__1.r = q__2.r * (float).5, q__1.i = q__2.i * (float).5;
        p2.r = q__1.r, p2.i = q__1.i;
            q__2 = conjg(z1);
        q__1.r = z1.r * q__2.r - z1.i * q__2.i, q__1.i = z1.r * q__2.i +
            z1.i * q__2.r;
        sn[iptr] = q__1.r;
        sn[iptr + 1] = z1.r * (float)-2.;
        sn[iptr + 2] = (float)1.;
            q__2 = conjg(p1);
        q__1.r = p1.r * q__2.r - p1.i * q__2.i, q__1.i = p1.r * q__2.i +
            p1.i * q__2.r;
        sd[iptr] = q__1.r;
        sd[iptr + 1] = p1.r * (float)-2.;
        sd[iptr + 2] = (float)1.;
        iptr += 3;
            q__2 = conjg(z2);
        q__1.r = z2.r * q__2.r - z2.i * q__2.i, q__1.i = z2.r * q__2.i +
            z2.i * q__2.r;
        sn[iptr] = q__1.r;
        sn[iptr + 1] = z2.r * (float)-2.;
        sn[iptr + 2] = (float)1.;
            q__2 = conjg(p2);
        q__1.r = p2.r * q__2.r - p2.i * q__2.i, q__1.i = p2.r * q__2.i +
            p2.i * q__2.r;
        sd[iptr] = q__1.r;
        sd[iptr + 1] = p2.r * (float)-2.;
        sd[iptr + 2] = (float)1.;
        iptr += 3;
        nsects += 2;
    } else if (strncmp(rtype + i * 3, "CP", 2) == 0) {
        i__2 = i;
        q__3.r = b * p[i__2].r, q__3.i = b * p[i__2].i;
            q__2 = cpowi(q__3, 2);
        d__1 = a * (float)4.;
        q__1.r = q__2.r - d__1, q__1.i = q__2.i;
        ctemp.r = q__1.r, ctemp.i = q__1.i;
            q__1 = csqrt1(ctemp);
        ctemp.r = q__1.r, ctemp.i = q__1.i;
        i__2 = i;
        q__3.r = b * p[i__2].r, q__3.i = b * p[i__2].i;
        q__2.r = q__3.r + ctemp.r, q__2.i = q__3.i + ctemp.i;
        q__1.r = q__2.r * (float).5, q__1.i = q__2.i * (float).5;
        p1.r = q__1.r, p1.i = q__1.i;
        i__2 = i;
        q__3.r = b * p[i__2].r, q__3.i = b * p[i__2].i;
        q__2.r = q__3.r - ctemp.r, q__2.i = q__3.i - ctemp.i;
        q__1.r = q__2.r * (float).5, q__1.i = q__2.i * (float).5;
        p2.r = q__1.r, p2.i = q__1.i;
        sn[iptr] = (float)0.;
        sn[iptr + 1] = b;
        sn[iptr + 2] = (float)0.;
            q__2 = conjg(p1);
        q__1.r = p1.r * q__2.r - p1.i * q__2.i, q__1.i = p1.r * q__2.i +
            p1.i * q__2.r;
        sd[iptr] = q__1.r;
        sd[iptr + 1] = p1.r * (float)-2.;
        sd[iptr + 2] = (float)1.;
        iptr += 3;
        sn[iptr] = (float)0.;
        sn[iptr + 1] = b;
        sn[iptr + 2] = (float)0.;
            q__2 = conjg(p2);
        q__1.r = p2.r * q__2.r - p2.i * q__2.i, q__1.i = p2.r * q__2.i +
            p2.i * q__2.r;
        sd[iptr] = q__1.r;
        sd[iptr + 1] = p2.r * (float)-2.;
        sd[iptr + 2] = (float)1.;
        iptr += 3;
        nsects += 2;
    } else if (strncmp(rtype + i * 3, "SP", 2) == 0) {
        sn[iptr] = (float)0.;
        sn[iptr + 1] = b;
        sn[iptr + 2] = (float)0.;
        sd[iptr] = a;
        i__2 = i;
        sd[iptr + 1] = -(double)b * p[i__2].r;
        sd[iptr + 2] = (float)1.;
        iptr += 3;
        ++(nsects);
    }
    }
/* Scaling - use fact that the bandpass filter amplitude at sqrt( omega_l **/
/*            equals the amplitude of the lowpass prototype at d.c. */
    d__1 = sqrt(a);
    q__1.r = (float)0., q__1.i = d__1;
    s.r = q__1.r, s.i = q__1.i;
    h.r = (float)1., h.i = (float)0.;

    iptr = 1;
    i__1 = nsects;
    for (i = 1; i <= i__1; ++i) {
    i__2 = iptr + 2;
    q__6.r = sn[i__2] * s.r, q__6.i = sn[i__2] * s.i;
    i__3 = iptr + 1;
    q__5.r = q__6.r + sn[i__3], q__5.i = q__6.i;
    q__4.r = q__5.r * s.r - q__5.i * s.i, q__4.i = q__5.r * s.i + q__5.i *
         s.r;
    i__4 = iptr;
    q__3.r = q__4.r + sn[i__4], q__3.i = q__4.i;
    q__2.r = h.r * q__3.r - h.i * q__3.i, q__2.i = h.r * q__3.i + h.i *
        q__3.r;
    i__5 = iptr + 2;
    q__10.r = sd[i__5] * s.r, q__10.i = sd[i__5] * s.i;
    i__6 = iptr + 1;
    q__9.r = q__10.r + sd[i__6], q__9.i = q__10.i;
    q__8.r = q__9.r * s.r - q__9.i * s.i, q__8.i = q__9.r * s.i + q__9.i *
         s.r;
    i__7 = iptr;
    q__7.r = q__8.r + sd[i__7], q__7.i = q__8.i;
        q__1 = cdiv(q__2, q__7);
    h.r = q__1.r, h.i = q__1.i;
    iptr += 3;
    }
    q__2.r = *dcvalue, q__2.i = (float)0.;
    d__1 = h.r;
    q__5 = conjg(h);
    q__4.r = d__1 * q__5.r, q__4.i = d__1 * q__5.i;
    q__3 = csqrt1(q__4);
    q__1 = cdiv(q__2, q__3);
    scale = q__1.r;
    sn[1] *= scale;
    sn[2] *= scale;
    sn[3] *= scale;
    return TRUE;
}

/*  Subroutine to generate second order section parameterization */
/*    from an pole-zero description for lowpass filters. */
/*  Input Arguments: */
/*  ---------------- */
/*    P                       Array containing poles */
/*    Z                       Array containing zeros */
/*   RTYPE                   Character array containing root type information
*/
/*                              (SP)  Single pole or */
/*                              (CP)  Complex conjugate pole pair */
/*                             (CPZ) Complex conjugate pole and zero pairs*/
/*    DCVALUE                 Zero-frequency value of prototype filter */
/*  Output Arguments: */
/*  ----------------- */
/*    SN                      Numerator polynomials for second order */
/*                              sections. */
/*    SD                      Denominator polynomials for second order */
/*                              sections. */

static int lp(p, z, rtype, dcvalue, sn, sd)
complex *p, *z;
char *rtype;
float *dcvalue;
float *sn, *sd;
{
    /* System generated locals */
    int i__1, i__2, i__3;
    complex q__1, q__2, q__3, q__4;

    /* Local variables */
    int iptr, i;
    float scale;

    /* Parameter adjustments */
    --sd;
    --sn;
    rtype -= 3;
    --z;
    --p;

    /* Function Body */
    iptr = 1;
    i__1 = nsects;
    for (i = 1; i <= i__1; ++i) {
    if (strncmp(rtype + i * 3, "CPZ", 3) == 0) {
        i__2 = i;
        q__2 = conjg(p[i]);
        q__1.r = p[i__2].r * q__2.r - p[i__2].i * q__2.i, q__1.i = p[i__2]
            .r * q__2.i + p[i__2].i * q__2.r;
        i__3 = i;
        q__4 = conjg(z[i]);
        q__3.r = z[i__3].r * q__4.r - z[i__3].i * q__4.i, q__3.i = z[i__3]
            .r * q__4.i + z[i__3].i * q__4.r;
        scale = q__1.r / q__3.r;
        i__2 = i;
        q__2 = conjg(z[i]);
        q__1.r = z[i__2].r * q__2.r - z[i__2].i * q__2.i, q__1.i = z[i__2]
            .r * q__2.i + z[i__2].i * q__2.r;
        sn[iptr] = q__1.r * scale;
        i__2 = i;
        sn[iptr + 1] = z[i__2].r * (float)-2. * scale;
        sn[iptr + 2] = scale * (float)1.;
        i__2 = i;
        q__2 = conjg(p[i]);
        q__1.r = p[i__2].r * q__2.r - p[i__2].i * q__2.i, q__1.i = p[i__2]
            .r * q__2.i + p[i__2].i * q__2.r;
        sd[iptr] = q__1.r;
        i__2 = i;
        sd[iptr + 1] = p[i__2].r * (float)-2.;
        sd[iptr + 2] = (float)1.;
        iptr += 3;
    } else if (strncmp(rtype + i * 3, "CP", 2) == 0) {
        i__2 = i;
        q__2 = conjg(p[i]);
        q__1.r = p[i__2].r * q__2.r - p[i__2].i * q__2.i, q__1.i = p[i__2]
            .r * q__2.i + p[i__2].i * q__2.r;
        scale = q__1.r;
        sn[iptr] = scale;
        sn[iptr + 1] = (float)0.;
        sn[iptr + 2] = (float)0.;
        i__2 = i;
        q__2 = conjg(p[i]);
        q__1.r = p[i__2].r * q__2.r - p[i__2].i * q__2.i, q__1.i = p[i__2]
            .r * q__2.i + p[i__2].i * q__2.r;
        sd[iptr] = q__1.r;
        i__2 = i;
        sd[iptr + 1] = p[i__2].r * (float)-2.;
        sd[iptr + 2] = (float)1.;
        iptr += 3;
    } else if (strncmp(rtype + i * 3, "SP", 2) == 0) {
        i__2 = i;
        scale = -(double)p[i__2].r;
        sn[iptr] = scale;
        sn[iptr + 1] = (float)0.;
        sn[iptr + 2] = (float)0.;
        i__2 = i;
        sd[iptr] = -(double)p[i__2].r;
        sd[iptr + 1] = (float)1.;
        sd[iptr + 2] = (float)0.;
        iptr += 3;
    }
    }
    sn[1] = *dcvalue * sn[1];
    sn[2] = *dcvalue * sn[2];
    sn[3] = *dcvalue * sn[3];
    return TRUE;
}

/*  Subroutine to convert a lowpass filter to a band reject filter */
/*    via an analog polynomial transformation.  The lowpass filter is */
/*   described in terms of its poles and zeros (as input to this routine).*/
/*    The output consists of the parameters for second order sections. */
/*  Input Arguments: */
/*  ---------------- */
/*    P                       Array containing poles */
/*    Z                       Array containing zeros */
/*    RTYPE                   Character array containing type information */
/*                              (SP)  single real pole or */
/*                              (CP)  complex conjugate pole pair */
/*                              (CPZ) complex conjugate pole/zero pairs */
/*    DCVALUE                 Zero-frequency value of prototype filter */
/*                              prior to transformation */
/*    FL                      Low-frequency cutoff */
/*    FH                      High-frequency cutoff */
/*  Output Arguments: */
/*  ----------------- */
/*    SN                      Numerator polynomials for second order */
/*                              sections. */
/*    SD                      Denominator polynomials for second order */
/*                              sections. */
/*    NSECTS                  Number of second order sections following */
/*                              transformation.  The number is doubled. */

static int lptbr(p, z, rtype, dcvalue, fl, fh, sn, sd)
complex *p, *z;
char *rtype;
float *dcvalue;
float *fl, *fh, *sn, *sd;
{
    /* System generated locals */
    int i__1, i__2;
    double d__1;
    complex q__1, q__2, q__3;

    /* Local variables */
    complex cinv;
    int iptr;
    float a, b, h;
    int i, n;
    float scale;
    complex ctemp, p1, p2;
    float twopi;
    complex z1, z2;
    float pi;

    /* Parameter adjustments */
    --sd;
    --sn;
    rtype -= 3;
    --z;
    --p;

    /* Function Body */
    pi = (float)3.14159265;
    twopi = pi * (float)2.;
    a = twopi * twopi * *fl * *fh;
    b = twopi * (*fh - *fl);
    n = nsects;
    nsects = 0;
    iptr = 1;
    i__1 = n;
    for (i = 1; i <= i__1; ++i) {
    if (strncmp(rtype + i * 3, "CPZ", 3) == 0) {
        q__1 = cdiv(c_b43, z[i]);
        cinv.r = q__1.r, cinv.i = q__1.i;
        q__3.r = b * cinv.r, q__3.i = b * cinv.i;
            q__2 = cpowi(q__3, 2);
        d__1 = a * (float)4.;
        q__1.r = q__2.r - d__1, q__1.i = q__2.i;
        ctemp.r = q__1.r, ctemp.i = q__1.i;
        q__1 = csqrt1(ctemp);
        ctemp.r = q__1.r, ctemp.i = q__1.i;
        q__3.r = b * cinv.r, q__3.i = b * cinv.i;
        q__2.r = q__3.r + ctemp.r, q__2.i = q__3.i + ctemp.i;
        q__1.r = q__2.r * (float).5, q__1.i = q__2.i * (float).5;
        z1.r = q__1.r, z1.i = q__1.i;
        q__3.r = b * cinv.r, q__3.i = b * cinv.i;
        q__2.r = q__3.r - ctemp.r, q__2.i = q__3.i - ctemp.i;
        q__1.r = q__2.r * (float).5, q__1.i = q__2.i * (float).5;
        z2.r = q__1.r, z2.i = q__1.i;
        q__1 = cdiv(c_b43, p[i]);
        cinv.r = q__1.r, cinv.i = q__1.i;
        q__3.r = b * cinv.r, q__3.i = b * cinv.i;
            q__2 = cpowi(q__3, 2);
        d__1 = a * (float)4.;
        q__1.r = q__2.r - d__1, q__1.i = q__2.i;
        ctemp.r = q__1.r, ctemp.i = q__1.i;
        q__1 = csqrt1(ctemp);
        ctemp.r = q__1.r, ctemp.i = q__1.i;
        q__3.r = b * cinv.r, q__3.i = b * cinv.i;
        q__2.r = q__3.r + ctemp.r, q__2.i = q__3.i + ctemp.i;
        q__1.r = q__2.r * (float).5, q__1.i = q__2.i * (float).5;
        p1.r = q__1.r, p1.i = q__1.i;
        q__3.r = b * cinv.r, q__3.i = b * cinv.i;
        q__2.r = q__3.r - ctemp.r, q__2.i = q__3.i - ctemp.i;
        q__1.r = q__2.r * (float).5, q__1.i = q__2.i * (float).5;
        p2.r = q__1.r, p2.i = q__1.i;
        q__2 = conjg(z1);
        q__1.r = z1.r * q__2.r - z1.i * q__2.i, q__1.i = z1.r * q__2.i +
            z1.i * q__2.r;
        sn[iptr] = q__1.r;
        sn[iptr + 1] = z1.r * (float)-2.;
        sn[iptr + 2] = (float)1.;
        q__2 = conjg(p1);
        q__1.r = p1.r * q__2.r - p1.i * q__2.i, q__1.i = p1.r * q__2.i +
            p1.i * q__2.r;
        sd[iptr] = q__1.r;
        sd[iptr + 1] = p1.r * (float)-2.;
        sd[iptr + 2] = (float)1.;
        iptr += 3;
        q__2 = conjg(z2);
        q__1.r = z2.r * q__2.r - z2.i * q__2.i, q__1.i = z2.r * q__2.i +
            z2.i * q__2.r;
        sn[iptr] = q__1.r;
        sn[iptr + 1] = z2.r * (float)-2.;
        sn[iptr + 2] = (float)1.;
        q__2 = conjg(p2);
        q__1.r = p2.r * q__2.r - p2.i * q__2.i, q__1.i = p2.r * q__2.i +
            p2.i * q__2.r;
        sd[iptr] = q__1.r;
        sd[iptr + 1] = p2.r * (float)-2.;
        sd[iptr + 2] = (float)1.;
        iptr += 3;
        nsects += 2;
    } else if (strncmp(rtype + i * 3, "CP", 2) == 0) {
        q__1 = cdiv(c_b43, p[i]);
        cinv.r = q__1.r, cinv.i = q__1.i;
        q__3.r = b * cinv.r, q__3.i = b * cinv.i;
            q__2 = cpowi(q__3, 2);
        d__1 = a * (float)4.;
        q__1.r = q__2.r - d__1, q__1.i = q__2.i;
        ctemp.r = q__1.r, ctemp.i = q__1.i;
        q__1 = csqrt1(ctemp);
        ctemp.r = q__1.r, ctemp.i = q__1.i;
        q__3.r = b * cinv.r, q__3.i = b * cinv.i;
        q__2.r = q__3.r + ctemp.r, q__2.i = q__3.i + ctemp.i;
        q__1.r = q__2.r * (float).5, q__1.i = q__2.i * (float).5;
        p1.r = q__1.r, p1.i = q__1.i;
        q__3.r = b * cinv.r, q__3.i = b * cinv.i;
        q__2.r = q__3.r - ctemp.r, q__2.i = q__3.i - ctemp.i;
        q__1.r = q__2.r * (float).5, q__1.i = q__2.i * (float).5;
        p2.r = q__1.r, p2.i = q__1.i;
        sn[iptr] = a;
        sn[iptr + 1] = (float)0.;
        sn[iptr + 2] = (float)1.;
        q__2 = conjg(p1);
        q__1.r = p1.r * q__2.r - p1.i * q__2.i, q__1.i = p1.r * q__2.i +
            p1.i * q__2.r;
        sd[iptr] = q__1.r;
        sd[iptr + 1] = p1.r * (float)-2.;
        sd[iptr + 2] = (float)1.;
        iptr += 3;
        sn[iptr] = a;
        sn[iptr + 1] = (float)0.;
        sn[iptr + 2] = (float)1.;
        q__2 = conjg(p2);
        q__1.r = p2.r * q__2.r - p2.i * q__2.i, q__1.i = p2.r * q__2.i +
            p2.i * q__2.r;
        sd[iptr] = q__1.r;
        sd[iptr + 1] = p2.r * (float)-2.;
        sd[iptr + 2] = (float)1.;
        iptr += 3;
        nsects += 2;
    } else if (strncmp(rtype + i * 3, "SP", 2) == 0) {
        sn[iptr] = a;
        sn[iptr + 1] = (float)0.;
        sn[iptr + 2] = (float)1.;
        i__2 = i;
        sd[iptr] = -(double)a * p[i__2].r;
        sd[iptr + 1] = b;
        i__2 = i;
        sd[iptr + 2] = -(double)p[i__2].r;
        iptr += 3;
        ++(nsects);
    }
    }
/*  Scaling - use the fact that the bandreject filter amplitude  at d.c. */
/*            equals the lowpass prototype amplitude at d.c. */
    h = (float)1.;
    iptr = 1;
    i__1 = nsects;
    for (i = 1; i <= i__1; ++i) {
    h = h * sn[iptr] / sd[iptr];
    iptr += 3;
    }
    scale = *dcvalue / ABS(h);
    sn[1] *= scale;
    sn[2] *= scale;
    sn[3] *= scale;
    return TRUE;
}

/*  Subroutine to alter the cutoff of a filter.  Assumes that the */
/*    filter is structured as second order sections.  Changes */
/*    the cutoffs of normalized lowpass and highpass filters through */
/*    a simple polynomial transformation. */
/*  Input Arguments: */
/*  ---------------- */
/*    F                       New cutoff frequency */
/*  Input/Output Arguments: */
/*  ----------------------- */
/*    SN                      Numerator polynomials for second order */
/*                              sections. */
/*    SD                      Denominator polynomials for second order */
/*                              sections. */

static int cutoffs(sn, sd, f)
float *sn, *sd;
float *f;
{
    /* System generated locals */
    int i__1;

    /* Local variables */
    int iptr, i;
    float scale;

    /* Parameter adjustments */
    --sd;
    --sn;

    /* Function Body */
    scale = *f * (float)6.2831853000000004;

    iptr = 1;
    i__1 = nsects;
    for (i = 1; i <= i__1; ++i) {

    sn[iptr + 1] /= scale;
    sn[iptr + 2] /= scale * scale;
    sd[iptr + 1] /= scale;
    sd[iptr + 2] /= scale * scale;
    iptr += 3;
    }
    return TRUE;
}

/*  Subroutine to convert a lowpass filter to a highpass filter via */
/*    an analog polynomial transformation.  The lowpass filter is */
/*   described in terms of its poles and zeroes (as input to this routine).*/
/*    The output consists of the parameters for second order sections. */
/*  Input Arguments: */
/*  ---------------- */
/*    P                       Array containing poles */
/*    Z                       Array containing zeroes */
/*   RTYPE                   Character array containing root type information
*/
/*                              (SP) single real pole or */
/*                              (CP)  complex conjugate pair */
/*                              (CPZ) complex pole/zero pairs */
/*    DCVALUE                 Zero-frequency value of prototype filter */
/*  Output Arguments: */
/*  ----------------- */
/*    SN                      Numerator polynomials for second order */
/*                              sections. */
/*    SD                      Denominator polynomials for second order */
/*                              sections. */

static int lpthp(p, z, rtype, dcvalue, sn, sd)
complex *p, *z;
char *rtype;
float *dcvalue;
float *sn, *sd;
{
    /* System generated locals */
    int i__1, i__2, i__3;
    complex q__1, q__2, q__3, q__4;

   /* Local variables */
    int iptr, i;
    float scale;

    /* Parameter adjustments */
    --sd;
    --sn;
    rtype -= 3;
    --z;
    --p;

    /* Function Body */
    iptr = 1;
    i__1 = nsects;
    for (i = 1; i <= i__1; ++i) {
    if (strncmp(rtype + i * 3, "CPZ", 3) == 0) {
        i__2 = i;
        q__2 = conjg(p[i]);
        q__1.r = p[i__2].r * q__2.r - p[i__2].i * q__2.i, q__1.i = p[i__2]
            .r * q__2.i + p[i__2].i * q__2.r;
        i__3 = i;
        q__4 = conjg(z[i]);
        q__3.r = z[i__3].r * q__4.r - z[i__3].i * q__4.i, q__3.i = z[i__3]
            .r * q__4.i + z[i__3].i * q__4.r;
        scale = q__1.r / q__3.r;
        sn[iptr] = scale * (float)1.;
        i__2 = i;
        sn[iptr + 1] = z[i__2].r * (float)-2. * scale;
        i__2 = i;
        q__2 = conjg(z[i]);
        q__1.r = z[i__2].r * q__2.r - z[i__2].i * q__2.i, q__1.i = z[i__2]
            .r * q__2.i + z[i__2].i * q__2.r;
        sn[iptr + 2] = q__1.r * scale;
        sd[iptr] = (float)1.;
        i__2 = i;
        sd[iptr + 1] = p[i__2].r * (float)-2.;
        i__2 = i;
        q__2 = conjg(p[i]);
        q__1.r = p[i__2].r * q__2.r - p[i__2].i * q__2.i, q__1.i = p[i__2]
            .r * q__2.i + p[i__2].i * q__2.r;
        sd[iptr + 2] = q__1.r;
        iptr += 3;
    } else if (strncmp(rtype + i * 3, "CP", 2) == 0) {
        i__2 = i;
        q__2 = conjg(p[i]);
        q__1.r = p[i__2].r * q__2.r - p[i__2].i * q__2.i, q__1.i = p[i__2]
            .r * q__2.i + p[i__2].i * q__2.r;
        scale = q__1.r;
        sn[iptr] = (float)0.;
        sn[iptr + 1] = (float)0.;
        sn[iptr + 2] = scale;
        sd[iptr] = (float)1.;
        i__2 = i;
        sd[iptr + 1] = p[i__2].r * (float)-2.;
        i__2 = i;
        q__2 = conjg(p[i]);
        q__1.r = p[i__2].r * q__2.r - p[i__2].i * q__2.i, q__1.i = p[i__2]
            .r * q__2.i + p[i__2].i * q__2.r;
        sd[iptr + 2] = q__1.r;
        iptr += 3;
    } else if (strncmp(rtype + i * 3, "SP", 2) == 0) {
        i__2 = i;
        scale = -(double)p[i__2].r;
        sn[iptr] = (float)0.;
        sn[iptr + 1] = scale;
        sn[iptr + 2] = (float)0.;
        sd[iptr] = (float)1.;
        i__2 = i;
        sd[iptr + 1] = -(double)p[i__2].r;
        sd[iptr + 2] = (float)0.;
        iptr += 3;
    }
    }
    sn[1] *= *dcvalue;
    sn[2] *= *dcvalue;
    sn[3] *= *dcvalue;
    return TRUE;
}

/* Transforms an analog filter to a digital filter via the bilinear transforma
ti*/
/*   Assumes both are stored as second order sections.  The transformation is
*/
/*    done in-place. */
/*  Input Arguments: */
/*  ---------------- */
/*   SN                   Array containing numerator polynomial coefficients f
or*/
/*                           second order sections.  Packed head-to-tail. */
/*   SD                   Array containing denominator polynomial coefficients
 f*/
/*                           second order sections.  Packed head-to-tail. */

static int bilin2(sn, sd)
float *sn, *sd;
{
    /* System generated locals */
    int i__1;

    /* Local variables */
    int iptr, i;
    float scale, a0, a1, a2;

    /* Parameter adjustments */
    --sd;
    --sn;

    /* Function Body */
    iptr = 1;
    i__1 = nsects;
    for (i = 1; i <= i__1; ++i) {
    a0 = sd[iptr];
    a1 = sd[iptr + 1];
    a2 = sd[iptr + 2];
    scale = a2 + a1 + a0;
    sd[iptr] = (float)1.;
    sd[iptr + 1] = (a0 - a2) * (float)2. / scale;
    sd[iptr + 2] = (a2 - a1 + a0) / scale;
    a0 = sn[iptr];
    a1 = sn[iptr + 1];
    a2 = sn[iptr + 2];
    sn[iptr] = (a2 + a1 + a0) / scale;
    sn[iptr + 1] = (a0 - a2) * (float)2. / scale;
    sn[iptr + 2] = (a2 - a1 + a0) / scale;
    iptr += 3;
    }
    return TRUE;
}

/* WARP -- FUNCTION, APPLIES TANGENT FREQUENCY WARPING TO COMPENSATE */
/*         FOR BILINEAR ANALOG -> DIGITAL TRANSFORMATION */
/* ARGUMENTS: */
/* ---------- */
/*      F       ORIGINAL DESIGN FREQUENCY SPECIFICATION (HERTZ) */
/*      TS      SAMPLING INTERVAL (SECONDS) */
/*  LAST MODIFIED:  SEPTEMBER 20, 1990 */

static double warp(f, ts)
float *f, *ts;
{
    /* System generated locals */
    float ret_val;

    /* Local variables */
    float angle, twopi;

    twopi = (float)6.2831853;
    angle = twopi * *f * *ts / (float)2.;
    ret_val = tan(angle) * (float)2. / *ts;
    ret_val /= twopi;
    return ret_val;
}

/* BEROOTS -- SUBROUTINE TO RETURN BESSEL POLES FOR */
/*   NORMALIZED LOWPASS FILTER */
/* LAST MODIFIED:  SEPTEMBER 7, 1990 */
/*  OUTPUT ARGUMENTS: */
/*  ----------------- */
/*      P              COMPLEX ARRAY CONTAINING POLES */
/*                       CONTAINS ONLY ONE FROM EACH */
/*                       COMPLEX CONJUGATE PAIR, AND */
/*                       ALL REAL POLES */
/*      RTYPE          CHARACTER ARRAY INDICATING 2ND ORDER SECTION */
/*                       TYPE: */
/*                         (SP)  SINGLE REAL POLE */
/*                         (CP)  COMPLEX CONJUGATE POLE PAIR */
/*                         (CPZ) COMPLEX CONJUGATE POLE-ZERO PAIRS */
/*      DCVALUE        MAGNITUDE OF FILTER AT ZERO FREQUENCY */
/*  INPUT ARGUMENTS: */
/*  ---------------- */
/*      IORD           DESIRED FILTER ORDER */

static int beroots(p, rtype, dcvalue, iord)
complex *p;
char *rtype;
float *dcvalue;
int iord;
{
    /* Parameter adjustments */
    rtype -= 3;
    --p;

    /* Function Body */
    if (iord == 1) {
    p[1].r = (float)-1., p[1].i = (float)0.;
    strncpy(rtype + 3, "SP", 2);
    } else if (iord == 2) {
    p[1].r = (float)-1.1016013, p[1].i = (float).6360098;
    strncpy(rtype + 3, "CP", 2);
    } else if (iord == 3) {
    p[1].r = (float)-1.0474091, p[1].i = (float).9992645;
    strncpy(rtype + 3, "CP", 2);
    p[2].r = (float)-1.3226758, p[2].i = (float)0.;
    strncpy(rtype + 6, "SP", 2);
    } else if (iord == 4) {
    p[1].r = (float)-.9952088, p[1].i = (float)1.2571058;
    strncpy(rtype + 3, "CP", 2);
    p[2].r = (float)-1.3700679, p[2].i = (float).4102497;
    strncpy(rtype + 6, "CP", 2);
    } else if (iord == 5) {
    p[1].r = (float)-.9576766, p[1].i = (float)1.4711244;
    strncpy(rtype + 3, "CP", 2);
    p[2].r = (float)-1.3808774, p[2].i = (float).7179096;
    strncpy(rtype + 6, "CP", 2);
    p[3].r = (float)-1.502316, p[3].i = (float)0.;
    strncpy(rtype + 9, "SP", 2);
    } else if (iord == 6) {
    p[1].r = (float)-.9306565, p[1].i = (float)1.6618633;
    strncpy(rtype + 3, "CP", 2);
    p[2].r = (float)-1.3818581, p[2].i = (float).9714719;
    strncpy(rtype + 6, "CP", 2);
    p[3].r = (float)-1.5714904, p[3].i = (float).3208964;
    strncpy(rtype + 9, "CP", 2);
    } else if (iord == 7) {
    p[1].r = (float)-.9098678, p[1].i = (float)1.8364514;
    strncpy(rtype + 3, "CP", 2);
    p[2].r = (float)-1.3789032, p[2].i = (float)1.1915667;
    strncpy(rtype + 6, "CP", 2);
    p[3].r = (float)-1.6120388, p[3].i = (float).5892445;
    strncpy(rtype + 9, "CP", 2);
    p[4].r = (float)-1.6843682, p[4].i = (float)0.;
    strncpy(rtype + 12, "SP", 2);
    } else if (iord == 8) {
    p[1].r = (float)-.892871, p[1].i = (float)1.9983286;
    strncpy(rtype + 3, "CP", 2);
    p[2].r = (float)-1.3738431, p[2].i = (float)1.3883585;
    strncpy(rtype + 6, "CP", 2);
    p[3].r = (float)-1.6369417, p[3].i = (float).8227968;
    strncpy(rtype + 9, "CP", 2);
    p[4].r = (float)-1.7574108, p[4].i = (float).2728679;
    strncpy(rtype + 12, "CP", 2);
    }
    nsects = iord - iord / 2;
    *dcvalue = (float)1.;
    return TRUE;
}

static complex cmul(a,b)
complex a,b;
{
    complex c;
    c.r = a.r * b.r - a.i * b.i;
    c.i = a.i * b.r + a.r * b.i;
    return c;
}

static complex cpowi(a,n)
complex a;
int n;
{
    int i;
    complex c;
    c.i = 0.;
    c.r = 1.;
    for (i = 1; i <= n; ++i) {
    c = cmul(c, a);
    }
    return c;

}
static complex csqrt1(z)
complex z;
{   complex c;
    float x,y,w,r;
    if ((z.r == 0.0) && (z.i == 0.0)) {
        c.r=0.0;
        c.i=0.0;
        return c;
    } else {
        x=fabs(z.r);
        y=fabs(z.i);
        if (x >= y) {
            r=y/x;
            w=sqrt(x)*sqrt(0.5*(1.0+sqrt(1.0+r*r)));
        } else {
            r=x/y;
            w=sqrt(y)*sqrt(0.5*(r+sqrt(1.0+r*r)));
        }
        if (z.r >= 0.0) {
            c.r=w;
            c.i=z.i/(2.0*w);
        } else {
            c.i=(z.i >= 0) ? w : -w;
            c.r=z.i/(2.0*c.i);
        }
        return c;
    }
}

static complex conjg(z)
complex z;
{   complex c;
    c.r=z.r;
    c.i = -z.i;
    return c;
}

static complex cdiv(a,b)
complex a,b;
{   complex c;
    float r,den;
    if (fabs(b.r) >= fabs(b.i)) {
        r=b.i/b.r;
        den=b.r+r*b.i;
        c.r=(a.r+r*a.i)/den;
        c.i=(a.i-r*a.r)/den;
    } else {
        r=b.r/b.i;
        den=b.i+r*b.r;
        c.r=(a.r*r+a.i)/den;
        c.i=(a.i*r-a.r)/den;
    }
    return c;
}

SECTIM (MSECS,YR,DOY,MTH,DAY,HR,MIN,SEC)                      
double MSECS;
int *YR;
int *DOY;
int *MTH;
int *DAY;
int *HR;
int *MIN;
float *SEC;
{
int DDAY,MMTH;
//             -- Temporary seconds         
double SSEC;
//             -- Seconds per day           
double SECDAY;
//             -- Seconds per year          
double SECYR;
//              -- Leap-year indicators      
float  IND, SIN;
//              -- Counter                   
int    I;
SECDAY=86400.0;
SECYR =31536000.0;
//*-------------------------------------------------------------------------      
//*  Find year:                                                                   
//*                                                                               
SSEC = 0.0;
for(I=1;I<201;I++)
{
    IND = 0.0;
//               -- Leap year                 
    if ((I%4) == 0) IND = 1.0;
//               -- Add years                 
    SSEC = SSEC + SECYR + IND*SECDAY;
//               -- Year found                
    if (SSEC > MSECS) goto found;              
        SIN = IND;
}
found:                                                              
*YR = I - 1;
//*                                                                               
//*  Find day-of-year and date:                                                   
//*                                                                               
//c-- Reset remaining seconds   
SSEC = MSECS - (SSEC - SECYR - IND*SECDAY);

for(I=1;I<367;I++)
{
    SSEC = SSEC - SECDAY;
    if (SSEC < 0) goto incr;                                              
}
incr:

I = I - 1;
//           -- 366 days of year          
if (SIN > 0.0) I = I + 1;
//           --                           
if (I == 0)
{                           
//           -- Justifying if change      
    *YR = *YR - 1;
//           -- of year                   
    I  = 365;                                  
    if ((*YR%4) == 0) I = 366;
}


*DOY = I;
//-- convert from doy to date  
DTE (I,&DDAY,&MMTH,*YR);
*DAY=DDAY;
*MTH=MMTH;


if(*YR >= 100) *YR=*YR-100;            /* test for year 2000 or more        */





//*                                                                               
//*  Find hour:                                                                   
//*                                                                               
SSEC = SSEC + SECDAY;

for(I=1;I<25;I++)
{
    SSEC = SSEC - 60.0*60.0;
    if (SSEC < 0) goto seks;                                              
}
seks:
*HR = I - 1;
//*                                                                               
//*  Find minutes and remaining seconds:                                          
//*                                                                               
SSEC = SSEC + 60.0*60.0;
for(I=1;I<61;I++)
{
    SSEC = SSEC - 60.0;
    if (SSEC < 0) goto otte;
}
otte:                                              
   *MIN = I - 1;
   *SEC = SSEC + 60.0;
if(*YR < 50)
{
    *YR=*YR+2000;
}else{
    *YR=*YR+1900;
}
}











